package extcmd;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.nio.charset.Charset;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import java.util.Map.Entry;
import java.util.Properties;
import java.util.zip.ZipEntry;
import java.util.zip.ZipInputStream;

/**
 * ċNƃt@C̍XV
 * 
 * @author Takayuki Shoji
 */
public class Restart {

	/**
	 * ϐt@C
	 */
	private static final String ENV_PROP = "env.properties"; //$NON-NLS-1$

	/**
	 * evZXOɏo͂Ō̍s
	 */
	private static final String END_LINE = "[END]"; //$NON-NLS-1$

	/**
	 * UTF-8
	 */
	private static final Charset UTF8 = Charset.forName("UTF-8"); //$NON-NLS-1$

	/**
	 * s
	 */
	private static final byte[] NL = System
			.getProperty("line.separator").getBytes(UTF8); //$NON-NLS-1$

	/**
	 * R}h: ċN
	 */
	public static final String CMD_RESTART = "restart"; //$NON-NLS-1$

	/**
	 * R}h: XVEċN(ʏ팠)
	 */
	public static final String CMD_UPDATE = "update"; //$NON-NLS-1$

	/**
	 * R}h: ɂXV
	 */
	public static final String CMD_PRIVILEGE_UPDATE = "privilege_update"; //$NON-NLS-1$

	/**
	 * ()ϐ: ċNR}h̃L[̃vtBbNX
	 */
	public static final String RESTART = "_RESTART"; //$NON-NLS-1$

	/**
	 * (XV)ϐ: vZXNR}h̃L[̃vtBbNX
	 */
	public static final String PRIVILEGE = "_PRIVILEGE"; //$NON-NLS-1$

	/**
	 * (XV)ϐ: CXg[fBNg(ex. C:\Program Files\petaclone)
	 * 
	 * tH_̖OύXăobNAbvƂ邽߂ɎgB
	 * efBNg̓CXg[fBNgƂĎgB	
	 */
	public static final String INSTALL_DIR = "_INSTALL_DIR"; //$NON-NLS-1$

	/**
	 * (XV)ϐ: XVt@C
	 */
	public static final String NEW_FILE = "_NEW_FILE"; //$NON-NLS-1$

	/**
	 * (ċN)ϐ: ƃfBNg(ex. C:/Program Files/petaclone/)
	 */
	public static final String BASE_DIR = "_BASE_DIR"; //$NON-NLS-1$

	/**
	 * ()ϐ: IĎt@C
	 */
	public static final String WATCH_FILE = "_WATCH_FILE"; //$NON-NLS-1$

	/**
	 * ()ϐ: Ot@C
	 */
	public static final String LOG = "_LOG"; //$NON-NLS-1$

	/**
	 * (XV)ϐ: AvP[VtH_
	 */
	public static final String APP_FOLDER_NAME = "_APP_FOLDER_NAME"; //$NON-NLS-1$

	/**
	 * (XV)Vo[W̃t@C(WJς݂̃tH_)
	 */
	private File newVerFile;

	/**
	 * (XV)CXg[fBNg
	 */
	private File installDir;

	/**
	 * O
	 */
	private PrintStream out;

	/** date format for log */
	private static SimpleDateFormat dateFormat = new SimpleDateFormat(
			"yyyy/MM/dd HH:mm:ss.SSS"); //$NON-NLS-1$

	/**
	 * ϐgꍇtrue
	 */
	private static boolean environ = true;

	/**
	 * environfalsȅꍇɊϐ̑Ɏg
	 */
	private static Properties env;

	/**
	 * ϐ擾܂B
	 * @param name ϐ
	 * @return l
	 */
	private static String getenv(String name) {
		if (environ) {
			return System.getenv(name);
		}
		return env.getProperty(name);
	}

	/**
	 * @param args 
	 */
	public static void main(String[] args) {
		new Restart().execute(args);
	}

	/**
	 * @param args 
	 */
	private void execute(String[] args) {

		try {
			setupLog(args);

			String mode = args[0];
			if (mode.equals(CMD_RESTART)) {

				// I폜t@C܂ő҂
				waitForDelete();

				File dir = new File(getenv(BASE_DIR));
				restart(dir);

			} else if (mode.equals(CMD_UPDATE)) {

				// I폜t@C܂ő҂
				waitForDelete();

				update(true);

			} else if (mode.equals(CMD_PRIVILEGE_UPDATE)) {

				update(false);

			}
		} catch (Exception e) {
			log("Failed.", e); //$NON-NLS-1$

		} finally {
			log(END_LINE, null);
			if (out != null && out != System.out) {
				out.close();
			}
		}
	}

	/**
	 * Ȍs܂B
	 * @param args R}hC
	 * @throws IOException 
	 */
	private void setupLog(String[] args) throws IOException {

		File log = null;
		if (args.length > 0 && args[0].equals(CMD_PRIVILEGE_UPDATE)) {

			// env.properties ǂݍŊϐ𕜌
			try {
				env = loadEnvironment();
				environ = false;

				String path = getenv(LOG) + '.' + CMD_PRIVILEGE_UPDATE;
				log = new File(path);
				FileOutputStream fout = new FileOutputStream(log, false);
				out = new PrintStream(fout, true);

			} catch (IOException e) {
				e.printStackTrace();
				out = System.out;
			}
			//STDOUT
			//out = System.out;

		} else {
			String path = getenv(LOG);
			if (path == null || path.length() == 0) {
				log = File.createTempFile("Restart", ".log"); //$NON-NLS-1$ //$NON-NLS-2$

			} else {
				log = new File(path);

			}
			FileOutputStream fout = new FileOutputStream(log, false);
			out = new PrintStream(fout, true);
		}

		// R}hC
		for (int i = 0; i < args.length; i++) {
			log("args[" + i + "]=" + args[i], null); //$NON-NLS-1$ //$NON-NLS-2$
		}

		// ϐ
		logEnvironment(LOG);
		logEnvironment(WATCH_FILE);
		logEnvironment(BASE_DIR);
		logEnvironment(NEW_FILE);
		logEnvironment(INSTALL_DIR);
		logEnvironmentArray(RESTART);
		logEnvironmentArray(PRIVILEGE);
	}

	/**
	 * AԂtϐz擾܂B
	 * @param prefix vtBbNX
	 * @return z
	 */
	private static String[] getStringArray(String prefix) {
		List list = new ArrayList();
		for (int i = 0;; i++) {
			String value = getenv(prefix + i);
			if (value != null) {
				list.add(value);
			} else {
				break;
			}
		}
		return (String[]) list.toArray(new String[list.size()]);
	}

	/**
	 * ċN
	 * @param workDir ƃtH_
	 */
	private void restart(File workDir) {
		String[] restart = getStringArray(RESTART);
		// N
		try {
			Runtime.getRuntime().exec(restart, null, workDir);
			// vZXc邽 Process#waitFor() ͕sv
		} catch (IOException e) {
			log("Failed to execute.", e); //$NON-NLS-1$
		}
	}

	/**
	 * I폜t@C܂ő҂
	 */
	private void waitForDelete() {
		File watchFile = new File(getenv(WATCH_FILE));
		for (int i = 0; i < 300; i++) {
			if (watchFile.exists()) {
				try {
					Thread.sleep(1000);
				} catch (InterruptedException e) {
					log("Interrupted.", e); //$NON-NLS-1$
				}
				continue;
			}
			break;
		}
	}

	/**
	 * ̊mFƃobNAbv̍쐬
	 * @param installDir petaclonetH_
	 * @param backupDir petaclone_bktH_
	 * @return : true, s: false
	 */
	private boolean hasPrivilegeAndBackup(File installDir, File backupDir) {
		try {
			File testDir = new File(installDir.getParentFile(),
					installDir.getName() + "_priv_chk"); //$NON-NLS-1$
			if (testDir.exists()) {
				log("Test dir is already existing:" + testDir.getAbsolutePath(), //$NON-NLS-1$
				null);
				if (!testDir.delete()) {
					log("Failed to delete: " + testDir.getAbsolutePath(), null); //$NON-NLS-1$
					return false;
				}
			}
			if (testDir.mkdir()) {
				if (!testDir.delete()) {
					log("mkdir=OK, delete=fail: " + testDir.getAbsolutePath(), //$NON-NLS-1$
							null);
					return false;
				}
			} else {
				log("mkdir=fail: " + testDir.getAbsolutePath(), null); //$NON-NLS-1$
				return false;
			}

			// obNAbv폜
			deleteDirectory(backupDir);

			// ̃tH_obNAbv
			if (!installDir.renameTo(backupDir)) {
				log("Failed to rename: from=" + installDir.getAbsolutePath() //$NON-NLS-1$
						+ ", to=" + backupDir.getAbsolutePath(), null); //$NON-NLS-1$
				return false;
			}

			return true;

		} catch (IOException e) {
			log("Failed to delete backup:" + backupDir.getAbsolutePath(), null); //$NON-NLS-1$
			return false;
		}
	}

	/**
	 * XV
	 * @param restart ċNꍇ(ʏ팠)true
	 * @throws IOException 
	 * @throws InterruptedException 
	 */
	private void update(boolean restart) throws IOException,
			InterruptedException {
		newVerFile = new File(getenv(NEW_FILE));
		installDir = new File(getenv(INSTALL_DIR));

		if (!newVerFile.isFile()) {
			log("New version file not found:" + newVerFile.getAbsolutePath(), null); //$NON-NLS-1$
			return;
		}

		if (!installDir.isDirectory()) {
			log("Install directory not found:" + installDir.getAbsolutePath(), null); //$NON-NLS-1$
			return;
		}
		File backupDir = new File(installDir.getParentFile(),
				installDir.getName() + "_bk"); //$NON-NLS-1$

		try {
			if (hasPrivilegeAndBackup(installDir, backupDir)) {
				try {
					// kt@CWJ
					expandArchive();
				} catch (IOException e) {
					log("Failed to expand archive: " + newVerFile.getAbsolutePath(), e); //$NON-NLS-1$
					// obNAbv߂
					deleteDirectory(installDir);
					if (!backupDir.renameTo(installDir)) {
						throw new IOException(
								"Failed to restore from backup.", e); //$NON-NLS-1$
					}
					throw e;
				}
			} else if (restart) {
				// ʏ팠Ŏs  vZXNđҋ@

				// Ďt@C쐬
				File watchFile = new File(getenv(WATCH_FILE));
				if (!watchFile.createNewFile()) {
					log("Failed to create watch file:" + getenv(WATCH_FILE), null); //$NON-NLS-1$
					return;
				}
				// ϐp̂߂Propertiest@Cɕۑ
				saveEnvironment();
				// vZXNďI҂
				String[] cmd = getStringArray(PRIVILEGE);
				try {
					Process p = Runtime.getRuntime().exec(cmd);
					p.waitFor();

					// vZXɂ폜҂
					waitForDelete();

				} catch (IOException e) {
					log("Failed to execute privileged process.", e); //$NON-NLS-1$
				}

			} else {
				// s
				log("Failed to backup, not authorized.", null); //$NON-NLS-1$
			}
		} finally {
			if (restart) {
				File workDir = new File(installDir.getParentFile(),
						getenv(APP_FOLDER_NAME));
				restart(workDir);
			} else {
				// : t@C폜
				File watchFile = new File(getenv(WATCH_FILE));
				if (watchFile.exists()) {
					if (!watchFile.delete()) {
						log("Failed to delete watch file:" + getenv(WATCH_FILE), null); //$NON-NLS-1$
					} else {
						log("deleted:" + getenv(WATCH_FILE), null); //$NON-NLS-1$
					}
				}
			}
		}
	}

	/**
	 * ϐt@Cɕۑ܂B
	 * @throws FileNotFoundException
	 * @throws IOException
	 */
	private void saveEnvironment() throws FileNotFoundException, IOException {
		Properties env = new Properties();
		Iterator itr = System.getenv().entrySet().iterator();
		while (itr.hasNext()) {
			Entry entry = (Entry) itr.next();
			env.setProperty((String) entry.getKey(), (String) entry.getValue());
		}
		FileOutputStream fo = new FileOutputStream(ENV_PROP);
		try {
			env.store(fo, null);
		} finally {
			fo.close();
		}
	}

	/**
	 * ϐ[h܂B
	 * @return Properties
	 * @throws FileNotFoundException
	 * @throws IOException
	 */
	private static Properties loadEnvironment() throws IOException {
		Properties prop = new Properties();
		FileInputStream in = new FileInputStream(ENV_PROP);
		try {
			prop.load(in);
		} finally {
			in.close();
		}
		return prop;
	}

	/**
	 * XVpA[JCuWJ܂B
	 * @throws IOException
	 * @throws InterruptedException
	 */
	private void expandArchive() throws IOException, InterruptedException {

		File programsDir = installDir.getParentFile();

		if (newVerFile.getName().endsWith(".tgz")) { //$NON-NLS-1$

			String[] cmdarray = new String[] { "tar", "zxf", //$NON-NLS-1$ //$NON-NLS-2$
					newVerFile.getAbsolutePath() };
			Process p = Runtime.getRuntime().exec(cmdarray, null, programsDir);
			p.waitFor();

		} else if (newVerFile.getName().endsWith(".dmg")) { //$NON-NLS-1$

			String appName = getenv(APP_FOLDER_NAME);

			log("Attach DMG", null); //$NON-NLS-1$
			String[] cmdarray = new String[] { "hdiutil", "attach", //$NON-NLS-1$ //$NON-NLS-2$
					newVerFile.getAbsolutePath() };
			Process p = Runtime.getRuntime().exec(cmdarray, null, programsDir);
			p.waitFor();

			log("Copy DMG content", null); //$NON-NLS-1$
			cmdarray = new String[] { "cp", "-R", "/Volumes/" + appName, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
					programsDir.getAbsolutePath() };
			p = Runtime.getRuntime().exec(cmdarray, null, programsDir);
			p.waitFor();

			log("Remove trash if exists", null); //$NON-NLS-1$
			cmdarray = new String[] {
					"rm", "-R", //$NON-NLS-1$ //$NON-NLS-2$
					new File(programsDir, appName + "/.Trashes").getAbsolutePath() }; //$NON-NLS-1$
			p = Runtime.getRuntime().exec(cmdarray, null, programsDir);
			p.waitFor();

			log("Detach DMG", null); //$NON-NLS-1$
			cmdarray = new String[] {
					"hdiutil", "detach", "/Volumes/" + appName }; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			p = Runtime.getRuntime().exec(cmdarray, null, programsDir);
			p.waitFor();

		} else if (newVerFile.getName().endsWith(".zip")) { //$NON-NLS-1$
			FileInputStream fin = null;
			ZipInputStream in = null;
			try {
				fin = new FileInputStream(newVerFile);
				in = new ZipInputStream(fin);

				ZipEntry entry = null;
				while ((entry = in.getNextEntry()) != null) {
					log(entry.getName(), null);
					if (entry.isDirectory()) {
						File d = new File(programsDir, entry.getName());
						if (d.mkdirs()) {
							d.setLastModified(entry.getTime());
						} else {
							log("Could not make dirs:", null); //$NON-NLS-1$
						}
					} else {
						String relativePath = entry.getName();
						File outFile = new File(programsDir, relativePath);

						// o͐̃fBNg쐬
						File parentFile = outFile.getParentFile();
						parentFile.mkdirs();

						// t@Co͂
						FileOutputStream out = null;
						try {
							out = new FileOutputStream(outFile);

							byte[] buf = new byte[256];
							int size = 0;
							while ((size = in.read(buf)) >= 0) {
								if (size > 0) {
									out.write(buf, 0, size);
								}
							}
						} finally {
							if (out != null) {
								out.close();
							}
						}
						outFile.setLastModified(entry.getTime());
					}

					in.closeEntry();
				}

			} finally {
				if (in != null) {
					in.close();
				} else if (fin != null) {
					fin.close();
				}
			}
		} else {
			throw new IOException("Unsupported archive:" //$NON-NLS-1$
					+ newVerFile.getAbsolutePath());
		}
	}

	/**
	 * Gg[ċAIɍ폜܂B
	 * @param entry t@CEfBNg
	 * @throws IOException 
	 */
	static void deleteDirectory(File entry) throws IOException {
		if (!entry.exists()) {
			return;
		}
		if (entry.isFile()) {
			if (!entry.delete()) {
				throw new IOException("Could not delete file: " //$NON-NLS-1$
						+ entry.getAbsolutePath());
			}
		} else if (entry.isDirectory()) {
			File[] entries = entry.listFiles();
			for (int i = 0; i < entries.length; i++) {
				deleteDirectory(entries[i]);
			}
			if (!entry.delete()) {
				throw new IOException("Could not delete directory: " //$NON-NLS-1$
						+ entry.getAbsolutePath());
			}
		}
	}

	/**
	 * OL^܂B
	 * @param msg ObZ[W
	 * @param th O
	 */
	void log(String msg, Throwable th) {
		if (out == null) {
			out = System.out;
		}
		try {
			out.write(dateFormat.format(new Date()).getBytes(UTF8));
			out.write(' ');
			out.write(msg.getBytes(UTF8));
			out.write(NL);
			if (th != null) {
				th.printStackTrace(out);
			}
			out.flush();

		} catch (IOException ex) {
			ex.printStackTrace();
		}
	}

	/**
	 * ϐOt@Cɏo͂܂B
	 * @param envname ϐ
	 */
	private void logEnvironmentArray(String envname) {
		for (int i = 0;; i++) {
			if (getenv(envname + i) != null) {
				logEnvironment(envname + i);
			} else {
				break;
			}
		}
	}

	/**
	 * ϐOt@Cɏo͂܂B
	 * @param envname ϐ
	 */
	private void logEnvironment(String envname) {
		log(envname + '=' + getenv(envname), null);
	}

}
