package jp.takayuki.swt.dnd;

import java.io.ByteArrayInputStream;

import jp.takayuki.graphics.DibImage;

import org.eclipse.swt.dnd.ByteArrayTransfer;
import org.eclipse.swt.dnd.TransferData;
import org.eclipse.swt.graphics.ImageData;

/**
 * <p>CF_DIB^̃f[^DibImage(BMP)ɕϊ܂B</p>
 * 
 * @author Takayuki Shoji
 */
public class DibTransfer extends ByteArrayTransfer {
	/** Nbv{[hBMP̃^Cv */
	private static final String[] TYPENAMES = { "CF_DIB" }; //$NON-NLS-1$

	/** BMPTYPEID */
	private static final int[] TYPEIDS = { 8 };

	/** B̃CX^X */
	private static DibTransfer _instance = new DibTransfer();

	/**
	 * RXgN^
	 */
	private DibTransfer() {
		//
	}

	/**
	 * CX^XԂ܂B
	 * @return CX^X
	 */
	public static DibTransfer getInstance() {
		return _instance;
	}

	protected int[] getTypeIds() {
		return TYPEIDS;
	}

	protected String[] getTypeNames() {
		return TYPENAMES;
	}

	/**
	 * lCeBuf[^DibImageIuWFNgɕϊ܂B
	 * 
	 * @param transferData ]ꂽf[^
	 * @return DibImageIuWFNg
	 */
	protected Object nativeToJava(TransferData transferData) {
		if (!isSupportedType(transferData)) {
			return null;
		}

		byte[] buffer = (byte[]) super.nativeToJava(transferData);
		if (buffer != null) {
			return new DibImage(buffer);
		}
		return null;
	}

	/**
	 * DibImage  ImageData ɕϊ܂B
	 * @param dib DibImage
	 * @return ImageData
	 */
	public static ImageData convertDibToImageData(DibImage dib) {
		ByteArrayInputStream is = new ByteArrayInputStream(dib.getBytes(false));
		return new ImageData(is);
	}
}