package jp.takayuki.swt.undo;

import java.util.Iterator;
import java.util.LinkedList;

/**
 * ҏWǗNXłB
 * 
 * @author Takayuki Shoji
 */
public class UndoStack {

	/**
	 * EBWFbgɐݒ肳UndoStack̃L[
	 */
	public static final String KEY_UNDO_STACK = "undo_stack"; //$NON-NLS-1$

	/**
	 * UndoΏۂ̃R}ḧʒu
	 */
	private int position;

	/**
	 * UndoCommand̃X^bN
	 */
	private LinkedList stack = new LinkedList();

	/**
	 * Undo/Redȏ쒆true
	 */
	public boolean underOperation;

	/** Undo̍ő */
	public int max = 20;

	/**
	 * @return Undo\ȏꍇtrue
	 */
	public boolean canUndo() {
		return position < stack.size();
	}

	/**
	 * Undô߂̃R}h擾܂A
	 * @return R}h
	 */
	public TextUndoCommand getUndo() {
		if (!canUndo()) {
			return null;
		}
		TextUndoCommand undo = (TextUndoCommand) stack.get(position);
		undo.mergeable = false;
		position++;
		return undo;
	}

	/**
	 * @return Redo\ȏꍇtrue
	 */
	public boolean canRedo() {
		return 0 < position;
	}

	/**
	 * Redô߂̃R}h擾܂A
	 * @return R}h
	 */
	public TextUndoCommand getRedo() {
		if (!canRedo()) {
			return null;
		}
		position--;
		return (TextUndoCommand) stack.get(position);
	}

	/**
	 * X^bNNA܂B
	 */
	public void clear() {
		stack = new LinkedList();
		position = 0;
		underOperation = false;
	}

	/**
	 * ҏWɃR}hǉ܂B
	 * @param undo R}h
	 * @param independent }[WȂꍇtrue
	 */
	public void push(TextUndoCommand undo, boolean independent) {
		if (underOperation) {
			return;
		}
		if (position > 0) {
			for (int i = 0; i < position; i++) {
				stack.removeFirst();
			}
			position = 0;
		}
		// }[W
		if (!independent) {
			TextUndoCommand prev = peek();
			if (prev != null && prev.merge(undo)) {
				return;
			}
		}

		if (stack.size() >= max) {
			stack.removeLast();
		}
		stack.addFirst(undo);
	}

	/**
	 * ÕR}h擾܂B
	 * @return R}h܂null
	 */
	public TextUndoCommand peek() {
		if (stack.isEmpty()) {
			return null;
		}
		return (TextUndoCommand) stack.getFirst();
	}

	/**
	 * peek()UndoR}h}[Wsɐݒ肵܂B
	 */
	public void setUnmergeable() {
		TextUndoCommand undo = peek();
		if (undo != null) {
			undo.mergeable = false;
		}
	}

	/**
	 * ߂UndoR}hɃX^Cǉ܂B
	 * @param obj 
	 * @param setUnmergeable truȅꍇAmergeablefalseɐݒ肵܂B
	 */
	public void addInsertedObjectToLast(Object obj, boolean setUnmergeable) {
		TextUndoCommand undo = peek();
		if (undo != null) {
			undo.addInsertedObject(obj);
			if (setUnmergeable) {
				undo.mergeable = false;
			}
		}
	}

	/**
	 * ߂UndoR}hɃX^Cǉ܂B
	 * @param obj 
	 * @param setUnmergeable truȅꍇAmergeablefalseɐݒ肵܂B
	 */
	public void addReplacedObjectToLast(Object obj, boolean setUnmergeable) {
		TextUndoCommand undo = peek();
		if (undo != null) {
			undo.addReplacedObject(obj);
			if (setUnmergeable) {
				undo.mergeable = false;
			}
		}
	}

	public String toString() {
		StringBuffer sb = new StringBuffer("UndoStack{"); //$NON-NLS-1$
		sb.append("position=").append(position); //$NON-NLS-1$
		sb.append(", underOperation=").append(underOperation); //$NON-NLS-1$
		sb.append(", max=").append(max); //$NON-NLS-1$
		sb.append(", stack={"); //$NON-NLS-1$
		Iterator itr = stack.iterator();
		while (itr.hasNext()) {
			TextUndoCommand undo = (TextUndoCommand) itr.next();
			sb.append(undo).append(',');
		}
		sb.append('}');
		sb.append('}');
		return sb.toString();
	}
}