package jp.takayuki.swt.util;

import java.util.List;

import jp.takayuki.tools.Os;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.Shell;

/**
 * j[Ɋւ郆[eBeB\bhWB
 * 
 * @author Takayuki Shoji
 */
public class SWTMenuUtils {

	/**
	 * ؂ǉ܂B
	 * 
	 * @param parent j[
	 */
	public static void addSeparator(Menu parent) {
		new MenuItem(parent, SWT.SEPARATOR);
	}

	/**
	 * ShellɃj[o[ǉ܂B
	 * 
	 * @param shell ΏۂShell
	 * @return Menu
	 */
	public static Menu addMenuBar(Shell shell) {
		Menu menuBar = new Menu(shell, SWT.BAR);
		shell.setMenuBar(menuBar);
		return menuBar;
	}

	/**
	 * Tuj[ǉ܂B
	 * 
	 * @param parent ẽj[
	 * @param text ACẽeLXg
	 * @return Menu
	 */
	public static Menu addCascade(Menu parent, String text) {
		MenuItem menuBarFile = new MenuItem(parent, SWT.CASCADE);
		menuBarFile.setText(text);

		Menu menuFile = new Menu(menuBarFile);
		menuBarFile.setMenu(menuFile);
		return menuFile;
	}

	/**
	 * MenuItemǉ܂B
	 * 
	 * @param parent ẽj[
	 * @param text \eLXg
	 * @param keyLabel V[gJbgL[̕\p\LB\Ȃꍇnullw肷B
	 * @param shortcut V[gJbg
	 * @param icon ACR
	 * @param listener CxgXi[
	 * @return MenuItem
	 */
	public static MenuItem addMenuItem(Menu parent, String text,
			String keyLabel, int shortcut, Image icon,
			SelectionListener listener) {
		return addMenuItem(parent, text, keyLabel, shortcut, icon, listener,
				null);
	}

	/**
	 * MenuItemǉ܂B
	 * 
	 * @param parent ẽj[
	 * @param text \eLXg
	 * @param keyLabel V[gJbgL[̕\p\LB\Ȃꍇnullw肷B
	 * @param shortcut V[gJbg
	 * @param icon ACR
	 * @param listener CxgXi[
	 * @param methodName listener̃\bh
	 * @return MenuItem
	 */
	public static MenuItem addMenuItem(Menu parent, String text,
			String keyLabel, int shortcut, Image icon,
			SelectionListener listener, String methodName) {
		return create(parent, SWT.PUSH, text, keyLabel, shortcut, icon,
				listener, methodName, true);
	}

	/**
	 * MenuItemǉ܂B
	 * 
	 * @param parent ẽj[
	 * @param text \eLXg
	 * @param keyLabel V[gJbgL[̕\p\LB\Ȃꍇnullw肷B
	 * @param shortcut V[gJbg
	 * @param icon ACR
	 * @param listener CxgXi[
	 * @param methodName listener̃\bh
	 * @param showKeyLabel keyLabel\ꍇtrueB^XNgCj[ŎgpB
	 * @return MenuItem
	 */
	public static MenuItem addMenuItem(Menu parent, String text,
			String keyLabel, int shortcut, Image icon,
			SelectionListener listener, String methodName, boolean showKeyLabel) {
		return create(parent, SWT.PUSH, text, keyLabel, shortcut, icon,
				listener, methodName, showKeyLabel);
	}

	/**
	 * `FbN{bNXMenuItemǉ܂B
	 * 
	 * @param parent ẽj[
	 * @param text \eLXg
	 * @param keyLabel V[gJbgL[̕\p\LB\Ȃꍇnullw肷B
	 * @param shortcut V[gJbg
	 * @param icon ACR
	 * @param listener CxgXi[
	 * @param methodName listener̃\bh
	 * @param checked `FbN̏l
	 * @return MenuItem
	 */
	public static MenuItem addMenuItemCheckbox(Menu parent, String text,
			String keyLabel, int shortcut, Image icon,
			SelectionListener listener, String methodName, boolean checked) {

		MenuItem item = create(parent, SWT.CHECK, text, keyLabel, shortcut,
				icon, listener, methodName, true);
		item.setSelection(checked);
		return item;
	}

	/**
	 * WI{^MenuItemǉ܂B
	 * 
	 * @param parent ẽj[
	 * @param text \eLXg
	 * @param keyLabel V[gJbgL[̕\p\LB\Ȃꍇnullw肷B
	 * @param shortcut V[gJbg
	 * @param icon ACR
	 * @param listener CxgXi[
	 * @param methodName listener̃\bh
	 * @param selected Ȉl
	 * @return MenuItem
	 */
	public static MenuItem addMenuItemRadio(Menu parent, String text,
			String keyLabel, int shortcut, Image icon,
			SelectionListener listener, String methodName, boolean selected) {

		MenuItem item = create(parent, SWT.RADIO, text, keyLabel, shortcut,
				icon, listener, methodName, true);
		item.setSelection(selected);
		if (selected)
			item.setEnabled(false);
		return item;
	}

	/**
	 * MenuItem𐶐܂B
	 * 
	 * @param parent ẽj[
	 * @param style MenuItem̃X^C
	 * @param text \eLXg
	 * @param keyLabel V[gJbgL[̕\p\LB\Ȃꍇnullw肷B
	 * @param shortcut V[gJbgBw肵Ȃꍇ0w肷BPOP_UPX^C̏ꍇ͖܂B
	 * @param icon ACR
	 * @param listener CxgXi[
	 * @param methodName listener̃\bh
	 * @param showKeyLabel keyLabel\ꍇtrueB^XNgCj[ŎgpB
	 * @return MenuItem
	 */
	private static MenuItem create(Menu parent, int style, String text,
			String keyLabel, int shortcut, Image icon,
			SelectionListener listener, String methodName, boolean showKeyLabel) {
		MenuItem item = new MenuItem(parent, style);
		if (keyLabel == null || !showKeyLabel) {
			item.setText(text);
		} else {
			item.setText(text + "\t" + keyLabel); //$NON-NLS-1$
		}
		if (shortcut != 0
				&& ((parent.getStyle() & SWT.POP_UP) == 0 || Os.isMacOSX()))
			item.setAccelerator(shortcut);
		if (icon != null)
			item.setImage(icon);
		if (listener != null) {
			item.addSelectionListener(listener);
			if (methodName != null && (listener instanceof ListenerDelegate)) {
				ListenerDelegate delegate = (ListenerDelegate) listener;
				delegate.register(item, methodName);
			}
		}
		return item;
	}

	/**
	 * MenuItemenabledݒ肵܂B
	 * 
	 * @param menuItems MenuItem̃Xg
	 * @param enabled I\ɂɂtrue
	 */
	public static void setEnabled(List menuItems, boolean enabled) {
		if (menuItems == null) {
			return;
		}
		for (int i = 0; i < menuItems.size(); i++) {
			MenuItem item = (MenuItem) menuItems.get(i);
			item.setEnabled(enabled);
		}
	}
}
