package jp.takayuki.swt.widgets;

import java.text.DecimalFormat;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;

/**
 * JEg_E\郉x
 * @author Takayuki Shoji
 */
public class CountdownLabel extends Composite implements Runnable, Listener {

	/** x */
	private final Label label;

	/** JEg_E0ɂȂ鎞 */
	private long targetTime;

	/** Display */
	private Display display;

	/** ~tO */
	private boolean stop = true;

	/** tH[}b^ */
	private DecimalFormat format = new DecimalFormat("00"); //$NON-NLS-1$

	/** tHg */
	private Font font;

	/** JEg_EXi[ */
	private SelectionListener listener;

	/**
	 * RXgN^
	 * @param parent eEBWFbg
	 * @param style x̃X^C
	 */
	public CountdownLabel(Composite parent, int style) {
		super(parent, SWT.NONE);
		display = parent.getDisplay();
		setLayout(new FillLayout());
		label = new Label(this, style);
		label.setText("00:00"); //$NON-NLS-1$
	}

	/**
	 * x̃tHgݒ肵܂B
	 * @param font x̃tHg
	 * @param dispose tHg̔jōs
	 */
	public void setLabelFont(Font font, boolean dispose) {
		this.font = font;
		label.setFont(font);
		if (dispose)
			label.addListener(SWT.Dispose, this);
	}

	public void handleEvent(Event event) {
		switch (event.type) {
		case SWT.Dispose:
			if (font != null) {
				font.dispose();
			}
			break;
		}
	}

	/**
	 * JEg_E0ɂȂ鎞ݒ肵܂B
	 * @param targetTime JEg_E0ɂȂ鎞
	 */
	public void setTargetTime(long targetTime) {
		this.targetTime = targetTime;
	}

	/**
	 * JEg_E̕\Jn܂B
	 */
	public void start() {
		if (!stop) {
			return;
		}
		stop = false;
		display.syncExec(this);
	}

	/**
	 * \~܂(JEg_E͎~܂܂)B
	 */
	public void stop() {
		stop = true;
	}

	public void run() {
		if (stop || display.isDisposed() || label.isDisposed()) {
			return;
		}
		long remain = targetTime - System.currentTimeMillis();
		label.setText(format(remain));
		this.layout();
		int next = (int) (remain % 1000);

		if (remain <= 0) {
			if (listener != null) {
				Event event = new Event();
				event.widget = this;
				SelectionEvent ev = new SelectionEvent(event);
				ev.display = getDisplay();
				listener.widgetSelected(ev);
			}
		} else {
			display.timerExec(next, this);
		}
	}

	/**
	 * c莞Ԃ𕶎񉻂܂B
	 * @param time c莞
	 * @return tH[}bgςݕ
	 */
	private String format(long time) {
		long min = time / (60 * 1000);
		long sec = (time % (60 * 1000)) / 1000;
		return format.format(min) + ':' + format.format(sec);
	}

	/**
	 * c莞Ԃ0ɂȂƂɌĂяo郊Xi[ݒ肵܂B
	 * @param listener Xi[
	 */
	public void setCountdownListener(SelectionListener listener) {
		this.listener = listener;
	}
}
