package jp.takayuki.swt.widgets;

import java.util.Iterator;
import java.util.Vector;

import jp.takayuki.logging.Logger;
import jp.takayuki.swt.util.CocoaMenuDetectSuppressor;

import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.events.ControlAdapter;
import org.eclipse.swt.events.ControlEvent;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.KeyAdapter;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseListener;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.events.TraverseEvent;
import org.eclipse.swt.events.TraverseListener;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.ScrollBar;

/**
 * Mac OS ClassicFindeȑACR\̂悤ȃACR
 * {^^̃ACRJX^EBWFbgB
 * TODO ACRt{^͕WEBWFbgg
 * @author Takayuki Shoji
 */
public class LabeledIconTray extends Composite {
	/** fobOtO */
	static final boolean DEBUG = false;
	/**
	 * logger
	 */
	private static final Logger logger = Logger
			.getLogger(LabeledIconTray.class);
	/**
	 * ScrolledComposite
	 */
	ScrolledComposite sc;
	/**
	 * ScrolledComposite̓e
	 */
	Composite content;
	/**
	 * ACẽRNV<br>
	 * l: LabeledIconItem
	 */
	private Vector items = new Vector();
	/**
	 * tH[JXĂACe̔ԍ
	 */
	private LabeledIconItem focus = null;
	/**
	 * ͈͑I̋N_
	 */
	private LabeledIconItem startingPoint = null;
	/**
	 * {^SelectionXi[<br>
	 * l: SelectionListener
	 */
	private Vector buttonSelectionListeners = new Vector();
	/**
	 * ACRSelectionXi[<br>
	 * l: SelectionListener
	 */
	private Vector iconSelectionListeners = new Vector();
	/**
	 * ACR̃}EXXi[<br>
	 * l: MouseListener
	 */
	private Vector iconMouseListeners = new Vector();
	/**
	 * ACROpenXi[<br>
	 * ACRIă_uNbNEnterL[Open<br>
	 * l: SelectionListener
	 */
	private Vector iconOpenListeners = new Vector();
	/**
	 * mouseUpCxgőIm肳Ȃtrue<br>
	 * łɑIꂽACemouseDownƂɃZbgB
	 * hbÔ߂mouseUpőI𑀍(̃ACȇI)m肳B
	 */
	private boolean delayedSelectionMode;
	/**
	 * ăCAEg}Ȃtrue
	 */
	private boolean suppressLayout;

	/**
	 * ACep̃j[
	 */
	private Menu itemMenu;

	/**
	 * RXgN^
	 * @param parent eEBWFbg
	 * @param style ScrolledCompositestyleƓ
	 */
	public LabeledIconTray(Composite parent, int style) {
		// OComposite
		super(parent, SWT.NONE);
		this.setLayout(new FillLayout());
		// dispose
		addDisposeListener(new DisposeListener() {
			public void widgetDisposed(DisposeEvent event) {
				setSuppressLayout(true);
				if (itemMenu != null) {
					itemMenu.dispose();
					itemMenu = null;
				}
			}
		});

		// XN[Composite
		// SWT.V_SCROLL | SWT.BORDER
		sc = new ScrolledComposite(this, style);

		// XN[o[̒(Ƃ肠Œ)
		// WISHLIST XN[o[̈ړʂ̎
		ScrollBar bar = sc.getVerticalBar();
		bar.setIncrement(8);
		bar.setPageIncrement(32);

		sc.setExpandHorizontal(true);
		sc.setExpandVertical(true);
		// ACezuComposite
		content = new Composite(sc, SWT.NONE);
		sc.setContent(content);

		// ACezu郌CAEg}l[W
		RowLayout layout = new RowLayout(SWT.HORIZONTAL);
		layout.wrap = true;
		layout.pack = true;
		content.setLayout(layout);
		// găCAEg悤ɃXi[ǉ
		sc.addControlListener(new ControlAdapter() {
			public void controlResized(ControlEvent arg0) {
				sc.setMinSize(
					content.computeSize(sc.getClientArea().width, SWT.DEFAULT));
			}
		});
		sc.pack();
		// F
		content.setBackground(
			getDisplay().getSystemColor(SWT.COLOR_LIST_BACKGROUND));
		//sc.setBackground(getDisplay().getSystemColor(SWT.COLOR_BLUE));
		// IpƃtH[JX擾pXi[
		content.addMouseListener(new MouseAdapter() {
			public void mouseDown(MouseEvent event) {
				if (event.button != 1 && event.button != 3) {
					return;
				}
				if (DEBUG) {
					logger.debug("content mouseDown(deselectAll)"); //$NON-NLS-1$
				}
				deselectAll();
				content.forceFocus();
			}
		});
		// L[Cxg̏
		content.addKeyListener(new KeyAdapter() {
			public void keyPressed(KeyEvent event) {
				if (DEBUG) {
					logger.debug("keyCode: " //$NON-NLS-1$
							+ event.keyCode
							+ ", stateMask: " //$NON-NLS-1$
							+ event.stateMask
							+ ", character: " //$NON-NLS-1$
							+ event.character
							+ ';');
				}
				if (event.character == ' ') {
					if (DEBUG) {
						logger.debug("space key pressed"); //$NON-NLS-1$
					}
					onSpaceKey(event);
					return;
				}
				if (event.character == 0x01) {
					if (event.stateMask == SWT.MOD1) {
						// Ctrl+A
						selectAll();
					} else if (event.stateMask == (SWT.MOD1 | SWT.MOD2)) {
						// Ctrl+Shift+A
						deselectAll();
					}

				}
			}
		});
		content.addTraverseListener(new TraverseListener() {
			public void keyTraversed(TraverseEvent event) {
				switch (event.detail) {
					case SWT.TRAVERSE_TAB_NEXT :
					case SWT.TRAVERSE_TAB_PREVIOUS :
						//System.out.println("^uL[" + event.doit);
						event.doit = true; // ȂfalseɂȂĂ邱Ƃ
						break;
					case SWT.TRAVERSE_ARROW_NEXT :
						onArrowNext(event);
						break;
					case SWT.TRAVERSE_ARROW_PREVIOUS :
						onArrowPrevious(event);
						break;
					case SWT.TRAVERSE_RETURN :
						//System.out.println("^[");
						onReturnKey(event);
						break;
					case SWT.TRAVERSE_MNEMONIC :
						//System.out.println("j[jbN" + event);
						break;
					case SWT.TRAVERSE_ESCAPE :
					case SWT.TRAVERSE_PAGE_NEXT :
					case SWT.TRAVERSE_PAGE_PREVIOUS :
						break;
				}
			}
		});
	}
	/**
	 * ɃXN[o[\܂B
	 * @param show
	 */
	public void setAlwaysShowScrollBars(boolean show) {
		sc.setAlwaysShowScrollBars(show);
	}
	/**
	 * ACẽCfbNX͈̔͂`FbN܂B
	 * @param index CfbNX
	 * @return ͈͓Ȃtrue
	 */
	private boolean checkIndexBounds(int index) {
		if (index < 0 || index >= items.size()) {
			return false;
		}
		return true;
	}
	/**
	 * w肳ꂽCfbNX̑I܂B
	 * ͈͊O̒l͖܂B
	 * <br>ĕ`: 
	 * @param index CfbNX
	 */
	public void deselect(int index) {
		if (!checkIndexBounds(index)) {
			return;
		}
		LabeledIconItem item = (LabeledIconItem) items.get(index);
		if (!item.getSelection())
			return;
		item.setSelection(false);
		item.redraw();
	}
	/**
	 * w肳ꂽCfbNX̔z̑I܂B
	 * <br>ĕ`: 
	 * @param indices CfbNX̔z
	 */
	public void deselect(int[] indices) {
		for (int i = 0; i < indices.length; i++) {
			deselect(indices[i]);
		}
	}
	/**
	 * w肳ꂽ͈͂̑I܂B
	 * <br>ĕ`: 
	 * @param start JnCfbNX
	 * @param end ICfbNX
	 */
	public void deselect(int start, int end) {
		int min = Math.min(start, end);
		int max = Math.max(start, end);
		for (int i = min; i <= max; i++) {
			deselect(i);
		}
	}
	/**
	 * ׂĂ̑I܂B
	 * <br>ĕ`: 
	 */
	public void deselectAll() {
		Iterator itr = items.iterator();
		while (itr.hasNext()) {
			LabeledIconItem item = (LabeledIconItem) itr.next();
			if (!item.getSelection())
				continue;
			item.setSelection(false);
			item.redraw();
		}
	}
	/**
	 * ACe擾܂B<br>
	 * G[: SWT.ERROR_INVALID_RANGE
	 * @param index CfbNX
	 * @return ACe
	 */
	public LabeledIconItem getItem(int index) {
		if (!checkIndexBounds(index)) {
			SWT.error(SWT.ERROR_INVALID_RANGE);
		}
		return (LabeledIconItem) items.get(index);
	}
	/**
	 * |Cgɑ΂ACe擾܂B<br>
	 * TODO RectangleɊ܂܂ACe̔z̎擾
	 * @param point [Jʒu
	 * @return ACeB݂ȂꍇnullB
	 */
	public LabeledIconItem getItem(Point point) {
		Iterator itr = items.iterator();
		while (itr.hasNext()) {
			LabeledIconItem item = (LabeledIconItem) itr.next();
			if (item.getBounds().contains(point)) {
				return item;
			}
		}
		return null;
	}
	/**
	 * SACe擾܂B
	 * @return SACe̔z
	 */
	public LabeledIconItem[] getItems() {
		return (LabeledIconItem[]) items.toArray(
			new LabeledIconItem[items.size()]);
	}
	/**
	 * ACe擾܂B
	 * @return ACe
	 */
	public int getItemCount() {
		return items.size();
	}
	/**
	 * IꂽACe擾܂B
	 * @return ACe
	 */
	public LabeledIconItem[] getSelection() {
		Vector result = new Vector();
		Iterator itr = items.iterator();
		while (itr.hasNext()) {
			LabeledIconItem item = (LabeledIconItem) itr.next();
			if (item.getSelection()) {
				result.add(item);
			}
		}
		return (LabeledIconItem[]) result.toArray(
			new LabeledIconItem[result.size()]);
	}
	/**
	 * ŌɑIꂽACẽCfbNXԂ܂B<br>
	 * LĂȂꍇ͑Iꂽŏ̃ACeԂ܂B
	 * @return CfbNXBIƂ-1B
	 */
	public int getSelectionIndex() {
		// ŌɑIACe
		if (focus != null && focus.getSelection()) {
			return focus.getNumber();
		}
		// Iꂽŏ̃ACeԂ
		for (int i = 0; i < items.size(); i++) {
			LabeledIconItem item = (LabeledIconItem) items.get(i);
			if (item.getSelection()) {
				return i;
			}
		}
		return -1;
	}
	/**
	 * IꂽׂẴCfbNXԂ܂B
	 * @return CfbNX̔z
	 */
	public int[] getSelectionIndices() {
		int[] buf = new int[items.size()];
		int count = 0;
		for (int i = 0; i < items.size(); i++) {
			LabeledIconItem item = (LabeledIconItem) items.get(i);
			if (item.getSelection()) {
				buf[count] = i;
				count++;
			}
		}
		// 傤ǂ̃TCYɃRs[
		int[] result = new int[count];
		System.arraycopy(buf, 0, result, 0, count);
		return result;
	}
	/**
	 * IĂtrueB͈͊OfalseB
	 * @param index
	 * @return IĂtrueB͈͊OfalseB
	 */
	public boolean isSelected(int index) {
		if (!checkIndexBounds(index)) {
			return false;
		}
		LabeledIconItem item = (LabeledIconItem) items.get(index);
		return item.getSelection();
	}
	/**
	 * ACeɔԍUȂ܂B
	 * @param start w肳ꂽlȍ~̃CfbNX̔ԍUȂ
	 */
	private void renumber(int start) {
		for (int i = start; i < items.size(); i++) {
			LabeledIconItem item = (LabeledIconItem) items.get(i);
			item.setNumber(i);
		}
	}
	/**
	 * 폜(p)<br>
	 * ĕ`ԍ̐UȂs܂B
	 * @param index CfbNX
	 */
	private void removeItem(int index) {
		if (focus != null && focus.getNumber() == index) {
			focus = null;
		}
		if (startingPoint != null && startingPoint.getNumber() == index) {
			startingPoint = null;
		}
		LabeledIconItem item = getItem(index);
		item.setMenu(null);
		item.dispose();
		items.remove(index);
	}
	/**
	 * 폜
	 * @param index CfbNX
	 */
	public void remove(int index) {
		removeItem(index);
		renumber(index);
		//`
		doLayout();
	}
	/**
	 * CfbNX̔z(\[gĂȂȂ)
	 * w肳ꂽvf폜܂B
	 * @param indices CfbNX̔z
	 */
	public void remove(int[] indices) {
		// 납폜
		for (int i = indices.length - 1; i >= 0; i--) {
			removeItem(indices[i]);
		}
		// ŏԍUȂ
		renumber(0);
		// `
		doLayout();
	}
	/**
	 * w肳ꂽ͈͂폜܂B
	 * @param start JnCfbNX
	 * @param end ICfbNX
	 */
	public void remove(int start, int end) {
		int min = Math.min(start, end);
		int max = Math.max(start, end);
		// 납폜
		for (int i = max; i >= min; i--) {
			removeItem(i);
		}
		renumber(min);
		doLayout();
	}
	/**
	 * ׂč폜܂B
	 */
	public void removeAll() {
		focus = null;
		startingPoint = null;
		for (int i = 0; i < items.size(); i++) {
			LabeledIconItem item = (LabeledIconItem) items.get(i);
			item.setMenu(null);
			item.dispose();
		}
		items.clear();
		doLayout();
	}
	/**
	 * w肳ꂽCfbNXI͈͂Ɋ܂߂܂B
	 * @param index CfbNX
	 */
	public void select(int index) {
		if (!checkIndexBounds(index)) {
			return;
		}
		LabeledIconItem item = (LabeledIconItem) items.get(index);
		if (!item.getSelection()
			&& item.getStatus() != LabeledIconItem.BUTTON) {
			item.setSelection(true);
			item.redraw();
			//System.out.println("selectredraw܂B");
		}
	}
	/**
	 * w肳ꂽCfbNX̔zI͈͂Ɋ܂߂܂B
	 * @param indices CfbNX̔z
	 */
	public void select(int[] indices) {
		for (int i = 0; i < indices.length; i++) {
			select(indices[i]);
		}
	}
	/**
	 * w肳ꂽ͈͂I͈͂ɓ܂B
	 * @param start JnCfbNX
	 * @param end ICfbNX
	 */
	public void select(int start, int end) {
		int min = Math.min(start, end);
		int max = Math.max(start, end);
		for (int i = min; i <= max; i++) {
			select(i);
		}
	}
	/**
	 * ׂđI܂B
	 */
	public void selectAll() {
		for (int i = 0; i < items.size(); i++) {
			LabeledIconItem item = (LabeledIconItem) items.get(i);
			item.setSelection(true);
			item.redraw();
		}
	}
	/**
	 * w肳ꂽCfbNXȊȎI܂B
	 * @param index CfbNX
	 */
	private void deselectAllExcept(int index) {
		Iterator itr = items.iterator();
		while (itr.hasNext()) {
			LabeledIconItem item = (LabeledIconItem) itr.next();
			if (item.getNumber() != index && item.getSelection()) {
				item.setSelection(false);
				item.redraw();
			}
		}
	}
	/**
	 * I͈͂w肵܂B(̑I͉܂B)
	 * @param index CfbNX
	 */
	public void setSelection(int index) {
		deselectAllExcept(index);
		select(index);
	}

	/**
	 * w肳ꂽCfbNXI͈͂ɂ܂B
	 * @param indices CfbNX̔z
	 */
	public void setSelection(int[] indices) {
		for (int i = 0; i < items.size(); i++) {
			LabeledIconItem item = (LabeledIconItem) items.get(i);
			boolean found = false;
			for (int c = 0; c < indices.length; c++) {
				if (i == indices[c]) {
					if (!item.getSelection()) {
						item.setSelection(true);
						item.redraw();
						found = true;
					}
					break;
				}
			}
			if (!found && item.getSelection()) {
				item.setSelection(false);
				item.redraw();
			}
		}
	}
	/**
	 * w肳ꂽ͈͂I͈͂ɂ܂B
	 * @param start JnCfbNX
	 * @param end ICfbNX
	 */
	public void setSelection(int start, int end) {
		int min = Math.min(start, end);
		int max = Math.max(start, end);
		for (int i = 0; i < min; i++) {
			LabeledIconItem item = (LabeledIconItem) items.get(i);
			if (item.getSelection()) {
				item.setSelection(false);
				item.redraw();
			}
		}
		for (int i = min; i <= max; i++) {
			LabeledIconItem item = (LabeledIconItem) items.get(i);
			if (!item.getSelection()
				&& item.getStatus() != LabeledIconItem.BUTTON) {
				item.setSelection(true);
				item.redraw();
			}
		}
		for (int i = max + 1; i < items.size(); i++) {
			LabeledIconItem item = (LabeledIconItem) items.get(i);
			if (item.getSelection()) {
				item.setSelection(false);
				item.redraw();
			}
		}
	}
	/**
	 * w肳ꂽACeI͈͂ɂ܂B
	 * @param items ACe̔z
	 */
	public void setSelection(LabeledIconItem[] items) {
		int[] indices = new int[items.length];
		for (int i = 0; i < items.length; i++) {
			indices[i] = items[i].getNumber();
		}
		setSelection(indices);
	}
	/**
	 * w肳ꂽACeԖڂԂ܂B
	 * @param item ACe
	 * @return item.getNumber()
	 */
	public int indexOf(LabeledIconItem item) {
		return item.getNumber();
	}

	/**
	 * ACe̒ǉ
	 * @param item ACe
	 */
	void addItem(LabeledIconItem item) {
		addItem(item, items.size());
	}
	/**
	 * ACe̒ǉ
	 * @param item ACe
	 * @param index }ʒu
	 */
	void addItem(LabeledIconItem item, int index) {
		items.add(index, item);
		renumber(index);
		//`
		doLayout();
		if (itemMenu != null) {
			item.setMenu(itemMenu);
			CocoaMenuDetectSuppressor.install(item);
		}
	}
	/**
	 * ɃCxgXi[̓o^p
	 * ACe̒ڂ̐eEBWFbgԂ܂B
	 * @return ڂ̐eEBWFbg(Composite)
	 */
	public Composite getComposite() {
		return content;
	}
	/**
	 * CAEgs܂B
	 */
	void doLayout() {
		if (suppressLayout)
			return;
		Point pt = content.computeSize(sc.getClientArea().width, SWT.DEFAULT);
		if (DEBUG)
			logger.debug("content size: " + pt); //$NON-NLS-1$
		content.setSize(pt.x, SWT.DEFAULT);
		content.layout();
		// XN[o[XV
		sc.setMinSize(pt);
	}
	/**
	 * tH[JXړ܂B<br>
	 * ĕ`: łɑIĂꍇƃ{^̏ꍇɍĕ`悵܂B
	 * @param item ACe
	 */
	private void moveFocus(LabeledIconItem item) {
		if (focus == item || !item.getEnabled()) {
			return;
		}
		if (focus != null) {
			focus.setFocus(false);
			focus.redraw();
		}
		focus = item;
		focus.setFocus(true);
		content.forceFocus();
		if (focus.getSelection()
			|| focus.getStatus() == LabeledIconItem.BUTTON) {
			focus.redraw();
		}
	}
	/**
	 * ACe({^)MouseDownCxg<br>
	 * ̃ACẽtH[JXAw肳ꂽACeɃtH[JX܂B
	 * ĕ`悵܂B
	 * @param e Cxg
	 */
	void onMouseDownAtButtonItem(MouseEvent e) {
		LabeledIconItem item = (LabeledIconItem) e.widget;
		moveFocus(item);
		deselectAll();
		item.redraw();
	}
	/**
	 * ACe(ACR)̃_uNbN<br>
	 * Xi[ւ̒ʒm: L(open)
	 * @param event Cxg
	 */
	void onDoubleClickAtIconItem(MouseEvent event) {
		if (focus == null) {
			return;
		}
		Event e = new Event();
		e.button = event.button;
		e.data = event.data;
		e.display = event.display;
		e.stateMask = event.stateMask;
		e.time = event.time;
		e.x = event.x;
		e.y = event.y;
		e.widget = this; // gC
		e.item = focus; // ACe
		SelectionEvent sEvent = new SelectionEvent(e);
		notifyItemOpenListeners(sEvent);
	}
	/**
	 * ACRACeMouseListenerǉ܂B
	 * @param listener Xi[
	 */
	public void addItemMouseListener(MouseListener listener) {
		iconMouseListeners.add(listener);
	}
	/**
	 * ACRACeMouseListener폜܂B
	 * @param listener Xi[
	 */
	public void removeItemMouseListener(MouseListener listener) {
		iconMouseListeners.remove(listener);
	}
	/**
	 * ACe(ACRA{^)MouseDownCxg<br>
	 * <b>NbN: </b>NbNACe: IÃACȇI: A
	 * ͈͑I̋N_: ݒÃ݂tH[JX: ݒ<br>
	 * <b>Vtg+NbN: </b>ɑIꍇAI͈͂̃ACe: IA
	 * ͈͊ÕACe: IÃ݂tH[JX: ݒAI͈͂̋N_: ȂɂȂ<br>
	 * ɑIꍇ: ݂̃tH[JX: ݒA͈͑I̋N_: ȂɂȂ(-1Ȃݒ)
	 * I͈͂̃ACe: IA͈͊ÕACe: I<br>
	 * <b>Rg[+NbN: </b>̃ACȇI: ̂܂܁A͈͑I̋N_: ݒA
	 * ݂̃tH[JX: ݒANbNACe: IԂ̔]<br>
	 * <b>Rg[+Vtg+NbN: </b>{͑I͈͂̒ǉA
	 * Rg[+NbNƓɂ<br>
	 * Xi[ւ̒ʒm: traỹXi[ɃACR̍NbNȊÕCxg𗬂B
	 * @param e Cxg
	 */
	void onMouseDownAtItem(MouseEvent e) {
		// traỹXi[ɒʒm(}EX_ECxg)
		LabeledIconItem item = (LabeledIconItem) e.widget;
		if (e.button != 1) {
			if (e.button == 3 && item.getStatus() == LabeledIconItem.ICON) {
				// ACRACeł̉ENbN
				moveFocus(item);
				if (!item.getSelection()) {
					startingPoint = item;
					setSelection(item.getNumber());
				}
			}
			return;
		}
		// ACemouseDown
		moveFocus(item);
		// CL[ɉď
		if (e.stateMask == (SWT.MOD1 | SWT.MOD2) || e.stateMask == SWT.MOD1) {
				if (item.getSelection()) {
					delayedSelectionMode = true;
				} else {
					delayedSelectionMode = false;
					startingPoint = item;
					if (item.getSelection()) {
						deselect(item.getNumber());
					} else {
						select(item.getNumber());
					}
					// SelectionEventʒm
					notifyIconSelectionListeners(e);
				}

		} else if (e.stateMask == SWT.MOD2) {
				if (getSelectionIndex() != -1) {
					// Iꍇ
					setSelection(item.getNumber(), startingPoint.getNumber());
				} else {
					// Iꍇ
					if (startingPoint == null) {
						startingPoint = item;
					}
					select(item.getNumber());
				}
				// SelectionEvent
				notifyIconSelectionListeners(e);

		} else {
				// CL[Ȃ
				if (item.getSelection()) {
					// }EXAbv҂[h
					delayedSelectionMode = true;
				} else {
					startingPoint = item;
					setSelection(item.getNumber());
					delayedSelectionMode = false;
					// SelectionEvent
					notifyIconSelectionListeners(e);
				}

		}
		//System.out.println("ACRmouseDown: " + e.time + " " + item.toString());
	}
	/**
	 * ACRACemouseUpCxg
	 * @param e Cxg
	 */
	void onMouseUpAtIconItem(MouseEvent e) {
		if (!delayedSelectionMode || e.button != 1) {
			// mouseUpCxgʒm
			if (DEBUG)
				logger.debug("onMouseUpAtIconItem"); //$NON-NLS-1$
			Iterator itr = iconMouseListeners.iterator();
			while (itr.hasNext()) {
				MouseListener listener = (MouseListener) itr.next();
				listener.mouseUp(e);
			}
			return;
		}
		delayedSelectionMode = false;
		LabeledIconItem item = (LabeledIconItem) e.widget;

		if ((e.stateMask & SWT.MOD1) != 0) {
			startingPoint = item;
			// delayedSelectionMode͂łɑIĂƂȂ̂ŊmFsv
			deselect(item.getNumber());
		} else {
			startingPoint = item;
			setSelection(item.getNumber());
		}
		// SelectionEvent
		notifyIconSelectionListeners(e);
	}
	/**
	 * L[: Âӂ܂
	 * @param event Cxg
	 */
	private void onArrowNext(TraverseEvent event) {
		if (items.isEmpty())
			return;
		// tH[JXȂꍇ͍ŏɃtH[JXłACe
		// tH[JXꍇ͎ɃtH[JXłACe
		// Ō̏ꍇ͍ŏɃtH[JXłACeɈړ

		// ݂̃tH[JXԍ
		int cur;
		if (focus == null) {
			cur = 0;
		} else {
			cur = focus.getNumber();
		}
		// ɃtH[JXԍ
		int next = cur + 1;
		while (cur != next) {
			if (next == items.size()) {
				next = 0;
			}
			LabeledIconItem item = (LabeledIconItem) items.get(next);
			if (item.getEnabled()) {
				break;
			}
			next++;
		}
		arrowKeyAction(event, next);
	}
	/**
	 * L[: Âӂ܂
	 * @param event Cxg
	 */
	private void onArrowPrevious(TraverseEvent event) {
		if (items.isEmpty())
			return;
		// 
		int cur;
		if (focus == null) {
			cur = 0;
		} else {
			cur = focus.getNumber();
		}
		// ɃtH[JXԍ
		int next = cur - 1;
		while (cur != next) {
			if (next == -1) {
				next = items.size() - 1;
			}
			LabeledIconItem item = (LabeledIconItem) items.get(next);
			if (item.getEnabled()) {
				break;
			}
			next--;
		}
		arrowKeyAction(event, next);
	}
	/**
	 * L[ړ̏
	 * @param event Cxg
	 * @param next ړ̃CfbNX
	 */
	private void arrowKeyAction(TraverseEvent event, int next) {
		moveFocus(getItem(next));
		if ((event.stateMask & SWT.MOD1) != 0) {
			// Rg[L[: tH[JẌړ
			focus.redraw();
		} else if ((event.stateMask & SWT.MOD2) != 0) {
			// VtgL[: ǉI
			int start = 0;
			if (startingPoint != null)
				start = startingPoint.getNumber();
			setSelection(start, next);
			// SelectionEvent
			notifyIconSelectionListeners(event);
		} else {
			// CL[Ȃ: NbNƓ
			startingPoint = focus;
			setSelection(next);
			// SelectionEvent
			notifyIconSelectionListeners(event);
		}
		// XN[
		Rectangle target = focus.getBounds();
		Rectangle current = sc.getClientArea();
		Point origin = sc.getOrigin();
		//current.x = origin.x;
		current.y = origin.y;
		if (current.contains(0, target.y)
			&& current.contains(0, target.y + target.height - 1)) {
			// SĂ
			//System.out.println(
			//	"ړȂ target: " + target + ", current" + current);
			return;
		} else if (target.y + target.height > current.y + current.height) {
			// ɃXN[
			//System.out.println(
			//	"Ɉړ target: " + target + ", current" + current);
			sc.setOrigin(0, target.y + target.height - current.height + 2);
			// ]t
		} else {
			// ɃXN[
			//System.out.println(
			//	"Ɉړ target: " + target + ", current" + current);
			sc.setOrigin(0, target.y);
		}
		//System.out.println(
		//	"ړ : " +sc.getOrigin());
	}
	/**
	 * Xy[XL[ɂNbN
	 * @param event Cxg
	 */
	private void onSpaceKey(KeyEvent event) {
		if (focus == null)
			return;
		if (focus.getStatus() == LabeledIconItem.BUTTON) {
			//System.out.println("Xy[XNbN");
			Event e = new Event();
			e.character = event.character;
			e.data = event.data;
			e.display = event.display;
			e.keyCode = event.keyCode;
			e.stateMask = event.stateMask;
			e.time = event.time;
			e.widget = this; // tray
			e.item = focus; // item
			SelectionEvent sEvent = new SelectionEvent(e);
			notifyButtonSelectionListeners(sEvent);
			return;
		}
		// ACRACe
		if ((event.stateMask & SWT.MOD1) != 0) {
			// Rg[L[: I̔]
			if (focus.getSelection()) {
				deselect(focus.getNumber());
			} else {
				select(focus.getNumber());
			}
		} else if ((event.stateMask & SWT.MOD2) != 0) {
			// VtgL[: ͈͑I
			//int start;
			if (startingPoint != null) {
				setSelection(startingPoint.getNumber(), focus.getNumber());
			} else {
				setSelection(focus.getNumber());
			}
		} else {
			// CL[Ȃ: IĂȂꍇselect(focus)
			if (focus.getSelection())
				return;
			select(focus.getNumber());
		}
		// SelectionEventʒm
		Event e = new Event();
		e.character = event.character;
		e.data = event.data;
		e.display = event.display;
		e.widget = this; // gC
		e.item = focus; // ACe
		e.keyCode = event.keyCode;
		e.stateMask = event.stateMask;
		e.time = event.time;
		SelectionEvent sEvent = new SelectionEvent(e);
		notifyIconSelectionListeners(sEvent);
	}
	/**
	 * ACe({^)SelectionCxg<br>
	 * Xi[ւ̒ʒm: L
	 * @param e Cxg
	 */
	void onClickAtButtonItem(MouseEvent e) {
		//System.out.println("onClickAtButtonItem: SelectionCxgʒm");
		Event event = new Event();
		event.button = e.button;
		event.data = e.data;
		event.display = e.display;
		event.stateMask = e.stateMask;
		event.time = e.time;
		event.widget = this; // gC
		event.item = focus; // ACe
		event.x = e.x;
		event.y = e.y;
		SelectionEvent sEvent = new SelectionEvent(event);
		notifyButtonSelectionListeners(sEvent);
	}
	/**
	 * {^SelectionListenerɒʒm܂B
	 * @param event Cxg
	 */
	private void notifyButtonSelectionListeners(SelectionEvent event) {
		fireWidgetSelected(buttonSelectionListeners, event);
	}

	/**
	 * {@link SelectionListener#widgetSelected(SelectionEvent)}Ăяo܂B
	 * @param listeners Xi[
	 * @param event Cxg
	 */
	private void fireWidgetSelected(Vector listeners, SelectionEvent event) {
		if (DEBUG)
			logger.debug("fireWidgetSelected"); //$NON-NLS-1$
		Iterator itr = listeners.iterator();
		while (itr.hasNext()) {
			SelectionListener listener = (SelectionListener) itr.next();
			listener.widgetSelected(event);
		}
	}

	/**
	 * {^ACeSelectionListenerǉ܂B
	 * @param listener Xi[
	 */
	public void addButtonSelectionListener(SelectionListener listener) {
		buttonSelectionListeners.add(listener);
	}
	/**
	 * {^ACeSelectionListener폜܂B
	 * @param listener Xi[
	 */
	public void removeButtonSelectionListener(SelectionListener listener) {
		buttonSelectionListeners.remove(listener);
	}
	/**
	 * ^[L[Ƃ̏
	 * @param event Cxg
	 */
	private void onReturnKey(TraverseEvent event) {
		if (focus == null) {
			return;
		}
		if (focus.getStatus() == LabeledIconItem.BUTTON) {
			// {^̓NbN
			Event e = new Event();
			e.character = event.character;
			e.data = event.data;
			e.detail = event.detail;
			e.display = event.display;
			e.keyCode = event.keyCode;
			e.stateMask = event.stateMask;
			e.time = event.time;
			e.widget = this; // gC
			e.item = focus; // ACe
			SelectionEvent sEvent = new SelectionEvent(e);
			notifyButtonSelectionListeners(sEvent);
		} else if (focus.getSelection()) {
			// ACe͑IĂ΃_uNbN
			Event e = new Event();
			e.character = event.character;
			e.data = event.data;
			e.detail = event.detail;
			e.display = event.display;
			e.keyCode = event.keyCode;
			e.stateMask = event.stateMask;
			e.time = event.time;
			e.widget = this; // gC
			e.item = focus; // ACe
			SelectionEvent sEvent = new SelectionEvent(e);
			notifyItemOpenListeners(sEvent);
		}
	}
	/**
	 * ACe_uNbNAIEnterL[Ƃ
	 * Cxgʒm܂B
	 * @param event Cxg
	 */
	private void notifyItemOpenListeners(SelectionEvent event) {
		fireWidgetSelected(iconOpenListeners, event);
	}
	/**
	 * ACRopenXi[ǉ܂B
	 * @param listener Xi[
	 */
	public void addIconOpenListener(SelectionListener listener) {
		iconOpenListeners.add(listener);
	}
	/**
	 * ACRopenXi[폜܂B
	 * @param listener Xi[
	 */
	public void removeIconOpenListener(SelectionListener listener) {
		iconOpenListeners.remove(listener);
	}
	/**
	 * ACRSelectionXi[ǉ܂B
	 * @param listener Xi[
	 */
	public void addIconSelectionListener(SelectionListener listener) {
		iconSelectionListeners.add(listener);
	}
	/**
	 * ACRSelectionXi[폜܂B
	 * @param listener Xi[
	 */
	public void removeIconSelectionListener(SelectionListener listener) {
		iconSelectionListeners.remove(listener);
	}
	/**
	 * [U[̑ɂăACȒIԂύXꂽƂ
	 * ʒm܂B
	 * @param event Cxg
	 */
	private void notifyIconSelectionListeners(SelectionEvent event) {
		if (DEBUG)
			logger.debug("notifyIconSelectionListeners"); //$NON-NLS-1$
		Iterator itr = iconSelectionListeners.iterator();
		while (itr.hasNext()) {
			SelectionListener listener = (SelectionListener) itr.next();
			listener.widgetSelected(event);
		}
	}
	/**
	 * MouseEventSelectionEventɕϊĒʒm܂B
	 * @param event Cxg
	 */
	private void notifyIconSelectionListeners(MouseEvent event) {
		Event e = new Event();
		e.button = event.button;
		e.data = event.data;
		e.display = event.display;
		e.widget = this;
		e.item = focus;
		e.stateMask = event.stateMask;
		e.time = event.time;
		e.x = event.x;
		e.y = event.y;
		SelectionEvent sEvent = new SelectionEvent(e);
		notifyIconSelectionListeners(sEvent);
	}
	/**
	 * TraversEventSelectionEventɕϊĒʒm܂B
	 * @param event Cxg
	 */
	private void notifyIconSelectionListeners(TraverseEvent event) {
		Event e = new Event();
		e.character = event.character;
		e.data = event.data;
		e.detail = event.detail;
		e.display = event.display;
		e.doit = event.doit;
		e.widget = this;
		e.item = focus;
		e.keyCode = event.keyCode;
		e.stateMask = event.stateMask;
		e.time = event.time;
		SelectionEvent sEvent = new SelectionEvent(e);
		notifyIconSelectionListeners(sEvent);
	}

	/**
	 * CAEg𐧌䂵܂B
	 * @param suppress truêƂCAEgsȂBfalsêƂCAEg1sB
	 */
	public void setSuppressLayout(boolean suppress) {
		suppressLayout = suppress;
		if (!suppress && !isDisposed())
			doLayout();
	}

	/**
	 * @see org.eclipse.swt.widgets.Control#isFocusControl()
	 */
	public boolean isFocusControl() {
		if (super.isFocusControl() || getComposite().isFocusControl()) {
			return true;
		}
		for (int i = items.size() - 1; i >= 0; i--) {
			LabeledIconItem item = (LabeledIconItem) items.get(i);
			if (item.isFocusControl()) {
				return true;
			}
		}
		return false;
	}

	/**
	 * ACep̃j[ݒ肵܂B
	 * ݒς݂̃j[͔jAVj[ׂẴACe
	 * @param itemMenu ACep̃j[
	 */
	public void setItemMenu(Menu itemMenu) {
		if (this.itemMenu != null) {
			this.itemMenu.dispose();
		}
		this.itemMenu = itemMenu;
		for (int i = 0; i < items.size(); i++) {
			LabeledIconItem item = (LabeledIconItem) items.get(i);
			item.setMenu(itemMenu);
			CocoaMenuDetectSuppressor.install(item);
		}
	}
}
