package jp.takayuki.tools;

import java.io.UnsupportedEncodingException;
import java.nio.charset.Charset;

/**
 * bytẽXgłB
 * @author Takayuki Shoji
 */
public class ByteList {

	/**
	 * ݂̃TCY
	 */
	private int size;

	/**
	 * f[^
	 */
	private byte[] buffer;

	/**
	 * ftHg̏TCY
	 */
	private static final int DEFAULT_BUFFER_LENGTH = 64;

	/**
	 * TCY
	 */
	private int increment;

	/**
	 * ftHg̑TCY
	 */
	private static final int DEFAULT_INCREMENT = 1024;

	/**
	 * RXgN^B
	 * TCY64BTCY1024B
	 */
	public ByteList() {
		this(DEFAULT_BUFFER_LENGTH, DEFAULT_INCREMENT);
	}

	/**
	 * RXgN^BTCY1024B
	 * @param initialCapacity bytez̏TCY
	 */
	public ByteList(int initialCapacity) {
		this(initialCapacity, DEFAULT_INCREMENT);
	}

	/**
	 * RXgN^
	 * @param initialSize TCY
	 * @param increment TCY
	 */
	public ByteList(int initialSize, int increment) {
		this.buffer = new byte[initialSize];
		this.increment = increment;
	}

	/**
	 * TCY擾܂B
	 * @return TCY
	 */
	public int size() {
		return size;
	}

	/**
	 * XĝƂtrueԂ܂B
	 * @return ̏ꍇtrue
	 */
	public boolean isEmpty() {
		return size == 0;
	}

	/**
	 * XgɃIuWFNg܂܂Ă邩܂B
	 * @param b l
	 * @return ܂܂Ătrue
	 */
	public boolean contains(byte b) {
		for (int i = 0; i < size; i++) {
			if (buffer[i] == b) {
				return true;
			}
		}
		return false;
	}

	/**
	 * z擾܂B
	 * @return bytez
	 */
	public byte[] toArray() {
		byte[] result = new byte[size];
		System.arraycopy(buffer, 0, result, 0, size);
		return result;
	}

	/**
	 * vfǉ܂B
	 * @param b ǉvf
	 */
	public void add(byte b) {
		if (size == buffer.length) {
			this.buffer = realloc(buffer.length + increment);
		}
		buffer[size] = b;
		size++;
	}

	/**
	 * vfzŒǉ܂B
	 * @param b ǉvf̔z
	 */
	public void add(byte[] b) {
		add(b, b.length);
	}

	/**
	 * vfzŒw肵Ēǉ܂B
	 * @param b ǉvf̔z
	 * @param len 
	 */
	public void add(byte[] b, int len) {
		if (b == null)
			return;
		if (size + len > buffer.length) {
			this.buffer = realloc(size + Math.max(len, increment));
		}
		System.arraycopy(b, 0, buffer, size, len);
		size += len;
	}

	/**
	 * w肵TCYbytez쐬bufferRs[܂B
	 * buffer͕ύX܂B
	 * @param newSize mۂTCY
	 * @return Vmۂz
	 */
	private byte[] realloc(int newSize) {
		byte[] newBuffer = new byte[newSize];
		System.arraycopy(buffer, 0, newBuffer, 0, buffer.length);
		return newBuffer;
	}

	/**
	 * TCY0ɐݒ肵܂B
	 */
	public void clear() {
		size = 0;
	}

	/**
	 * 񉻂܂B
	 * @param cs Zbg
	 * @return 
	 */
	public String toString(Charset cs) {
		if (Tool.javaVersion1_6_orHigher) {
			return new String(buffer, 0, size, cs);
		}
		try {
			return new String(buffer, 0, size, cs.name());
		} catch (UnsupportedEncodingException e) {
			return new String(buffer, 0, size);
		}
	}
}
