package jp.takayuki.tools;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;

import org.eclipse.swt.SWT;

/**
 * GUIŃtH_JR}hĂяoB
 * @author Takayuki Shoji
 */
public class FolderOpener {
	/**
	 * <p>GUIŃtH_J܂B</p>
	 * <p>WindowsłExplorerĂяo܂B</p>
	 * @param path JƂpXBt@C̏ꍇ͈̃tH_JB
	 * @param select ̃tH_\đIꍇtrue
	 */
	public static void openFolder(File path, boolean select) {
		if (path == null) {
			return;
		}
		String[] args;

		String platform = SWT.getPlatform();
		if (platform.equals("win32")) { //$NON-NLS-1$
			args = openFolderCommandWin32(path, select);
		} else if (platform.equals("carbon") || platform.equals("cocoa")) { //$NON-NLS-1$ //$NON-NLS-2$
			args = openFolderCommandMacOSX(path, select);
		} else if (platform.equals("gtk")) { //$NON-NLS-1$
			args = openFolderCommandNautilus(path, select);
		} else {
			return;
		}

		try {
			Process p = Runtime.getRuntime().exec(args);
			p.waitFor();
		} catch (IOException e) {
			e.printStackTrace();
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
	}

	/**
	 * Windowsł̃tH_JR}h擾܂B
	 * @param path JƂpX
	 * @param select pathIꍇtrue(1̃tH_J)
	 * @return R}h
	 */
	private static String[] openFolderCommandWin32(File path, boolean select) {
		if (!path.isDirectory()) {
			select = true;
		}

		ArrayList args = new ArrayList(3);
		args.add("explorer.exe"); //$NON-NLS-1$
		if (select) {
			args.add("/select,"); //$NON-NLS-1$
		}

		String pathToOpen = path.getAbsolutePath();
		args.add(pathToOpen);

		return (String[]) args.toArray(new String[args.size()]);
	}

	/**
	 * GtkŃtH_JR}h擾܂B
	 * @param path JƂpX
	 * @param upper 1̃tH_J
	 * @return R}h
	 */
	public static String[] openFolderCommandNautilus(File path, boolean upper) {
		return openFolderCommand(path, upper, "nautilus"); //$NON-NLS-1$
	}

	/**
	 * Mac OS XŃtH_JR}h擾܂B
	 * @param path JƂpX
	 * @param upper ̃tH_J
	 * @return R}h
	 */
	public static String[] openFolderCommandMacOSX(File path, boolean upper) {
		return openFolderCommand(path, upper, "open"); //$NON-NLS-1$
	}

	/**
	 * tH_R}h쐬鋤ʏłB
	 * @param path tH_pX
	 * @param upper ̃tH_J
	 * @param command R}h
	 * @return R}h
	 */
	private static String[] openFolderCommand(File path, boolean upper,
			String command) {
		if (!path.isDirectory()) {
			upper = true;
		}
		File targetFile;
		if (upper) {
			targetFile = path.getParentFile();
		} else {
			targetFile = path;
		}
		return new String[] { command, targetFile.getAbsolutePath() };
	}
}
