package jp.takayuki.tools;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import petaclone.swt.SWTMainWindow;

/**
 * Mac OS X̃fBNg̈ʒu܂B
 * @author Takayuki Shoji
 */
public class MacOSXPathResolver extends AbstractPathResolver {

	public File getApplicationData() {
		String home = System.getProperty("user.home"); //$NON-NLS-1$
		return new File(home, "Library/Preferences"); //$NON-NLS-1$
	}

	public File getMyDocuments() {
		String home = System.getProperty("user.home"); //$NON-NLS-1$
		return new File(home, "Documents"); //$NON-NLS-1$
	}

	public String[] getExecutable() {
		File dir = Tool.getProgramDirectory(getClass());
		if (dir == null) {
			return null;
		}
		// app̏ꍇ
		if (Boolean.getBoolean("exec.app")) { //$NON-NLS-1$
			// Ɍ*.appT
			while (!dir.getName().toLowerCase().endsWith(".app")) { //$NON-NLS-1$
				dir = dir.getParentFile();
				if (dir == null) {
					return null;
				}
			}
			return new String[] { "open", dir.getAbsolutePath() }; //$NON-NLS-1$
		}

		// jaȑꍇ
		String classLocation = Tool.getClassLocation(SWTMainWindow.class);
		File jarPath = Tool.getJarPath(classLocation);
		if (jarPath != null) {
			List args = createArgList();
			args.add("-jar"); //$NON-NLS-1$
			args.add(jarPath.getAbsolutePath());
			return (String[]) args.toArray(new String[args.size()]);
		}

		List args = createArgList();
		args.add("-cp"); //$NON-NLS-1$
		args.add(System.getProperty("java.class.path")); //$NON-NLS-1$
		args.add(SWTMainWindow.class.getName());
		return (String[]) args.toArray(new String[args.size()]);
	}

	/**
	 * @return Xg̋ʕ
	 */
	private List createArgList() {
		List args = new ArrayList();
		args.add(getJavaPath());
		String bit = System.getProperty("sun.arch.data.model"); //$NON-NLS-1$
		if (bit != null) {
			args.add("-d" + bit); //$NON-NLS-1$
		}
		args.add("-Dfile.encoding=UTF-8"); //$NON-NLS-1$
		args.add("-XstartOnFirstThread"); //$NON-NLS-1$
		return args;
	}

	public File getProgramDirectory() {
		File dir = Tool.getProgramDirectory(getClass());
		if (dir == null) {
			return null;
		}
		// app̏ꍇ
		if (Boolean.getBoolean("exec.app")) { //$NON-NLS-1$
			// Ɍ*.appT
			while (!dir.getName().endsWith(".app")) { //$NON-NLS-1$
				dir = dir.getParentFile();
				if (dir == null) {
					return null;
				}
			}
			return dir.getParentFile();
		}

		// jaȑꍇ
		String classLocation = Tool.getClassLocation(SWTMainWindow.class);
		File jarPath = Tool.getJarPath(classLocation);
		if (jarPath != null) {
			return jarPath.getParentFile();
		}

		// class̏ꍇ
		return dir;

	}
}
