package jp.takayuki.tools;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import petaclone.AppPreferences;
import extcmd.Restart;

/**
 * ċNƍXVs܂B
 * @author Takayuki Shoji
 */
public class MacOSXRestartHelper extends AbstractRestartHelper {

	/**
	 * @param pref ݒ
	 */
	public MacOSXRestartHelper(AppPreferences pref) {
		super(pref);
	}

	public void update(File updateFile) throws IOException {

		// J̏ꍇ͍XVȂ
		checkDevelopmentEnvironment();

		PathResolver pathResolver = pref.getPolicy().getPathResolver();

		deleteRestartLog();

		Map envp = new HashMap(System.getenv());
		envp.put(Restart.LOG, logFile.getAbsolutePath());
		envp.put(Restart.WATCH_FILE, createLockFile());
		envp.put(Restart.NEW_FILE, updateFile.getAbsolutePath());
		File installDir = pathResolver.getProgramDirectory();
		if (installDir == null) {
			throw new IOException("Failed to get program directory."); //$NON-NLS-1$
		}
		envp.put(Restart.APP_FOLDER_NAME, "petaclone"); //$NON-NLS-1$
		envp.put(Restart.INSTALL_DIR, installDir.getAbsolutePath());
		envp.put(Restart.BASE_DIR, Tool.getCurrentDirectory());
		String[] cmdSet = pathResolver.getExecutable();
		if (cmdSet == null) {
			throw new IOException("Failed to get restart command."); //$NON-NLS-1$
		}
		for (int i = 0; i < cmdSet.length; i++) {
			envp.put(Restart.RESTART + i, cmdSet[i]);
		}

		List args = new ArrayList();
		// 0: sudô߂̃R}h "osascript"
		args.add("osascript"); //$NON-NLS-1$
		// 1: 
		args.add("-e"); //$NON-NLS-1$
		// "java -cp . extcmd.Restart update"
		args.add("do shell script \"java -cp . " //$NON-NLS-1$
				+ Restart.class.getName()
				+ " " //$NON-NLS-1$
				+ Restart.CMD_PRIVILEGE_UPDATE
				+ "\" with administrator privileges"); //$NON-NLS-1$

		for (int i = 0; i < args.size(); i++) {
			envp.put(Restart.PRIVILEGE + i, args.get(i));
		}

		List args2 = getUpdateCommand(pathResolver);

		// s
		writeRestartClass();
		execute(args2, envp);
	}

}
