package jp.takayuki.tools;

import java.util.Arrays;

/**
 * {pUnicode NormalizerB
 * 
 * @author Takayuki Shoji
 */
public class Normalizer {

	/**
	 * _
	 */
	private static final char[] separated3099 = { //
	//
			0x0000,
			// Ђ炪
			0x3046, // 
			0x304B, // 
			0x304D, // 
			0x304F, // 
			0x3051, // 
			0x3053, // 
			0x3055, // 
			0x3057, // 
			0x3059, // 
			0x305B, // 
			0x305D, // 
			0x305F, // 
			0x3061, // 
			0x3064, // 
			0x3066, // 
			0x3068, // 
			0x306F, // 
			0x3072, // 
			0x3075, // 
			0x3078, // 
			0x307B, // 
			0x309D, // T

			// J^Ji
			0x30A6, // E
			0x30AB, // J
			0x30AD, // L
			0x30AF, // N
			0x30B1, // P
			0x30B3, // R
			0x30B5, // T
			0x30B7, // V
			0x30B9, // X
			0x30BB, // Z
			0x30BD, // \
			0x30BF, // ^
			0x30C1, // `
			0x30C4, // c
			0x30C6, // e
			0x30C8, // g
			0x30CF, // n
			0x30D2, // q
			0x30D5, // t
			0x30D8, // w
			0x30DB, // z
			0x30EF, // 
			0x30F0, // 
			0x30F1, // 
			0x30F2, // 
			0x30FD, // R
	};

	/**
	 * _
	 */
	private static final char[] separated309A = {
	//
			0x0000,
			// Ђ炪
			0x306F, // 
			0x3072, // 
			0x3075, // 
			0x3078, // 
			0x307B, // 

			// J^Ji
			0x30CF, // n
			0x30D2, // q
			0x30D5, // t
			0x30D8, // w
			0x30DB, // z

	};

	/**
	 * Kꂽ
	 */
	private static final char[] normalized = {
	//
			0x0000,
			// _Ђ炪
			0x3094, // J
			0x304C, // 
			0x304E, // 
			0x3050, // 
			0x3052, // 
			0x3054, // 
			0x3056, // 
			0x3058, // 
			0x305A, // 
			0x305C, // 
			0x305E, // 
			0x3060, // 
			0x3062, // 
			0x3065, // 
			0x3067, // 
			0x3069, // 
			0x3070, // 
			0x3073, // 
			0x3076, // 
			0x3079, // 
			0x307C, // 
			0x309E, // U

			// _J^Ji
			0x30F4, // 
			0x30AC, // K
			0x30AE, // M
			0x30B0, // O
			0x30B2, // Q
			0x30B4, // S
			0x30B6, // U
			0x30B8, // W
			0x30BA, // Y
			0x30BC, // [
			0x30BE, // ]
			0x30C0, // _
			0x30C2, // a
			0x30C5, // d
			0x30C7, // f
			0x30C9, // h
			0x30D0, // o
			0x30D3, // r
			0x30D6, // u
			0x30D9, // x
			0x30DC, // {
			0x30F7, // J
			0x30F8, // J
			0x30F9, // J
			0x30FA, // J
			0x30FE, // S

			// _Ђ炪
			0x3071, // 
			0x3074, // 
			0x3077, // 
			0x307A, // 
			0x307D, // 

			// _J^Ji
			0x30D1, // p
			0x30D4, // s
			0x30D7, // v
			0x30DA, // y
			0x30DD, // |
	};

	/**
	 * NFD`NFC`ɐK܂B
	 * 
	 * @param str NFD
	 * @return NFC
	 */
	public static String normalize(CharSequence str) {
		if (str == null) {
			return null;
		}
		final int len = str.length();
		if (len == 0)
			return ""; //$NON-NLS-1$

		final StringBuffer result = new StringBuffer(len);

		// 1
		result.append(str.charAt(0));

		for (int i = 1; i < len; i++) {
			final char c = str.charAt(i);

			final char prev;
			final int index;
			switch (c) {
			case 0x3099:
				prev = str.charAt(i - 1);
				index = Arrays.binarySearch(separated3099, prev);
				if (index > 0) {
					result.deleteCharAt(result.length() - 1);
					result.append(normalized[index]);
				} else {
					result.append(c);
				}
				break;

			case 0x309A:
				prev = str.charAt(i - 1);
				index = Arrays.binarySearch(separated309A, prev);
				if (index > 0) {
					result.deleteCharAt(result.length() - 1);
					result.append(normalized[index + 48]);
				} else {
					result.append(c);
				}
				break;

			default:
				result.append(c);
				break;
			}
		}
		return result.toString();
	}
}
