package jp.takayuki.tools;

import java.io.IOException;

/**
 * Iy[eBOVXeʂ܂B
 * @author Takayuki Shoji
 */
public class Os {

	/**
	 * OS̎ʎq
	 */
	private static int os;
	
	/**
	 * OS̑܂ȖO
	 */
	private static String osName;
	static{
		initialize();
	}

	/**
	 * Windows
	 */
	public static final int WINDOWS = 1;

	/**
	 * Mac OS X
	 */
	public static final int MACOSX = 2;

	/**
	 * ̑
	 */
	public static final int OTHER = 0;

	/**
	 * 
	 */
	private static void initialize() {
		final String name = System.getProperty("os.name"); //$NON-NLS-1$
		if (name.indexOf("Windows") != -1) { //$NON-NLS-1$
			os = WINDOWS;
			osName = "windows"; //$NON-NLS-1$
		} else if (name.indexOf("Mac") != -1) { //$NON-NLS-1$
			os = MACOSX;
			osName = "mac"; //$NON-NLS-1$
		} else {
			// Linux, FreeBSD, Solaris, ...
			os = OTHER;
			osName = "other"; //$NON-NLS-1$
		}
	}

	/**
	 * eXgpOSݒ肵܂B
	 * @param id OS̎ʎq
	 */
	public static void setId(int id) {
		os = id;
	}

	/**
	 * eXgpɕύXOSɖ߂܂B
	 */
	public static void reset() {
		initialize();
	}

	/**
	 * OS̎ʎqԂ܂B
	 * @return ʎq
	 */
	public static int getId() {
		return os;
	}

	/**
	 * OS̖O擾܂B
	 * @return OS̑܂ȖO
	 */
	public static String getName() {
		return osName;
	}

	/**
	 * WindowsȂtrueԂ܂B
	 * @return WindowsȂtrue
	 */
	public static boolean isWindows() {
		return os == WINDOWS;
	}

	/**
	 * Mac OS XȂtrueԂ܂B
	 * @return Mac OS XȂtrue
	 */
	public static boolean isMacOSX() {
		return os == MACOSX;
	}

	/**
	 * ̑OSȂtrueԂ܂B
	 * @return ̑OSȂtrue
	 */
	public static boolean isOther() {
		return os == OTHER;
	}

	/**
	 * Rs[^Vbg_EAnCol[gAX[v܂B
	 * <p>
	 * 1: Windows x~<br>
	 * 2: Windows shutdown /s<br>
	 * 3: Mac sleep<br>
	 * 4: Unix shutdown -h now
	 * 
	 * @param type Vbg_EAnCol[gAX[v̎
	 * @throws IOException R}hs̗O
	 * @throws InterruptedException R}hs̗O
	 */
	public static void shutdown(int type) throws IOException,
			InterruptedException {
		String[] command;
		switch (type) {
		case 0:
			// Ȃ
			return;
		case 1:
			// Windows x~
			command = new String[] { "%windir%\\System32\\rundll32.exe", //$NON-NLS-1$
					"powrprof.dll,SetSuspendState" }; //$NON-NLS-1$
			break;
		case 2:
			// Windows Vbg_E
			command = new String[] { "shutdown", "/s" }; //$NON-NLS-1$ //$NON-NLS-2$
			break;
		case 3:
			// Mac X[vEnCol[g
			command = new String[] { "osascript", "-e", //$NON-NLS-1$ //$NON-NLS-2$
					"tell application \"System Events\" to sleep" }; //$NON-NLS-1$
			break;
		case 4:
			// Unix shutdown -h now
			command = new String[] { "shutdown", "-h", "now" }; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			break;
		default:
			return;
		}
		Process p = Runtime.getRuntime().exec(command);
		p.waitFor();
	}

	/**
	 * OS̃o[W𐔒lĕԂ܂B
	 * @return OS̃o[W
	 */
	public static int[] getOsVersion() {
		String v = System.getProperty("os.version", ""); //$NON-NLS-1$ //$NON-NLS-2$
		String[] vers = Tool.split(v, '.', -1);
		int[] result = new int[vers.length];
		for (int i = 0; i < vers.length; i++) {
			try {
				result[i] = Integer.parseInt(vers[i]);
			} catch (NumberFormatException e) {
				result[i] = 0;
			}
		}
		return result;
	}

	/**
	 * vbgtH[\
	 */
	private static String platform;

	/**
	 * vbgtH[\Ԃ܂B(SWT.getPlatform() + '.' + bit)
	 * 
	 * @return vbgtH[\
	 */
	public static String getPlatform() {
		return platform;
	}

	/**
	 * vbgtH[\ݒ肵܂B
	 * 
	 * @param platform vbgtH[\
	 */
	public static void setPlatform(String platform) {
		Os.platform = platform;
	}
}
