package jp.takayuki.tools;

import java.util.Timer;
import java.util.TimerTask;

import jp.takayuki.logging.Logger;

/**
 * ėpTimerTask
 * @author Takayuki Shoji
 */
public class Task extends TimerTask {

	/**
	 * logger
	 */
	private static final Logger logger = Logger.getLogger(Task.class);

	/** R}h */
	private final Runnable task;

	/**
	 * @param task R}h
	 */
	public Task(Runnable task) {
		this.task = task;
	}

	public void run() {
		try {
			task.run();
		} catch (Throwable th) {
			logger.error("Error occurred.", th); //$NON-NLS-1$
		}
	}

	/**
	 * s\񂵂܂B
	 * @param timer ^C}[
	 * @param task ^XN
	 * @param delay x
	 */
	public static void schedule(Timer timer, Runnable task, long delay) {
		timer.schedule(new Task(task), delay);
	}
}
