package jp.takayuki.tools;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import petaclone.swt.SWTMainWindow;

/**
 * ʓIUNIX̃fBNg̈ʒu܂B
 * @author Takayuki Shoji
 */
public class UnixPathResolver extends AbstractPathResolver {

	/**
	 * AvP[Vf[^̃pXƂăz[fBNgԂ܂B
	 * 
	 * @see jp.takayuki.tools.PathResolver#getApplicationData()
	 */
	public File getApplicationData() {
		return getHome();
	}

	/**
	 * hLg̃pXƂăz[fBNgԂ܂B
	 * 
	 * @see jp.takayuki.tools.PathResolver#getMyDocuments()
	 */
	public File getMyDocuments() {
		return getHome();
	}

	/**
	 * z[fBNgԂ܂B
	 * 
	 * @return z[fBNg
	 */
	private File getHome() {
		String home = System.getProperty("user.home"); //$NON-NLS-1$
		return new File(home);
	}

	public String[] getExecutable() {
		File dir = Tool.getProgramDirectory(getClass());
		if (dir == null) {
			return null;
		}

		// jaȑꍇ
		String classLocation = Tool.getClassLocation(SWTMainWindow.class);
		File jarPath = Tool.getJarPath(classLocation);
		if (jarPath != null) {
			List args = new ArrayList();
			args.add(getJavaPath());
			args.add("-jar"); //$NON-NLS-1$
			args.add(jarPath.getAbsolutePath());
			return (String[]) args.toArray(new String[args.size()]);
		}

		List args = new ArrayList();
		args.add(getJavaPath());
		args.add("-cp"); //$NON-NLS-1$
		args.add(System.getProperty("java.class.path")); //$NON-NLS-1$
		args.add(SWTMainWindow.class.getName());
		return (String[]) args.toArray(new String[args.size()]);

	}

	public String getJavaPath() {
		String home = System.getProperty("java.home"); //$NON-NLS-1$
		File f = new File(home, "bin" + File.separatorChar + "java"); //$NON-NLS-1$ //$NON-NLS-2$
		return f.getAbsolutePath();
	}
}
