package jp.takayuki.tools;

import java.io.File;
import java.net.URL;

import petaclone.swt.SWTMainWindow;

/**
 * Windows̃fBNg̈ʒu܂B
 * @author Takayuki Shoji
 */
public class WindowsPathResolver extends AbstractPathResolver {

	/**
	 * @see PathResolver#getApplicationData()
	 */
	public File getApplicationData() {
		String home = System.getProperty("user.home"); //$NON-NLS-1$
		return new File(home, "Application Data"); //$NON-NLS-1$
	}

	/**
	 * @see PathResolver#getMyDocuments()
	 */
	public File getMyDocuments() {
		String home = System.getProperty("user.home"); //$NON-NLS-1$
		return new File(home, "My Documents"); //$NON-NLS-1$
	}

	public String[] getExecutable() {
		// exȅꍇ
		File exe = Tool.getExewrapExecutable();
		if (exe != null) {
			return new String[] { exe.getAbsolutePath() };
		}

		// jaȑꍇ
		String classLocation = Tool.getClassLocation(SWTMainWindow.class);
		File jarPath = Tool.getJarPath(classLocation);
		if (jarPath != null) {
			return new String[] { getJavaPath(), "-jar", //$NON-NLS-1$
					jarPath.getAbsolutePath() };
		}

		// classt@C̏ꍇ
		String cp = System.getProperty("java.class.path"); //$NON-NLS-1$
		return new String[] { getJavaPath(), "-cp", cp, //$NON-NLS-1$
				SWTMainWindow.class.getName() };
	}

	public String getJavaPath() {
		String home = System.getProperty("java.home"); //$NON-NLS-1$
		File f = new File(home, "bin" + File.separatorChar + "javaw.exe"); //$NON-NLS-1$ //$NON-NLS-2$
		return f.getAbsolutePath();
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Tool.saveCurrentDir();
		// eXg̏o̓tH_Ԃ邱Ƃ
		URL url = WindowsPathResolver.class.getResource("/"); //$NON-NLS-1$
		System.out.println(url.toExternalForm());

		WindowsPathResolver r = new WindowsPathResolver();
		System.out.println(r.getApplicationData());
		System.out.println(r.getMyDocuments());
		System.out.println(r.getProgramDirectory());
		String[] executable = r.getExecutable();
		for (int i = 0; i < executable.length; i++) {
			System.out.print(executable[i]);
			System.out.print(" "); //$NON-NLS-1$
		}
		System.out.println();
	}

}
