package jp.takayuki.tools;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import petaclone.AppPreferences;
import extcmd.Restart;

/**
 * ċNƍXVs܂B
 * @author Takayuki Shoji
 */
public class WindowsRestartHelper extends AbstractRestartHelper {

	/**
	 * @param pref ݒ
	 */
	public WindowsRestartHelper(AppPreferences pref) {
		super(pref);
	}

	public void update(File updateFile) throws IOException {

		// J̏ꍇ͍XVȂ
		checkDevelopmentEnvironment();

		PathResolver pathResolver = pref.getPolicy().getPathResolver();

		deleteRestartLog();
		String lockFile = createLockFile();

		Map envp = new HashMap(System.getenv());
		envp.put(Restart.LOG, logFile.getAbsolutePath());
		envp.put(Restart.WATCH_FILE, lockFile);
		String curDir = Tool.getCurrentDirectory();
		envp.put(Restart.BASE_DIR, curDir);
		envp.put(Restart.NEW_FILE, updateFile.getAbsolutePath());
		File installDir = pathResolver.getProgramDirectory();
		if (installDir == null) {
			throw new IOException("Failed to get program directory."); //$NON-NLS-1$
		}
		envp.put(Restart.APP_FOLDER_NAME, "petaclone"); //$NON-NLS-1$
		envp.put(Restart.INSTALL_DIR, installDir);
		String[] restartArgs = pathResolver.getExecutable();
		if (restartArgs == null) {
			throw new IOException("Failed to get restart command."); //$NON-NLS-1$
		}
		for (int i = 0; i < restartArgs.length; i++) {
			envp.put(Restart.RESTART + i, restartArgs[i]);
		}

		// sudo.vbsɖߍޒl
		Map context = new HashMap();
		context.put("executable", pathResolver.getJavaPath()); //$NON-NLS-1$

		// vbssRestartւ̈
		StringBuffer subArgs = new StringBuffer();

		// 0,1: Restart.class̃NXpX
		subArgs.append("-cp "); //$NON-NLS-1$

		subArgs.append("\"\""); //$NON-NLS-1$
		subArgs.append(updateDir.getAbsolutePath());
		subArgs.append("\"\""); //$NON-NLS-1$
		subArgs.append(' ');

		// 2: mainNX "Restart"
		subArgs.append(Restart.class.getName());
		subArgs.append(' ');

		// 3: R}h "update"
		subArgs.append(Restart.CMD_PRIVILEGE_UPDATE);

		// javä
		context.put("args", subArgs.toString()); //$NON-NLS-1$

		// sudo.vbs̍ƃfBNg
		//context.put("workdir", curDir); //$NON-NLS-1$
		context.put("workdir", updateDir.getAbsolutePath()); //$NON-NLS-1$

		File tmpFile = Tool.copyWithReplace(//
				"/sudo.vbs", "sudo", ".vbs", //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
				context, null);

		List args = new ArrayList();

		// 0: sudô߂̃R}h "wscript.exe"
		args.add("wscript.exe"); //$NON-NLS-1$

		// 1: sudo.vbs ̃pX
		args.add(tmpFile.getAbsolutePath());

		for (int i = 0; i < args.size(); i++) {
			envp.put(Restart.PRIVILEGE + i, args.get(i));
		}

		List args2 = getUpdateCommand(pathResolver);

		// s
		writeRestartClass();
		execute(args2, envp);
	}

}
