package petaclone;

import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import java.util.Map.Entry;

/**
 * Cxg̑M𒇉܂B
 * @author Takayuki Shoji
 */
public class EventBrokerImpl implements EventBroker {
	/**
	 * <p>CxgƃCxgXi[XgMap</p>
	 * <p>L[: Cxg String<br>
	 * l: CxgXi[̃Xg Set(l: EventListener)</p>
	 */
	private Map eventMap = new HashMap();

	/**
	 * RXgN^
	 */
	public EventBrokerImpl() {
		//
	}

	/**
	 * @see petaclone.EventBroker#addListener(java.lang.String, petaclone.EventListener)
	 */
	public void addListener(String eventName, EventListener listener) {

		synchronized (eventMap) {
			if (eventMap.containsKey(eventName)) {
				Set listeners = (Set) eventMap.get(eventName);
				listeners.add(listener);

			} else {
				Set listeners = new LinkedHashSet();
				listeners.add(listener);
				eventMap.put(eventName, listeners);

			}
		}
	}

	/**
	 * @see petaclone.EventBroker#removeListener(java.lang.String, petaclone.EventListener)
	 */
	public void removeListener(String eventName, EventListener listener) {
		synchronized (eventMap) {
			Set listeners = (Set) eventMap.get(eventName);
			if (listeners != null) {
				listeners.remove(listener);
			}
		}
	}

	/**
	 * @see petaclone.EventBroker#notifyEvent(java.lang.String, java.lang.Object)
	 */
	public void notifyEvent(String eventName, Object event) {
		synchronized (eventMap) {
			Set listeners = (Set) eventMap.get(eventName);
			if (listeners == null) {
				return;
			}
			Iterator iter = listeners.iterator();
			while (iter.hasNext()) {
				EventListener listener = (EventListener) iter.next();
				listener.listen(eventName, event);
			}
		}
	}

	/**
	 * CX^X𕶎񉻂܂B
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		StringBuffer sb = new StringBuffer("EventBroker{"); //$NON-NLS-1$
		synchronized (eventMap) {
			Iterator iter = eventMap.entrySet().iterator();
			while (iter.hasNext()) {
				Entry entry = (Entry) iter.next();
				sb.append("eventName=").append(entry.getKey()); //$NON-NLS-1$
				sb.append(", Set{"); //$NON-NLS-1$
				Set listeners = (Set) entry.getValue();
				Iterator listenersIter = listeners.iterator();
				while (listenersIter.hasNext()) {
					EventListener listener = (EventListener) listenersIter
							.next();
					sb.append(listener);
					if (listenersIter.hasNext()) {
						sb.append(", "); //$NON-NLS-1$
					}
				}

				sb.append('}');
			}
		}
		sb.append('}');
		return sb.toString();
	}
}
