package petaclone;

import jp.takayuki.tools.HexDump;

/**
 * f[^tH[}bgȂꍇɔOłB
 * 
 * @author Takayuki Shoji
 */
public class InvalidDataFormatException extends RuntimeException {

	/**
	 * serialVersionUID
	 */
	private static final long serialVersionUID = 1L;

	/**
	 * ƂȂf[^
	 */
	private Object data;

	/**
	 * RXgN^
	 * @param message bZ[W
	 */
	public InvalidDataFormatException(String message) {
		super(message);
	}

	/**
	 * RXgN^
	 * @param message bZ[W
	 * @param th OȂ
	 */
	public InvalidDataFormatException(String message, Throwable th) {
		super(message, th);
	}

	/**
	 * RXgN^
	 * @param message bZ[W
	 * @param data ƂȂf[^
	 */
	public InvalidDataFormatException(String message, Object data) {
		super(message);
		this.data = data;
	}

	/**
	 * RXgN^
	 * @param message bZ[W
	 * @param th OȂ
	 * @param data ƂȂf[^
	 */
	public InvalidDataFormatException(String message, Throwable th, Object data) {
		super(message, th);
		this.data = data;
	}

	/**
	 * @see java.lang.Throwable#getMessage()
	 */
	public String getMessage() {
		if (data == null) {
			return super.getMessage();
		}
		String message = super.getMessage();
		if (message == null) {
			return formatData();
		}
		return message + formatData();
	}

	/**
	 * ƂȂf[^tH[}bg܂B
	 * @return 
	 */
	private String formatData() {
		if (data instanceof String) {
			String stringData = (String) data;
			return " data=" + stringData; //$NON-NLS-1$
		} else if (data instanceof char[]) {
			char[] charData = (char[]) data;
			return " data=" + new String(charData); //$NON-NLS-1$
		} else if (data instanceof byte[]) {
			byte[] byteData = (byte[]) data;
			return " data=\n" + HexDump.dump(byteData); //$NON-NLS-1$
		}
		return " data=" + data.toString(); //$NON-NLS-1$
	}

	/**
	 * ƂȂf[^擾܂B
	 * @return ƂȂf[^Bnull̏ꍇB
	 */
	public Object getData() {
		return data;
	}
}
