package petaclone;

import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.net.InetSocketAddress;
import java.net.SocketException;
import java.util.HashSet;
import java.util.Properties;
import java.util.Set;

import jp.takayuki.tools.InetAddressUtils;
import jp.takayuki.tools.PropertiesUtils;

/**
 * N\<br>
 * RXgNgAIDݒ肵ĂB
 * @author Takayuki Shoji
 */
public class LaunchConfiguration implements TableViewable {

	/** ݒ̖O */
	public static final String NAME = "name"; //$NON-NLS-1$

	/** N邩ǂ */
	public static final String IS_VALID = "isValid"; //$NON-NLS-1$

	/** vgR */
	public static final String PROTOCOL = "protocol"; //$NON-NLS-1$

	/** oChAhX */
	public static final String BIND_ADDRESS = "bindAddress"; //$NON-NLS-1$

	/** u[hLXg̃Xg */
	public static final String BROADCAST = "broadcast"; //$NON-NLS-1$

	/** Limited broadcast s */
	public static final String LIMITED_BROADCAST = "limitedBroadcast"; //$NON-NLS-1$

	/** Directed broadcast s */
	public static final String DIRECTED_BROADCAST = "directedBroadcast"; //$NON-NLS-1$

	/** AvP[Ṽu[hLXggp邩ǂ */
	public static final String USE_DEFAULT_BROADCAST = "useDefaultBroadcast"; //$NON-NLS-1$

	/** őo[F󂯓邩ǂ */
	public static final String ACCEPT_SELF_BROADCAST = "acceptSelfBroadcast"; //$NON-NLS-1$

	/** N */
	private static final String ORDER = "launchOrder"; //$NON-NLS-1$

	/** vpeB */
	private Properties prop;

	/** t@CpX */
	private File path;

	/** NID */
	private String id;

	/**
	 * t@C烍[h邽߂̃RXgN^
	 * @param path vpeB[t@Cւ̃pX
	 */
	public LaunchConfiguration(File path) {
		this.path = path;
	}

	/**
	 * Properties^RXgN^
	 * @param prop ev[g̃vpeB[t@C
	 * @param path vpeB[t@Cւ̃pX
	 */
	public LaunchConfiguration(Properties prop, File path) {
		this.path = path;
		this.prop = prop;
	}

	/**
	 * x[XpXIDpX쐬܂B
	 * @param basePath - x[XpX
	 * @param id - id
	 * @return pX
	 */
	public static File makePath(File basePath, String id) {
		StringBuffer sb = new StringBuffer();
		sb.append("launch_").append(id).append(".properties"); //$NON-NLS-1$ //$NON-NLS-2$
		return new File(basePath, sb.toString());
	}

	/**
	 * ǂݍ݂܂B
	 * @throws IOException o͂ŗOꍇ
	 * @throws FileNotFoundException t@C݂Ȃꍇ
	 */
	public void load() throws FileNotFoundException, IOException {
		if (id == null) {
			throw new IllegalStateException("Set ID before load."); //$NON-NLS-1$
		}
		prop = PropertiesUtils.getPropertiesFromFile(path, null);
	}

	/**
	 * vpeBۑ܂B
	 * @throws IOException, FileNotFoundException
	 */
	public void save() throws IOException {
		String header = getId();
		// o̓Xg[p
		FileOutputStream fos = null;
		BufferedOutputStream out = null;
		try {
			fos = new FileOutputStream(path);
			out = new BufferedOutputStream(fos);
			prop.store(out, header);
		} finally {
			if (out != null) {
				out.close();
			} else if (fos != null) {
				fos.close();
			}
		}
	}

	/**
	 * t@C폜܂B
	 */
	public void delete() {
		path.delete();
	}

	/**
	 * @return T[oNȂtrueԂ܂B
	 */
	public boolean getIsValid() {
		return !prop.getProperty(IS_VALID, "1").equals("0"); //$NON-NLS-1$ //$NON-NLS-2$
	}

	/**
	 * @return ID擾܂B
	 */
	public String getId() {
		return id;
	}

	/**
	 * @param id IDݒ肵܂B
	 */
	public void setId(String id) {
		this.id = id;
	}

	/**
	 * T[oN邩ǂݒ肵܂B
	 * @param isValid T[oNȂtrue
	 */
	public void setIsValid(boolean isValid) {
		if (isValid) {
			prop.setProperty(IS_VALID, "1"); //$NON-NLS-1$
		} else {
			prop.setProperty(IS_VALID, "0"); //$NON-NLS-1$
		}
	}

	/**
	 * ݒ̕\擾܂B
	 * @return \
	 */
	public String getName() {
		return prop.getProperty(NAME, "default"); //$NON-NLS-1$
	}

	/**
	 * vgRsignature擾܂B<br>
	 * w肳ĂȂꍇ̓AvP[ṼftHg
	 * @return vgR̎ʎq
	 */
	public String getProtocol() {
		return prop.getProperty(PROTOCOL,
				LaunchConfigurations.DEFAULT_MESSENGER_SIGNATURE);
	}

	/**
	 * oChAhX̔ԍ擾܂B<br>
	 * ݒ肳ĂȂꍇAȏꍇ-1Ԃ܂B
	 * TODO NICɂmȃoChAhX̎w
	 * @return oChAhX̔ԍ
	 */
	public int getBindAddress() {
		String str = prop.getProperty(BIND_ADDRESS);
		if (str == null || str.length() == 0) {
			return -1;
		}
		try {
			return Integer.parseInt(str.trim());
		} catch (NumberFormatException e) {
			return -1;
		}
	}

	/**
	 * őo[F̃u[hLXg󂯓邩ǂ
	 * @return 󂯓ꍇtrue
	 */
	public boolean acceptSelfBroadcast() {
		return PropertiesUtils.getBoolean(prop, ACCEPT_SELF_BROADCAST, true);
	}

	/**
	 * ̑̃vpeB擾܂B
	 * @param key vpeB̃L[
	 * @param defaultValue ftHgl
	 * @return vpeB̒l
	 */
	public String getProperty(String key, String defaultValue) {
		return prop.getProperty(key, defaultValue);
	}

	/**
	 * ̑̃vpeBݒ肵܂B
	 * @param key vpeB̃L[
	 * @param value vpeB̒l
	 */
	public void setProperty(String key, String value) {
		prop.setProperty(key, value);
	}

	/**
	 * vpeB[IuWFNg擾܂B
	 * @return vpeB
	 */
	public Properties getProperties() {
		return prop;
	}

	/**
	 * 񉻂܂B
	 */
	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append("LaunchConfiguration{"); //$NON-NLS-1$
		sb.append("path=").append(path); //$NON-NLS-1$
		sb.append(", id=").append(id); //$NON-NLS-1$
		sb.append(", prop=").append(prop.toString()); //$NON-NLS-1$
		sb.append('}');
		return sb.toString();
	}

	/**
	 * e[uŕ\镶Ԃ܂B
	 */
	public String[] getRowStrings() {
		return new String[] { getName(), getProtocol(), "" }; //$NON-NLS-1$
	}

	/**
	 * oChAhXɉu[hLXgAhX擾܂B
	 * @param pref AvP[Vݒ
	 * @param socketAddress oChς݂̃\Pbg̃[JAhX
	 * @return u[hLXgAhX
	 */
	public InetSocketAddress[] getBroadcastAddresses(AppPreferences pref,
			InetSocketAddress socketAddress) {
		if (PropertiesUtils.getBoolean(prop, USE_DEFAULT_BROADCAST, true)) {
			String[] list = pref.getBroadcastAddresses();
			return stringsToInetSocketAddress(list, socketAddress,
					pref.getLimitedBroadcast(), pref.getDirectedBroadcast());
		}
		// Nݒ̃AhXgp
		String[] addrs = PropertiesUtils.getArray(prop, BROADCAST, false);
		boolean limitedBr = PropertiesUtils.getBoolean(prop, LIMITED_BROADCAST,
				true);
		boolean directedBr = PropertiesUtils.getBoolean(prop,
				DIRECTED_BROADCAST, false);
		return stringsToInetSocketAddress(addrs, socketAddress, limitedBr,
				directedBr);
	}

	/**
	 * InetSocketAddressɕϊAu[hLXgAhXǉ܂B
	 * @param addrs [U[ݒ肵u[hLXgAhX̕
	 * @param socketAddress oChς݂̃\Pbg̃[JAhX
	 * @param limitedBr Limited broadcast sꍇtrue
	 * @param directedBr Directed broadcast sꍇtrue
	 * @return u[hLXgAhX
	 */
	private InetSocketAddress[] stringsToInetSocketAddress(String[] addrs,
			InetSocketAddress socketAddress, boolean limitedBr,
			boolean directedBr) {

		Set set = new HashSet(addrs.length + 5);

		// 255.255.255.255Ȃ
		try {
			InetAddressUtils.addDefaultBroadcastAddress(socketAddress, set,
					limitedBr, directedBr);
		} catch (SocketException e) {
			e.printStackTrace();
		}

		// ݒ
		InetAddressUtils.toInetSocketAddress(addrs, socketAddress.getPort(),
				set);

		return (InetSocketAddress[]) set.toArray(new InetSocketAddress[set
				.size()]);
	}

	/**
	 * NԂ܂B
	 * @return N
	 */
	public int getOrder() {
		return PropertiesUtils.getInt(prop, ORDER, 0);
	}

	/**
	 * Nݒ肵܂B
	 * @param order N
	 */
	public void setOrder(int order) {
		PropertiesUtils.setInt(prop, ORDER, order);
	}
}
