package petaclone;

import java.io.File;
import java.io.IOException;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.Iterator;
import java.util.List;
import java.util.Properties;
import java.util.Set;

import jp.takayuki.logging.Logger;
import jp.takayuki.tools.MessageMap;
import jp.takayuki.tools.PrefixExtensionFilter;

/**
 * N\Ǘ܂B
 * @author Takayuki Shoji
 * ˑ
 * ECXg[ς݂mesengerXg
 * Epolicy̋N\tH_
 * EpolicỹftHgbZW[
 * EEventDistributer(ǂݏ̎s)
 */
public class LaunchConfigurations {

	/**
	 * logger
	 */
	private static final Logger logger = Logger
			.getLogger(LaunchConfigurations.class);

	/**
	 * bZ[W\[X
	 */
	private static final MessageMap mm = MessageMap.getMessageMap();

	/**
	 * t@C̐擪̕
	 */
	private static final String PREFIX = "launch_"; //$NON-NLS-1$

	/**
	 * gq
	 */
	private static final String EXTENSION = ".properties"; //$NON-NLS-1$

	/**
	 * ftHgN\ID
	 */
	private static final String DEFAULT = "default2"; //$NON-NLS-1$

	/**
	 * ftHgN\ID
	 */
	private static final String DEFAULT_OLD = "default"; //$NON-NLS-1$

	/**
	 * ۂɋN郊XgB<br>
	 * l: LaunchConfiguration
	 */
	private List startups = new ArrayList();

	/**
	 * CX^XƂ̃vpeB<br>
	 * N\ɍڂĂׂ̂āB
	 * ۂɋNĂ郁bZW[Ƃ͈v܂B<br>
	 * l: LaunchConfiguration
	 */
	private List confs = new ArrayList();

	/**
	 * N\fBNg
	 */
	private File configDirectory;

	/** ftHgbZW[̃ftHgl */
	public static final String DEFAULT_MESSENGER_SIGNATURE = "ipmsg"; //$NON-NLS-1$

	/**
	 * s̃ftHgbZW[ID
	 */
	private String defaultMessengerId;

	/**
	 * RXgN^
	 * @param configDirectory N\fBNg
	 */
	public LaunchConfigurations(File configDirectory) {
		assert configDirectory != null;
		assert configDirectory.isDirectory();

		this.configDirectory = configDirectory;
		this.defaultMessengerId = DEFAULT_MESSENGER_SIGNATURE;
	}

	/**
	 * N郊Xg擾܂B
	 * @return Xg, l: LaunchConfiguration
	 */
	public List getStartups() {
		return startups;
	}

	/**
	 * ێĂNݒ̃Xg擾܂B
	 * @return Nݒ̃Xg(l: LaunchConfiguration)
	 */
	public List getConfigurations() {
		return confs;
	}

	/**
	 * e`FbNȂN\[h܂B
	 * 
	 * MessengerFacadeɃCXg[ς݃bZW[ǉ
	 * ĂяoKv܂B
	 * ܂AstartupLaunchConfigurationsɎۂɋN
	 * N\[h܂B
	 * @param createDefault Nݒt@CPAftHg̋Nݒ𐶐ꍇtrue
	 * @param installed CXg[ς݃bZW[
	 */
	public void loadLaunchConfigurations(boolean createDefault, Set installed) {
		assert confs != null;
		assert startups != null;

		// N\̃Xg𓾂
		File[] files = this.configDirectory
				.listFiles(new PrefixExtensionFilter(PREFIX, EXTENSION));

		for (int i = 0; i < files.length; i++) {
			File path = files[i];
			String name = path.getName();

			if (files.length >= 2 && isOldDefault(name)) {
				/*
				 * ݂ꍇ́ALɂƐݒ肪\
				 * ߁AftHgNݒNݒƂĂ͖
				 * OɕύXB
				 * ɂAJX^}CYNݒ폜ꍇ
				 * ftHgNݒ肪Ӑ}邱ƂȂB
				 */
				File dest = new File(path.getParentFile(), path.getName()
						+ ".back"); //$NON-NLS-1$
				path.renameTo(dest);
				logger.info("Renamed old default launch " //$NON-NLS-1$
						+ "configuration file to ineffective name."); //$NON-NLS-1$
				continue;

			} else if (files.length == 1 && isOldDefault(name)) {
				/*
				 * t@C1̂Ƃ̓t@C(ID)
				 * VftHgt@CɕύX邱Ƃ
				 * 񂩂ʏ̋N\ƂĈB
				 */
				File dest = LaunchConfiguration.makePath(this.configDirectory,
						DEFAULT);
				path.renameTo(dest);
				path = dest;
				name = dest.getName();
				logger.info("Renamed old default launch " //$NON-NLS-1$
						+ "configuration file to valid name."); //$NON-NLS-1$
				// 
			}

			// Nݒǂݍ
			LaunchConfiguration conf = new LaunchConfiguration(path);

			// t@CɋNIDݒ
			String id = getId(name);
			conf.setId(id);
			try {
				conf.load();
			} catch (IOException e) {
				logger.error("Failed to load launch configuration. path=" //$NON-NLS-1$
						+ path + ",ID=" + id, e); //$NON-NLS-1$
				// TODO G[Cxgʒm
				//errorDialog("N\̃[hɎs܂B\nID: " + confIds[i]);
				continue;
			}

			if (!installed.contains(conf.getProtocol())) {
				// CXg[ĂȂ̂Ŗ
				continue;
			}

			// N\Xgɓo^
			confs.add(conf);

			// NL
			if (!conf.getIsValid()) {
				continue;
			}
			// ۂɋN郊Xgɓo^
			startups.add(conf);
		}

		if (false && createDefault && files.length == 0) {
			/*
			 * NŁANݒt@C
			 * 1ꍇ̓ftHgNݒ쐬
			 */
			LaunchConfiguration defaultConf = createDefaultLaunchConfiguration();

			confs.add(defaultConf);
			startups.add(defaultConf);
			logger.info("Default launch configuration was created."); //$NON-NLS-1$
		}

		// NɃ\[g
		Comparator comp = new LaunchConfigurationComparator();
		Collections.sort(confs, comp);
		Collections.sort(startups, comp);
	}

	/**
	 * ݒ胊XgNXgă[h܂B
	 * <p>
	 * NpEBU[hpB
	 */
	public void reloadStartups() {
		startups.clear();
		for (int i = 0; i < confs.size(); i++) {
			LaunchConfiguration conf = (LaunchConfiguration) confs.get(i);
			if (conf.getIsValid())
				startups.add(conf);
		}
	}

	/**
	 * ftHgNݒ쐬܂B
	 * @return Nݒ
	 */
	private LaunchConfiguration createDefaultLaunchConfiguration() {
		Properties prop = new Properties();
		prop.setProperty("name", mm.get("LaunchConfigurations.default")); //$NON-NLS-1$ //$NON-NLS-2$
		prop.setProperty("protocol", this.defaultMessengerId); //$NON-NLS-1$
		File path = LaunchConfiguration.makePath(this.configDirectory, DEFAULT);
		LaunchConfiguration defaultConf = new LaunchConfiguration(prop, path);
		defaultConf.setId(DEFAULT);
		return defaultConf;
	}

	/**
	 * N\̔rs
	 */
	private static class LaunchConfigurationComparator implements Comparator,
			Serializable {
		/**
		 * serialVersionUID
		 */
		private static final long serialVersionUID = 1L;

		/**
		 * @see Comparator#compare(Object, Object)
		 */
		public int compare(Object o1, Object o2) {
			LaunchConfiguration launch1 = (LaunchConfiguration) o1;
			LaunchConfiguration launch2 = (LaunchConfiguration) o2;
			return launch1.getOrder() - launch2.getOrder();
		}
	}

	/**
	 * vtBbNXƊgqID擾܂B
	 * @param name t@C
	 * @return NID
	 */
	private String getId(String name) {
		return name.substring(PREFIX.length(), name.length()
				- EXTENSION.length());
	}

	/**
	 * ftHg̋Nݒ̏ꍇtrueԂ܂B
	 * @param name t@C
	 * @return ftHg̃t@C̏ꍇtrueAȊOfalseB
	 */
	private boolean isOldDefault(String name) {
		return name.equals(PREFIX + DEFAULT_OLD + EXTENSION);
	}

	/**
	 * Nݒۑ܂B
	 * ۑꏊ͋NLaunchConfigurationɐݒ肳܂B
	 * @throws IOException ۑłȂꍇ
	 */
	public void saveLaunchConfigurations() throws IOException {
		Iterator itr = confs.iterator();
		// N
		int order = 1;
		while (itr.hasNext()) {
			LaunchConfiguration conf = (LaunchConfiguration) itr.next();
			conf.setOrder(order);
			order++;
			conf.save();
		}
	}

	/**
	 * j[NID𐶐܂B(System.currentTimeMillis())
	 * @return System.currentTimeMillis()
	 */
	public static String generateId() {
		return Long.toString(System.currentTimeMillis(), 16);
	}
}
