package petaclone;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;

import jp.takayuki.logging.Logger;
import jp.takayuki.tools.Tool;

/**
 * o[ǗBNo[Ao^o[̃Xgێ܂B<br>
 * MembersListenero^AǉAXVA폜̃Cxg󂯎邱Ƃł܂B<br>
 * BaseMaiñvpeB[𗘗p̂ŃvpeB̏ɃRXgNg܂B
 * @author Takayuki Shoji
 */
public class Members {

	/**
	 * logger
	 */
	private static final Logger logger = Logger.getLogger(Members.class);

	/**
	 * ݒ
	 */
	private AppPreferences pref;

	/**
	 * u悭vo^o[B
	 * }bv̌`<br>
	 * L[: UniqueMember#getComputerName()<br>
	 * l: UniqueMember<br>
	 * lUniqueMemberuniqueMembersclone()܂B
	 * ăvgRL܂B
	 * <p>
	 * L[͑啶ŊǗ܂B
	 * <p>
	 * registeredMembers͓̑̂o^_CAO
	 * o^ƂƑM_CAOœo^Ƃ݂̂A
	 * ̃^C~Odelete()Ăяo邱Ƃ̂
	 * XbhZ[tłKvB
	 */
	private HashMap registeredMembers;

	/**
	 * registeredMembers܂ނׂĂUniqueMemberB
	 * }bv̌`<br>
	 * L[: UniqueMember.getIdentifier()<br>
	 * l: UniqueMember
	 */
	private HashMap uniqueMembers;

	/**
	 * ύXʒm郊Xi[̃Xg<br>
	 * l: MembersListener<br>
	 */
	private ArrayList listeners;

	/**
	 * RXgN^<br>
	 * C̃vpeB𗘗p܂B
	 * @param pref ݒ
	 */
	public Members(AppPreferences pref) {
		this.pref = pref;
		this.registeredMembers = new HashMap();
		this.uniqueMembers = new HashMap();
		this.listeners = new ArrayList();

		loadRegisteredMembers();
		initUniqueMembers();
	}

	/**
	 * registeredMembersuniqueMembersclone()܂B
	 * эČŎgp܂B
	 */
	public void initUniqueMembers() {
		synchronized (uniqueMembers) {
			uniqueMembers.clear();
			Iterator itr = registeredMembers.values().iterator();
			while (itr.hasNext()) {
				UniqueMember um = (UniqueMember) itr.next();
				uniqueMembers.put(um.getComputerName(), um.clone());
			}
			assert registeredMembers.size() == uniqueMembers.size();
		}
	}

	/**
	 * Xi[ǉ܂B
	 * @param listener ǉ郊Xi[
	 */
	public void addListener(MembersListener listener) {
		synchronized (this.listeners) {
			this.listeners.add(listener);
		}
	}

	/**
	 * Xi[폜܂B
	 * @param listener 폜郊Xi[
	 */
	public void removeListener(MembersListener listener) {
		synchronized (this.listeners) {
			this.listeners.remove(listener);
		}
	}

	/**
	 * u悭vXgǂݍ݂܂B
	 * <br>
	 * ݂̓vpeBɃJ}؂ŕۑĂ܂B
	 * <br>[U[:OC:Rs[^:O[v,<br>
	 * eڂ%charlŋL^܂B
	 */
	private void loadRegisteredMembers() {
		String reg = pref.getRegisteredMembers();
		if (reg.length() == 0) {
			return;
		}

		String[] list = Tool.split(reg, ',', 0);
		//System.out.println("list.length" + list.length);
		for (int i = 0; i < list.length; i++) {
			String[] encoded = Tool.split(list[i], ':', 0);

			//System.out.println("encoded.length" + encoded.length);
			if (encoded.length < 4) {
				continue;
			}
			UniqueMember member = new UniqueMember(null);
			// [U[
			member.setUserName(Tool.decode(encoded[0]));
			// OC
			member.setOsUserName(Tool.decode(encoded[1]));
			// Rs[^
			member.setComputerName(Tool.decode(encoded[2]));
			// O[v
			member.setGroup(Tool.decode(encoded[3]));

			// o^
			registeredMembers.put(member.getComputerName(), member);

			//System.out.println("o^o[" + member.toString());
		}
	}

	/**
	 * u悭vXgۑ(vpeBɃZbg)܂B
	 */
	public void saveRegisteredMembers() {
		StringBuffer result = new StringBuffer();

		synchronized (uniqueMembers) {
			Iterator itr = registeredMembers.values().iterator();
			while (itr.hasNext()) {
				UniqueMember um = (UniqueMember) itr.next();
				result.append(um.toEncodedString());
				if (itr.hasNext()) {
					result.append(',');
				}
			}
		}

		//System.out.println(result.toString());
		pref.setRegisteredMembers(result.toString());
	}

	/**
	 * NĂo^o[̃XgԂ܂B
	 * u悭vj[pB
	 * <p>
	 * IPAhXFĂKv̂ŁA
	 * uniqueMembersCX^X擾܂B
	 * 
	 * @return UniqueMemberListB
	 */
	public List getLivingRegisteredMembers() {
		List list = new ArrayList();

		synchronized (uniqueMembers) {
			Iterator iter = uniqueMembers.values().iterator();
			while (iter.hasNext()) {
				UniqueMember um = (UniqueMember) iter.next();
				if (um.getStatus() != UniqueMember.OFFLINE && isRegistered(um)) {
					list.add(um);
				}
			}
		}

		return list;
	}

	/**
	 * O[vɏ郁o[̃XgԂ܂B
	 * O[vɏĂȂꍇ͋̃XgԂ܂B
	 * v郁o[Ȃꍇ̃XgԂ܂B
	 * @param max Ԃő吔B̒lw肷ƂׂĂԂ܂B
	 * @return UniqueMemberListB
	 */
	public List getLivingGroupMembers(int max) {
		List list = new ArrayList();
		if (max == 0) {
			return list;
		}
		if (max < 0) {
			max = Integer.MAX_VALUE;
		}
		String myGroup = pref.getGroupName();

		// O[vɏĂȂꍇ͋̃XgԂB
		if (myGroup == null || myGroup.length() == 0) {
			return list;
		}

		synchronized (uniqueMembers) {
			int count = 0;
			Iterator itr = uniqueMembers.values().iterator();
			while (itr.hasNext()) {
				if (count > max) {
					break;
				}
				UniqueMember um = (UniqueMember) itr.next();
				if (um.getStatus() == UniqueMember.OFFLINE) {
					continue;
				}
				if (myGroup.equalsIgnoreCase(um.getGroup())) {
					list.add(um);
					count++;
				}
			}
		}
		return list;
	}

	/**
	 * So[擾܂B<br>
	 * M_CAOĂяo܂B
	 * @return So[̔z
	 */
	public UniqueMember[] getAllMembers() {
		synchronized (uniqueMembers) {
			return (UniqueMember[]) uniqueMembers.values().toArray(
					new UniqueMember[uniqueMembers.size()]);
		}
	}

	/**
	 * uniqueMembersɑ݂ȂtrueԂ܂B
	 * @param identifier o[ʎq
	 * @return ݂Ȃtrue
	 */
	public boolean exists(String identifier) {
		synchronized (uniqueMembers) {
			return uniqueMembers.containsKey(identifier);
		}
	}

	/**
	 * registeredMembersɑ݂ȂtrueԂ܂B
	 * @param um o[
	 * @return o^Ătrue
	 */
	public boolean isRegistered(UniqueMember um) {
		synchronized (uniqueMembers) {
			return registeredMembers.containsKey(um.getComputerName());
		}
	}

	/**
	 * So[擾܂B
	 * @param identifier o[ʎq
	 * @return o[̏
	 */
	public UniqueMember get(String identifier) {
		synchronized (uniqueMembers) {
			return (UniqueMember) uniqueMembers.get(identifier);
		}
	}

	/**
	 * o^o[擾܂B
	 * @param um o[
	 * @return o[̏
	 */
	public UniqueMember getRegistered(UniqueMember um) {
		synchronized (uniqueMembers) {
			return (UniqueMember) registeredMembers.get(um.getComputerName());
		}
	}

	/**
	 * o^o[̒ǉύX̔fs܂B<br>
	 * o^_CAOĂяo܂B
	 * MembersListeneřĂяo: L
	 * @param member o^郁o[
	 */
	public void register(UniqueMember member) {

		synchronized (uniqueMembers) {
			// o^
			String computerName = member.getComputerName();
			registeredMembers.put(computerName, member);

			// uniqueMembers̍XV
			String id = member.getIdentifier();
			// o^ȊOregisteredMembersRȂ̂idɃRs[^Ԃ
			UniqueMember um = get(id);
			if (um == null) {
				/*
				 * łɔFĂuniqueMembers̃L[IPAhXɂȂ
				 * registeredMembers̃L[łRs[^
				 * }b`Ȃ߁ARs[^ŒTB
				 */
				Iterator itr = uniqueMembers.values().iterator();
				while (itr.hasNext()) {
					UniqueMember m = (UniqueMember) itr.next();
					if (m.getComputerName().equals(computerName)) {
						um = m;
						break;
					}
				}
			}

			if (um != null) {
				// ݂ꍇ͕Kvȕf
				updateRegisteredMember(member, um);
				return;
			}

			// ݂Ȃ̂clone()
			um = (UniqueMember) member.clone();
			uniqueMembers.put(id, um);
			// \̍XV
			notifyListenerToNew(um);
		}
	}

	/**
	 * o^ς݂̃o[XV܂B
	 * @param editted ҏW̃o[
	 * @param um ŊǗĂ郁o[̃CX^X
	 */
	private void updateRegisteredMember(UniqueMember editted, UniqueMember um) {
		assert um != editted;
		// [U[
		if (um.getUserName() == null || um.getUserName().length() == 0
				|| um.getMessengerCount() == 0 || pref.useRegisteredUserName()) {
			// [U[
			// ܂͓o^pPbg󂯂ƂĂȂ
			// ܂͓o^ꂽ[U[D悷Ƃ
			um.setUserName(editted.getUserName());
		}
		// O[v
		if (um.getGroup() == null || um.getGroup().length() == 0
				|| um.getMessengerCount() == 0 || pref.useRegisteredGroupName()) {
			// O[vD悷Ƃ
			um.setGroup(editted.getGroup());
		}
		// \̍XV
		notifyListenerToUpdate(um);
	}

	/**
	 * o^܂B<br>
	 * MembersListeneřĂяo: L
	 * @param member o[
	 */
	public void unregister(UniqueMember member) {
		synchronized (uniqueMembers) {

			// o^o[
			String computerName = member.getComputerName();
			registeredMembers.remove(computerName);

			// So[
			String id = member.getIdentifier();
			UniqueMember um = get(id);
			if (um != null) {
				if (um.getMessengerCount() == 0) {
					// f[^폜
					uniqueMembers.remove(id);
					// \XV
					notifyListenerToDelete(um);
				}
			} else {
				// Rs[^Ō
				um = get(computerName);

				// f[^폜
				uniqueMembers.remove(computerName);
				// \XV
				notifyListenerToDelete(um);
			}
			// ύX𔽉fĂ
			saveRegisteredMembers();
		}
	}

	/**
	 * e[uɐVR[h܂B
	 * ܂͂łɑ݂ꍇ͏XV܂B<br>
	 * T[oXi[Ăяo܂B
	 * MembersListeneřĂяo: L
	 * @param member ǉ郁o[
	 */
	public void add(Member member) {
		if (logger.isInfoEnabled())
			logger.info("start adding member:" + member); //$NON-NLS-1$

		/*
		 * sŖ肪̂ŁA
		 * idcomputerName͂Ŏ擾ĂB
		 */
		String computerName = member.computerName;
		String id = member.getIdentifier();

		synchronized (uniqueMembers) {
			int regCount = uniqueMembers.size();

			UniqueMember um = get(id);
			if (um != null) {
				// łɃXgɍڂĂ̂ŃvgRǉ
				updateUserAndGroup(member, um);
				assert regCount == uniqueMembers.size();
				return;
			}

			// idŃXgɍڂĂȂAo^ĂƂ
			// L[Rs[^IPAhXɕύX
			um = (UniqueMember) uniqueMembers.remove(computerName);
			if (um != null) {
				uniqueMembers.put(id, um);
				updateUserAndGroup(member, um);

			} else {
				// e[uɐVǉ
				um = new UniqueMember(member);
				uniqueMembers.put(id, um);
				// \̍XV
				notifyListenerToNew(um);
				assert regCount == uniqueMembers.size() - 1;
			}
		}
	}

	/**
	 * [UƃO[vXV܂B
	 * @param member V
	 * @param um XVUniqueMember
	 */
	private void updateUserAndGroup(Member member, UniqueMember um) {
		um.addMessenger(member);
		// [U[
		if (!pref.useRegisteredUserName()) {
			um.setUserName(member.userName);
		}
		// O[v
		if (member.group != null && !pref.useRegisteredGroupName()) {
			um.setGroup(member.group);
		}

		// UIXV
		notifyListenerToUpdate(um);
	}

	/**
	 * <p>e[u烌R[h폜܂B<br>
	 * T[oXi[Ăяo܂B</p>
	 * 
	 * <p>MembersListeneřĂяo: L</p>
	 * 
	 * @param member 폜郁o[
	 */
	public void delete(Member member) {
		String id = member.getIdentifier();

		synchronized (uniqueMembers) {

			int regCount = uniqueMembers.size();
			if (!exists(id)) {
				// ݂Ȃ
				return;
			}
			// ݂
			UniqueMember um = get(id);
			if (um.getMessengerCount() <= 1 && !isRegistered(um)) {
				// o^o[̓e[uȂ
				// ׂẴvgRpłȂo^o[̓e[u폜
				uniqueMembers.remove(id);
				// \̍XV
				notifyListenerToDelete(um);
				assert regCount == uniqueMembers.size() + 1;
				return;
			}
			// vgR폜
			um.removeMessenger(member);
			// Xe[^XACR̕ύX
			notifyListenerToUpdate(um);
			// vgR폜̂Ńo[͕ςȂ
			assert regCount == uniqueMembers.size();
		}
	}

	/**
	 * Xi[̒ǉ\bhĂяo܂B
	 * @param um ǉꂽo[
	 */
	private void notifyListenerToNew(UniqueMember um) {
		synchronized (this.listeners) {
			Iterator itr = listeners.iterator();
			while (itr.hasNext()) {
				MembersListener listener = (MembersListener) itr.next();
				listener.newMember(um);
			}
		}
	}

	/**
	 * Xi[̍XV\bhĂяo܂B
	 * @param um XVꂽo[
	 */
	private void notifyListenerToUpdate(UniqueMember um) {
		synchronized (this.listeners) {
			Iterator itr = listeners.iterator();
			while (itr.hasNext()) {
				MembersListener listener = (MembersListener) itr.next();
				listener.updateMember(um);
			}
		}
	}

	/**
	 * Xi[̍폜\bhĂяo܂B
	 * @param um 폜ꂽo[
	 */
	private void notifyListenerToDelete(UniqueMember um) {
		synchronized (this.listeners) {
			Iterator itr = listeners.iterator();
			while (itr.hasNext()) {
				MembersListener listener = (MembersListener) itr.next();
				listener.deleteMember(um);
			}
		}
	}

	/**
	 * Ԃ𕶎񉻂܂B
	 */
	public String toString() {
		StringBuffer sb = new StringBuffer("Members{"); //$NON-NLS-1$
		sb.append("pref ").append(pref == null ? "== null" : "!= null"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		sb.append(", listeners.size()=").append(listeners.size()); //$NON-NLS-1$
		synchronized (uniqueMembers) {
			sb.append(", registeredMembers=").append(registeredMembers); //$NON-NLS-1$
			sb.append(", uniqueMembers=").append(uniqueMembers); //$NON-NLS-1$

		}
		sb.append('}');
		return sb.toString();
	}
}
