package petaclone;

import java.io.BufferedWriter;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.io.Writer;
import java.net.InetAddress;
import java.net.UnknownHostException;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Collection;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Locale;
import java.util.Map.Entry;
import java.util.TimeZone;
import java.util.TreeSet;
import java.util.Vector;
import java.util.regex.Matcher;

import jp.takayuki.tools.MessageMap;
import jp.takayuki.tools.Tool;

/**
 * bZ[WB
 * @author Takayuki Shoji
 */
public class Message implements Comparable, TableViewable {

	/**
	 * bZ[W\[X
	 */
	private static final MessageMap mm = MessageMap.getMessageMap();

	/**
	 * pPbgԍ܂̓bZ[WIDB
	 * MOɐݒ肵܂B
	 */
	public int id;

	/** bZ[W^CvBʏAJʒm */
	public int messageType;

	/** messageType: bZ[W */
	public static final int MESSAGE = 1;

	/** messageType: Jʒm */
	public static final int OPEN_NOTICE = 2;

	/** messageType: ̑ */
	public static final int TYPE_OTHER = -1;

	/** MAMAԐM */
	public int messageClass;

	/** messageClass: VKMpbZ[W */
	public static final int SEND = 0;

	/** messageClass: ԐMpbZ[W */
	public static final int REPLY = 1;

	/** messageClass: MbZ[W */
	public static final int RECEIVED = 2;

	/** messageClass: MbZ[W(\ۗ) */
	public static final int PENDING = 3;

	/** }`LXgbZ[W */
	public boolean isMulticast;

	/** ۑς݂ */
	public boolean isSaved;

	/** Jς݂ */
	public boolean isOpened;

	/** JɃpX[hKv */
	public boolean isPasswordRequired;

	/** fXNgbvŕ\(ۑƂɑ삷邱) */
	public boolean desktop;

	/** Í̎(M̂) */
	public String encryptMethod;

	/**
	 * EBhẼ[h(WINDOW_*)
	 */
	public int windowMode;

	/** windowMode: 0=ʏ(ftHg) */
	public static final int WINDOW_DEFAULT = 0;

	/** windowMode: 1=ƗEBhE[h */
	public static final int WINDOW_INDEPENDENT = 1;

	/** windowMode: 2=ƗɍőOʂɕ\ */
	public static final int WINDOW_INDEPENDENT_ONTOP = 2;

	///////////////////////
	// {
	///////////////////////
	/**
	 * MBeLXgƂĔr\B
	 * `2003/06/12 09:55:03 GMTB
	 * `GMTœꂵA\ۂ̓[J^Cɕϊ܂B
	 */
	public String time;

	/** MAhX(MbZ[Wł̂ݎgp) */
	public String ipAddress;

	/** MRs[^ */
	public String computerName;

	/** M|[g */
	public int port;

	/** OS̃OC */
	public String osUserName;

	/** bZW[̃[U[ */
	public String userName;

	/** bZ[W{ */
	public String message = ""; //$NON-NLS-1$

	///////////////////////
	// Ytt@C
	///////////////////////
	/**
	 * Ytt@C<br>
	 * YtĂȂꍇnull<br>
	 * l: Attachment
	 */
	public ArrayList attachments;

	///////////////////////
	// vgR
	///////////////////////
	/**
	 * vgRƎ̏ۑ܂B
	 */
	private HashMap ext = new HashMap();

	/**
	 * vgRsignatureB
	 * messenger؂ւ蕜邽߂Ɏgp܂B
	 */
	public String protocol;

	/**
	 * MɎgpNݒIDłB
	 */
	public String launchId;

	///////////////////////
	// ԐMAML^
	///////////////////////
	/** ԐM */
	public Message replyFrom;

	/**
	 * ML^<br>
	 * l: Destination
	 */
	private Vector destinations;

	///////////////////////
	// EBhE
	///////////////////////
	/** EBhE̊e평l\萔 */
	public final static int IMPOSSIBLE = Integer.MIN_VALUE;

	/** EBhE̍̍W */
	public int windowLeft = IMPOSSIBLE;

	/** EBhȄ̍W */
	public int windowTop = IMPOSSIBLE;

	/** EChẺ */
	public int width = IMPOSSIBLE;

	/** EChE̍ */
	public int height = IMPOSSIBLE;

	/**
	 * EBhE̕\X^C
	 */
	public int windowStyle;

	/** windowStyle: bZ[W\ */
	public static final int FRONT = 0;

	/** windowStyle: Ԃ */
	public static final int BACK = 1;

	/** windowStyle: ACR\ */
	public static final int ICON = 2;

	/** windowStyle: 1s\ */
	public static final int ONE_LINE = 3;

	/** windowStyle: QRR[h\ */
	public static final int QR_CODE = 4;

	/** windowStyle: tⳎ\ */
	public static final int STICKY = 5;

	/**
	 * eLXg{bNX̑I͈(Jn)
	 */
	public int selectionStart = 0;

	/**
	 * eLXg{bNX̑I͈(I)
	 */
	public int selectionEnd = 0;

	/**
	 * eLXg{bNX1sڂɕ\Ăsԍ
	 */
	public int topIndex = 0;

	/**
	 * EBhE̓x
	 */
	public int alpha = 255;

	/**
	 * FBr,g,bBnull̂ƂAVXeftHgB
	 */
	public int[] color;

	/**
	 * Ytt@CgC̃EFCg
	 */
	public int[] trayRatio;

	/**
	 * ACR\œYt摜\ꍇɓ{\s
	 */
	public boolean magnification;

	/**
	 * tⳎ̔zF
	 */
	public MessageColorScheme colorScheme;

	/**
	 * RXgN^
	 */
	public Message() {
		messageType = MESSAGE;
	}

	/**
	 * VKMpɏ郆[eBeB\bhB
	 */
	public void initialNewMessage() {
		this.messageClass = SEND;
		this.isOpened = true;
		this.windowStyle = FRONT;
	}

	/**
	 * JԂ̃bZ[Wɏ郆[eBeB\bhB
	 * MbZ[WpB
	 */
	public void initialOpened() {
		this.messageClass = PENDING;
		this.isOpened = true;
		this.windowStyle = FRONT;
	}

	/**
	 * JԂ̃bZ[Wɏ郆[eBeB\bhB
	 * MbZ[WpBy^낤͂B
	 */
	public void initialSealed() {
		this.messageClass = PENDING;
		this.isOpened = false;
		this.windowStyle = BACK;
	}

	/**
	 * Fɂ܂B
	 */
	public void setForegroundBlue() {
		this.color = new int[] { 0, 0, 255 };
	}

	/**
	 * ԐMpMessageԂ܂B<br>
	 * Đ͌Őݒ肵܂B
	 * <p>
	 * ԐMEBhE[hp܂B
	 * 
	 * @param quote pBpȂꍇnullB
	 * @param insertNewLineToHead 擪ɉs2
	 * @return ԐMpbZ[W
	 */
	public Message createReplyMessage(String quote, boolean insertNewLineToHead) {
		Message result = new Message();
		result.messageClass = REPLY;
		result.isOpened = true;
		result.windowStyle = FRONT;
		result.replyFrom = this;
		result.windowMode = this.windowMode;

		// vgR֌W
		result.launchId = this.launchId;
		result.protocol = this.protocol;

		// bZ[Ẅp
		if (quote != null)
			result.message = getQuotedMessage(quote, insertNewLineToHead);

		return result;
	}

	/**
	 * tⳎ\p̕s܂B
	 * 
	 * @return ꂽbZ[W
	 */
	public Message duplicateForSticky() {
		Message result = new Message();
		result.initialNewMessage();
		result.windowStyle = STICKY;

		result.windowMode = this.windowMode;

		// ʒuƃTCY
		result.windowLeft = this.windowLeft + 24;
		result.windowTop = this.windowTop + 24;

		result.width = this.width;
		result.height = this.height;

		result.alpha = this.alpha;

		// {֘A
		result.message = this.message;
		result.selectionStart = this.selectionStart;
		result.selectionEnd = this.selectionEnd;

		// tⳊ֘A
		if (colorScheme != null) {
			result.colorScheme = colorScheme.duplicate();
		}

		return result;
	}

	/**
	 * @return [U[ʎqԂ܂B
	 */
	public String getIdentifier() {
		//return this.computerName.toUpperCase();
		return this.ipAddress;
	}

	/**
	 * @return `̃[U[ʎqԂ܂B
	 */
	public String getIdentifierLong() {
		StringBuffer sb = new StringBuffer(osUserName);
		sb.append('@').append(ipAddress);
		return sb.toString().toUpperCase();
	}

	/**
	 * vgRƎ̊g擾܂B
	 * @param key g̃L[
	 * @param defaultValue ftHgl
	 * @return L[ɑ΂l
	 */
	public String getExt(String key, String defaultValue) {
		if (!ext.containsKey(key)) {
			return defaultValue;
		}
		return (String) ext.get(key);
	}

	/**
	 * vgRƎ̊gݒ肵܂B
	 * @param key g̃L[
	 * @param value l
	 */
	public void setExt(String key, String value) {
		ext.put(key, value);
	}

	/**
	 * vgRƎ̊g̕\Ԃ܂B
	 * @return g̕\
	 */
	private String getExtString() {
		if (ext.isEmpty()) {
			return ""; //$NON-NLS-1$
		}

		StringBuffer sb = new StringBuffer();
		Iterator itr = ext.entrySet().iterator();
		while (itr.hasNext()) {
			Entry entry = (Entry) itr.next();
			sb.append("  ").append(entry.getKey()); //$NON-NLS-1$
			sb.append(": ").append(entry.getValue()).append('\n'); //$NON-NLS-1$
		}
		return sb.toString();
	}

	/**
	 * ڍ׃_CAOp̕Ԃ܂B
	 * @return \p
	 */
	public String getDetailString() {
		if (this.messageClass != RECEIVED) {
			return getMessageSizeInfo();
		}

		String method;
		if (encryptMethod == null) {
			method = mm.get("Message.info.encryptMethod.null"); //$NON-NLS-1$
		} else {
			method = encryptMethod;
		}

		Object[] arg = new Object[] {
		//
				// Rs[^
				computerName,
				// IPAhX
				ipAddress,
				// bZ[WID
				new Integer(id),
				// 񑗐M
				Boolean.valueOf(isMulticast),
				// Í@
				method,
				// bZ[W
				getMessageSizeInfo(),
				// g
				getExtString() };
		return mm.get("Message.info.from", arg); //$NON-NLS-1$
	}

	/**
	 * bZ[WTCYɊւ镶擾܂B
	 * @param utf8 UTF-8
	 * @return TCY񕶎
	 */
	private String getMessageSizeInfo() {
		try {
			String sysEnc = System.getProperty("file.encoding"); //$NON-NLS-1$

			Integer wholeCharLen = new Integer(message.length());
			Integer wholeBytes = new Integer(message.getBytes().length);
			Integer wholeUtf8 = new Integer(message.getBytes("UTF-8").length); //$NON-NLS-1$

			Integer selCharLen = new Integer(0);
			Integer selBytes = selCharLen;
			Integer selUtf8 = selCharLen;

			String selection = getSelectedText();
			if (selection != null) {
				selCharLen = new Integer(selection.length());
				selBytes = new Integer(selection.getBytes().length);
				selUtf8 = new Integer(selection.getBytes("UTF-8").length); //$NON-NLS-1$
			}
			return mm.get("Message.info.length", //$NON-NLS-1$
					new Object[] { sysEnc, wholeCharLen, wholeBytes, wholeUtf8,
							selCharLen, selBytes, selUtf8 });
		} catch (UnsupportedEncodingException e) {
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @see java.lang.Comparable#compareTo(Object)
	 */
	public int compareTo(Object obj) {
		Message msg = (Message) obj;
		return this.time.compareTo(msg.time);
	}

	/**
	 * MInetAddressԂ܂B
	 * IPAhXARs[^̏InetAddressϊ܂B
	 * @return MInetAddress
	 * @throws UnknownHostException 
	 */
	public InetAddress getAddress() throws UnknownHostException {
		try {
			return InetAddress.getByName(this.ipAddress);
		} catch (UnknownHostException e) {
			return InetAddress.getByName(this.computerName);
		}
	}

	/**
	 * EBhE\v񕶂擾܂B
	 * <p>
	 * ĂяoOUIƓKv܂B
	 * 
	 * @return v
	 */
	public String getWindowDescription() {

		String classText;
		switch (messageClass) {
		case Message.SEND:
			classText = mm.get("Message.desc.classText.SEND"); //$NON-NLS-1$
			break;
		case Message.REPLY:
			if (replyFrom != null && replyFrom.userName != null) {
				classText = mm.get("Message.desc.classText.REPLY_TO", //$NON-NLS-1$
						new Object[] { replyFrom.userName });
			} else {
				classText = mm.get("Message.desc.classText.REPLY"); //$NON-NLS-1$
			}
			break;
		case Message.RECEIVED:
			classText = mm.get("Message.desc.classText.RECEIVED", //$NON-NLS-1$
					new Object[] { userName });
			break;
		default:
			classText = mm.get("Message.desc.classText.default"); //$NON-NLS-1$
			break;
		}

		String summary;
		switch (windowStyle) {
		case Message.FRONT:
		case Message.STICKY:

			summary = getFirstLine(30);

			break;
		case Message.BACK:
			if (isPasswordRequired) {
				summary = mm.get("Message.desc.summary.passwordRequired"); //$NON-NLS-1$
			} else {
				summary = getFirstLine(30);
			}
			break;
		case Message.ONE_LINE:
		case Message.QR_CODE:
			// I𕔕ő30
			summary = getOneLineText(true);
			summary = Tool.getFirstLine(summary, 30);

			break;
		case Message.ICON:
			if (isPasswordRequired) {
				summary = mm.get("Message.desc.summary.passwordRequired"); //$NON-NLS-1$
			} else {
				summary = getFirstLine(30);
			}
			break;
		default:
			summary = mm.get("Message.desc.summary.invalidStyle"); //$NON-NLS-1$
			break;
		}

		if (summary == null || summary.length() == 0) {
			summary = mm.get("Message.desc.summary.empty"); //$NON-NLS-1$
		}

		return mm.get("Message.desc.format", //$NON-NLS-1$
				new Object[] { classText, summary });
	}

	/**
	 * IĂ镶擾܂B
	 * @return Í͈BnullB
	 */
	public String getSelectedText() {
		if (selectionStart != selectionEnd) {
			return message.substring(selectionStart, selectionEnd);
		}
		return null;
	}

	/**
	 * 1s\p̃eLXg擾܂B
	 * sR[h܂ނƂ܂B
	 * @param firstLine I͈͂̍ŏ̍s擾ꍇtrue
	 * @return 
	 */
	public String getOneLineText(boolean firstLine) {
		String oneLine = getSelectedText();
		if (oneLine != null) {
			if (firstLine) {
				// ŏ1s擾
				oneLine = Tool.getFirstLine(oneLine, 30);
			}
		} else {
			// ŏ1s擾
			oneLine = getFirstLine(30);
		}
		return oneLine;
	}

	/**
	 * ŏ̍sԂ܂B󔒍s͖܂B
	 * @param max 1s̍ő咷
	 * @return ŏ1s̕B܂͋󕶎B
	 */
	public String getFirstLine(int max) {
		return Tool.getFirstLine(message, 30);
	}

	/**
	 * sɈpbZ[WԂ܂B
	 * @param quoteString p
	 * @param insertNewLineToHead 擪ɉs2
	 * @return pꂽ
	 */
	public String getQuotedMessage(String quoteString, boolean insertNewLineToHead) {
		return Tool.getQuotedText(this.message, quoteString, insertNewLineToHead);
	}

	/**
	 * v[Xz_폜{擾܂B
	 * sR[hLFɓꂳ܂B
	 * 
	 * @return v[Xz_폜{
	 */
	public String getMessageWithoutPlaceholder() {
		StringBuffer sb = new StringBuffer(message);
		// sR[h\nɓ
		Tool.replaceAll(sb, "\r\n", "\n"); //$NON-NLS-1$ //$NON-NLS-2$
		Tool.replaceAll(sb, "\r", "\n"); //$NON-NLS-1$ //$NON-NLS-2$

		if (!hasAttachment()) {
			return sb.toString();
		}

		// 납폜
		Collection list = getInlineAttachments(false);
		Iterator itr = list.iterator();
		while (itr.hasNext()) {
			Attachment att = (Attachment) itr.next();
			sb.replace(att.position, att.position + 1, ""); //$NON-NLS-1$
		}
		return sb.toString();
	}

	/**
	 * s̃Xy[Xƃ^uі̉sԂ܂B
	 * 
	 * @param lineDelimiter sR[h
	 * @return Cfg
	 */
	public String getUnindentedMessage() {
		String str = Tool.unindent(message);
		return str.replaceFirst("[\\r\\n]+$", ""); //$NON-NLS-1$ //$NON-NLS-2$
	}

	/**
	 * fobOo͗p
	 */
	public String toString() {
		StringBuffer sb = new StringBuffer("Message{"); //$NON-NLS-1$
		sb.append("id=").append(this.id); //$NON-NLS-1$
		sb.append(", protocol=").append(this.protocol); //$NON-NLS-1$
		sb.append(", launchId=").append(this.launchId); //$NON-NLS-1$
		sb.append(", messageClass=").append(this.messageClass); //$NON-NLS-1$
		sb.append(", messageType=").append(this.messageType); //$NON-NLS-1$
		sb.append(", windowStyle=").append(this.windowStyle); //$NON-NLS-1$
		sb.append(", isOpened=").append(this.isOpened); //$NON-NLS-1$
		sb.append(", isSaved=").append(this.isSaved); //$NON-NLS-1$
		sb.append(", desktop=").append(this.desktop); //$NON-NLS-1$
		sb.append(", time=").append(this.time); //$NON-NLS-1$
		sb.append(", ipAddress=").append(this.ipAddress); //$NON-NLS-1$
		sb.append(", computerName=").append(this.computerName); //$NON-NLS-1$
		sb.append(", osUserName=").append(this.osUserName); //$NON-NLS-1$
		sb.append(", userName=").append(this.userName); //$NON-NLS-1$
		sb.append(", message=").append(this.message); //$NON-NLS-1$
		sb.append(", color="); //$NON-NLS-1$
		if (color == null || color.length != 3) {
			sb.append("null"); //$NON-NLS-1$
		} else {
			sb.append(Integer.toHexString(color[0]));
			sb.append('.');
			sb.append(Integer.toHexString(color[1]));
			sb.append('.');
			sb.append(Integer.toHexString(color[2]));
		}
		sb.append(", ext="); //$NON-NLS-1$
		Iterator keys = ext.keySet().iterator();
		while (keys.hasNext()) {
			String key = (String) keys.next();
			sb.append("\"").append(key); //$NON-NLS-1$
			sb.append("=").append(ext.get(key)).append("\", "); //$NON-NLS-1$ //$NON-NLS-2$
		}

		return sb.toString();
	}

	/**
	 * IP Messenger`̃Oo͂܂B
	 * R[hAsR[h̓vbgtH[ˑłB
	 * @param w o͐
	 * @throws IOException o͎̗O
	 */
	public void writeIPMsgLog(BufferedWriter w) throws IOException {
		w.write("====================================="); //$NON-NLS-1$
		w.newLine();

		// To, From
		if (this.messageClass == PENDING || this.messageClass == RECEIVED) {
			w.write(" From: "); //$NON-NLS-1$
			w.write(this.userName);
			w.write(" ("); //$NON-NLS-1$
			w.write(this.computerName);
			w.write(')');
			w.newLine();
		} else {
			Iterator itr = destinations.iterator();
			while (itr.hasNext()) {
				Destination dest = (Destination) itr.next();
				if (!dest.getResult()) {
					// sꍇ͋L^ȂB
					continue;
				}

				w.write(" To: "); //$NON-NLS-1$
				w.write(dest.getUserName());
				w.write(" ("); //$NON-NLS-1$
				w.write(dest.getComputerName());
				w.write(')');
				w.newLine();
			}
		}

		// 
		Date date = getDate();
		if (date != null) {
			SimpleDateFormat format = new SimpleDateFormat(
					"EEE MMM dd HH:mm:ss yyyy ", Locale.US); //$NON-NLS-1$
			w.write("  at "); //$NON-NLS-1$
			w.write(format.format(date));
		}

		// }`LXg
		if (this.isMulticast) {
			w.write(mm.get("Message.ipmsglog.multicast")); //$NON-NLS-1$
		}
		// Í
		if (this.encryptMethod != null) {
			w.write('(');
			// TODO IP MessengerƓ(+pfBO)ɂ
			w.write(this.encryptMethod);
			w.write(')');
		}
		// ApX[h
		if (!this.isOpened && this.isPasswordRequired) {
			w.write(mm.get("Message.ipmsglog.isPasswordRequired")); //$NON-NLS-1$
		} else if (!this.isOpened) {
			w.write(mm.get("Message.ipmsglog.sealed")); //$NON-NLS-1$
		}
		w.newLine();

		// Ytt@C
		if (this.hasAttachment()) {
			w.write(mm.get("Message.ipmsglog.attachment")); //$NON-NLS-1$
			Iterator itr = this.attachments.iterator();
			while (itr.hasNext()) {
				Attachment att = (Attachment) itr.next();
				w.write(att.name);
				if (itr.hasNext()) {
					w.write(", "); //$NON-NLS-1$
				}
			}
			w.newLine();
		}

		w.write("-------------------------------------"); //$NON-NLS-1$
		w.newLine();
		// [obj]o͂Ȃ
		Collection inline = getInlineAttachments(true);
		if (inline == null) {
			w.write(this.message);
		} else {
			Iterator itr = inline.iterator();

			Attachment att = null;
			if (itr.hasNext()) {
				att = (Attachment) itr.next();
			}

			for (int i = 0; i < message.length(); i++) {
				char c = message.charAt(i);
				if (c == '\uFFFC' && att != null && att.position == i) {
					//CC摜̈ʒu
					if (itr.hasNext()) {
						att = (Attachment) itr.next();
					}
					continue;
				}
				w.write(c);
			}
		}
		w.newLine();
		w.newLine();
		w.flush();
	}

	/**
	 * WriterXMLo͂܂B
	 * @param w o͐
	 * @throws IOException 
	 */
	public void writeXml(Writer w) throws IOException {
		writeXml(w, false);
	}

	/**
	 * WriterXMLo͂܂B
	 * @param w o͐
	 * @param isReply ԐM̃bZ[W̏ꍇtrue
	 * @throws IOException 
	 */
	public void writeXml(Writer w, boolean isReply) throws IOException {
		final String parent;
		if (isReply) {
			parent = "replyfrom"; //$NON-NLS-1$
		} else {
			parent = "message"; //$NON-NLS-1$
		}

		Tool.writeStartElement(w, parent);

		Tool.writeElement(w, "id", Integer.toString(id)); //$NON-NLS-1$

		Tool.writeElement(w, "messagetype", Integer.toString(messageType)); //$NON-NLS-1$

		Tool.writeElement(w, "messageclass", Integer.toString(messageClass)); //$NON-NLS-1$

		Tool.writeElement(w, "windowmode", Integer.toString(windowMode)); //$NON-NLS-1$

		Tool.writeElement(w, "ismulticast", isMulticast); //$NON-NLS-1$

		if (encryptMethod != null) {
			Tool.writeElement(w, "encryptmethod", encryptMethod); //$NON-NLS-1$
		}

		Tool.writeElement(w, "issaved", isSaved); //$NON-NLS-1$

		if (messageClass != RECEIVED && messageClass != PENDING) {
			// MpԂۑ
			Tool.writeElement(w, "isopened", isOpened); //$NON-NLS-1$
		}

		Tool.writeElement(w, "ispasswordrequired", isPasswordRequired); //$NON-NLS-1$

		Tool.writeElement(w, "desktop", desktop); //$NON-NLS-1$

		Tool.writeElement(w, "time", time); //$NON-NLS-1$

		Tool.writeElement(w, "ipaddress", ipAddress); //$NON-NLS-1$

		Tool.writeElement(w, "computername", computerName); //$NON-NLS-1$

		Tool.writeElement(w, "port", Integer.toString(port)); //$NON-NLS-1$

		Tool.writeElement(w, "osusername", osUserName); //$NON-NLS-1$

		Tool.writeElement(w, "username", userName); //$NON-NLS-1$

		// QƂ̕ϊ
		StringBuffer str = new StringBuffer(message);
		Tool.escape(str);
		// sϊ
		Tool.replaceAll(str, "\r\n", "&#10;"); //$NON-NLS-1$ //$NON-NLS-2$
		Tool.replaceAll(str, "\n", "&#10;"); //$NON-NLS-1$ //$NON-NLS-2$
		Tool.replaceAll(str, "\r", "&#13;"); //$NON-NLS-1$ //$NON-NLS-2$
		Tool.replaceAll(str, "\t", "&#9;"); //$NON-NLS-1$ //$NON-NLS-2$
		Tool.replaceAll(str, "\uFFFC", "&#65532;"); //$NON-NLS-1$ //$NON-NLS-2$

		Tool.writeStartElement(w, "messagebody"); //$NON-NLS-1$
		w.write(str.toString());
		Tool.writeEndElement(w, "messagebody"); //$NON-NLS-1$

		Tool.writeElement(w, "selectionstart", Integer //$NON-NLS-1$
				.toString(selectionStart));

		Tool.writeElement(w, "selectionend", Integer.toString(selectionEnd)); //$NON-NLS-1$

		Tool.writeElement(w, "topindex", Integer.toString(topIndex)); //$NON-NLS-1$

		Tool.writeElement(w, "protocol", protocol); //$NON-NLS-1$

		Tool.writeElement(w, "launchid", launchId); //$NON-NLS-1$

		Tool.writeElement(w, "windowleft", Integer.toString(windowLeft)); //$NON-NLS-1$
		Tool.writeElement(w, "windowtop", Integer.toString(windowTop)); //$NON-NLS-1$
		Tool.writeElement(w, "height", Integer.toString(height)); //$NON-NLS-1$
		Tool.writeElement(w, "width", Integer.toString(width)); //$NON-NLS-1$

		Tool.writeElement(w, "windowstyle", Integer.toString(windowStyle)); //$NON-NLS-1$

		if (magnification)
			Tool.writeElement(w, "magnification", magnification); //$NON-NLS-1$

		if (alpha != 255)
			Tool.writeElement(w, "alpha", Integer.toString(alpha)); //$NON-NLS-1$

		// F
		if (color != null) {
			Tool.writeColor(w, "foregroundcolor", color); //$NON-NLS-1$
		}

		// tⳎ̔zF
		if (colorScheme != null) {
			colorScheme.writeXml(w);
		}

		// Ytt@CgC̔䗦
		// [U[C^[tF[XˑǗ֐DŁB
		if (trayRatio != null && trayRatio.length == 2) {
			w.write("<trayratio>"); //$NON-NLS-1$
			w.write(Integer.toString(trayRatio[0]));
			w.write(',');
			w.write(Integer.toString(trayRatio[1]));
			w.write("</trayratio>"); //$NON-NLS-1$
		}

		// ext
		if (ext != null && !ext.isEmpty()) {
			w.write("<ext>"); //$NON-NLS-1$
			Iterator itr = ext.entrySet().iterator();
			while (itr.hasNext()) {
				Entry entry = (Entry) itr.next();
				String key = (String) entry.getKey();
				String val = (String) entry.getValue();

				w.write("<extitem name=\""); //$NON-NLS-1$
				Tool.escapeXml(w, key);
				w.write("\">"); //$NON-NLS-1$
				Tool.escapeXml(w, val);
				w.write("</extitem>"); //$NON-NLS-1$
			}
			w.write("</ext>"); //$NON-NLS-1$
		}
		// attachments
		if (hasAttachment()) {
			w.write("<attachment>"); //$NON-NLS-1$
			Iterator itr = attachments.iterator();
			while (itr.hasNext()) {
				Attachment attach = (Attachment) itr.next();
				// ۑς݂̂̂
				if (attach.localPath != null) {
					attach.writeXml(w);
				}
			}
			w.write("</attachment>"); //$NON-NLS-1$
		}

		if (destinations != null && !destinations.isEmpty()) {
			Tool.writeStartElement(w, "destinations"); //$NON-NLS-1$
			Iterator itr = destinations.iterator();
			while (itr.hasNext()) {
				Destination dest = (Destination) itr.next();
				dest.writeXml(w);
			}
			Tool.writeEndElement(w, "destinations"); //$NON-NLS-1$
		}

		// replyFrom
		if (replyFrom != null && !isReply) {
			replyFrom.writeXml(w, true);
		}
		Tool.writeEndElement(w, parent);
	}

	/**
	 * e[uɕ\镶̔zԂ܂B
	 * @see petaclone.TableViewable#getRowStrings()
	 */
	public String[] getRowStrings() {
		String msg;
		if (isPasswordRequired) {
			msg = mm.get("Message.desc.summary.passwordRequired"); //$NON-NLS-1$
		} else {
			msg = this.message;
		}
		return new String[] { this.userName, this.getLocalTime(), msg };
	}

	/**
	 * Method compareBy.
	 * @param column ԍ
	 * @param msg rMessage
	 * @return int
	 */
	public int compareBy(int column, Message msg) {
		switch (column) {
		case 0:
			// [U[
			if (!this.userName.equals(msg.userName)) {
				return this.userName.compareToIgnoreCase(msg.userName);
			}
			if (!this.time.equals(msg.time)) {
				// ꉞAIɔr\Ȍ`
				return this.time.compareTo(msg.time);
			}
			return this.message.compareTo(msg.message);

		case 1:
			// time
			if (!this.time.equals(msg.time)) {
				// ꉞAIɔr\Ȍ`
				return this.time.compareTo(msg.time);
			}
			if (!this.userName.equals(msg.userName)) {
				return this.userName.compareToIgnoreCase(msg.userName);
			}
			return this.message.compareTo(msg.message);

		case 2:
			// message
			if (!this.message.equals(msg.message)) {
				return this.message.compareTo(msg.message);
			}
			if (!this.time.equals(msg.time)) {
				// ꉞAIɔr\Ȍ`
				return this.time.compareTo(msg.time);
			}
			return this.userName.compareToIgnoreCase(msg.userName);

		default:
			return 0;
		}
	}

	/**
	 * Calendery^N[`Ŋi[܂B
	 * ̂܂ܕƂă\[g\Ȃ悤Ƀ^C][GMTœꂵ܂B
	 * @param c t
	 */
	public void setTime(Calendar c) {
		SimpleDateFormat format = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss Z"); //$NON-NLS-1$
		format.setTimeZone(TimeZone.getTimeZone("GMT")); //$NON-NLS-1$
		this.time = format.format(c.getTime());
	}

	/**
	 * y^N[`̓tătH[}bgĊi[܂B
	 * ^C][̋zB
	 * @param time t
	 */
	public void setTime(String time) {
		SimpleDateFormat format = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss Z"); //$NON-NLS-1$
		Calendar c = Calendar.getInstance();
		try {
			c.setTime(format.parse(time));
			setTime(c);
		} catch (ParseException e) {
			try {
				SimpleDateFormat oldFormat = new SimpleDateFormat(
						"yyyy/MM/dd HH:mm:ss"); //$NON-NLS-1$
				c.setTime(oldFormat.parse(time));
				setTime(c);
			} catch (ParseException e2) {
				// 肪邪̂܂܎󂯓
				this.time = time;
			}
		}
	}

	/**
	 * XML͎Ɏ𒼐ڐݒ肵܂B
	 * @param time 
	 */
	public void setTimeDirectly(String time) {
		this.time = time;
	}

	/**
	 * MɌݎݒ肵܂B
	 */
	public void setCurrentTime() {
		SimpleDateFormat format = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss Z"); //$NON-NLS-1$
		format.setTimeZone(TimeZone.getTimeZone("GMT")); //$NON-NLS-1$
		this.time = format.format(new Date());
	}

	/**
	 * MDate^ŕԂ܂B
	 * FIXME t̏
	 * @return Date^̑M
	 */
	public Date getDate() {
		assert time != null;
		try {
			SimpleDateFormat format = new SimpleDateFormat(
					"yyyy/MM/dd HH:mm:ss Z"); //$NON-NLS-1$
			return format.parse(this.time);
		} catch (ParseException e) {
			return null;
		}
	}

	/**
	 * \p̃[JԂtimeԂ܂B
	 * @return [JԂɕϊꂽM̕
	 */
	public String getLocalTime() {
		assert time != null;

		Date date = getDate();
		if (date == null) {
			return time;
		}

		SimpleDateFormat format = new SimpleDateFormat(mm
				.get("Message.localTimeFormat")); //$NON-NLS-1$
		return format.format(date);
	}

	/**
	 * Mʂǉ܂B
	 * @param dest ML^
	 */
	public void addDestination(Destination dest) {
		if (this.destinations == null) {
			this.destinations = new Vector();
		}
		this.destinations.add(dest);
	}

	/**
	 * Đ̐Ԃ܂B
	 * @return Đ̐
	 */
	public int destinationCount() {
		if (this.destinations == null) {
			return 0;
		}
		return this.destinations.size();
	}

	/**
	 * @return bZ[WɃt@CYtĂȂtrueԂ܂B
	 */
	public boolean hasAttachment() {
		if (this.attachments == null)
			return false;
		if (this.attachments.isEmpty()) {
			this.attachments = null;
			return false;
		}
		return true;
	}

	/**
	 * positionŃ\[gCC摜̃XgԂ܂B
	 * @param ascent ̎true
	 * @return Ytt@CȂƂnullB
	 */
	public Collection getInlineAttachments(boolean ascent) {
		if (!hasAttachment()) {
			return null;
		}
		TreeSet result = new TreeSet(new AttachmentPositionComparator(ascent));
		Iterator itr = attachments.iterator();
		while (itr.hasNext()) {
			Attachment att = (Attachment) itr.next();
			if (att.type == Attachment.TYPE_INLINE) {
				result.add(att);
			}
		}
		return result;
	}

	/**
	 * ۑ̓Ytt@CꍇtrueԂ܂B
	 * @return ۑ̓Ytt@Cꍇtrue
	 */
	public boolean hasUnsavedAttachment() {
		if (!hasAttachment()) {
			return false;
		}
		Iterator itr = this.attachments.iterator();
		while (itr.hasNext()) {
			Attachment att = (Attachment) itr.next();
			if (att.status != Attachment.STATUS_FINISHED) {
				return true;
			}
		}
		return false;
	}

	/**
	 * Ytt@Cǉ܂B(Mp)
	 * @param attachment pX
	 * @return ĒǉłAttachmentԂBǉłȂꍇnull
	 */
	public Attachment addAttachment(String attachment) {
		attachment = Tool.normalize(attachment);
		// dĂȂ`FbN
		if (containsLocalPath(attachment)) {
			return null;
		}
		// _ł̏擾
		Attachment att = new Attachment();
		att.localPath = attachment;
		if (!att.getFileInfo()) {
			return null;
		}
		// ǉ
		addAttachment(att);
		return att;
	}

	/**
	 * Ytt@Cǉ܂B
	 * @param att Yt
	 */
	public void addAttachment(Attachment att) {
		// ǉ
		if (this.attachments == null) {
			this.attachments = new ArrayList();
		}
		this.attachments.add(att);
	}

	/**
	 * t@CpXo^ς݂ǂԂ܂B
	 * @param localPath t@CpX(Kς)
	 * @return o^ς݂̏ꍇtrue
	 */
	private boolean containsLocalPath(String localPath) {
		if (this.attachments != null) {
			Iterator itr = attachments.iterator();
			while (itr.hasNext()) {
				Attachment att = (Attachment) itr.next();
				if (att.localPath.equals(localPath)) {
					return true;
				}
			}
		}
		return false;
	}

	/**
	 * Ytt@C܂B<br>
	 * M: MȂȂƂ<br>
	 * M: hbvƂ
	 * @param number Ytt@C̔ԍ
	 * @return 폜Ytt@CBYȂꍇnullB
	 */
	public Attachment removeAttachment(int number) {
		if (!hasAttachment() || number < 0 || attachments.size() <= number) {
			return null;
		}
		return (Attachment) this.attachments.remove(number);
	}

	/**
	 * MYtt@C폜܂B
	 * _E[hAKvł͂ȂƂɎgp܂B
	 * @param number Ytt@C̔ԍ
	 */
	public void deleteAttachment(int number) {
		if (!hasAttachment() || number < 0 || attachments.size() <= number) {
			return;
		}
		// 폜
		Attachment att = (Attachment) attachments.remove(number);
		att.delete();
	}

	/**
	 * w肳ꂽdowmloadIDAttachmentԂ܂B
	 * ȂnullԂ܂B
	 * @param downloadId _E[hʎq
	 * @return Ytt@C
	 */
	public Attachment findAttachment(int downloadId) {
		synchronized (attachments) {
			Iterator itr = attachments.iterator();
			while (itr.hasNext()) {
				Attachment att = (Attachment) itr.next();
				if (att.downloadId == downloadId) {
					return att;
				}
			}
		}
		return null;
	}

	/**
	 * is̓Ytt@C̃Xg擾܂B
	 * @return is̓Ytt@C̃Xg(l: Attachment)
	 * 	ŶnullԂ܂B
	 */
	public List getAttachmentInProgress() {
		if (attachments == null) {
			return null;
		}
		synchronized (attachments) {
			List list = null;
			Iterator iter = attachments.iterator();
			while (iter.hasNext()) {
				Attachment att = (Attachment) iter.next();
				if (att.isProgress()) {
					if (list == null) {
						list = new ArrayList();
					}
					list.add(att);
				}
			}
			return list;
		}
	}

	/**
	 * ƗvpX[h̏Ԃݒ肵܂B
	 * @param privacyLevel vCoV[x
	 * @see petaclone.AppPreferences#getPrivacyProtectionLevel()
	 */
	public void setPrivacyLevel(String privacyLevel) {
		if (privacyLevel.equals(AppPreferences.PRIVACY_PROTECTION_SEALED)) {
			isOpened = false;
		} else if (privacyLevel
				.equals(AppPreferences.PRIVACY_PROTECTION_PASSWORD)) {
			isOpened = false;
			isPasswordRequired = true;
		}

	}

	/**
	 * IuWFNgǂ܂B
	 * @see java.lang.Object#equals(Object)
	 */
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (!(obj instanceof Message)) {
			return false;
		}
		Message m = (Message) obj;
		if (id != m.id || messageClass != m.messageClass
				|| messageType != m.messageType) {
			return false;
		}

		if (!Tool.equals(protocol, m.protocol)
				|| !Tool.equals(launchId, m.launchId)) {
			return false;
		}

		return Tool.equals(message, m.message);
	}

	/**
	 * Object#hashCode()Ԃ܂B
	 * <p>
	 * : {equalšʂƂ̃\bh̖߂l͘AׂłÂ悤ɎĂ܂B
	 * 
	 * @see java.lang.Object#hashCode()
	 */
	public int hashCode() {
		return super.hashCode();
	}

	/**
	 * YtꂽŌ̉摜t@CԂ܂B
	 * @return 摜t@C̃pXB摜ꍇnullB
	 */
	public String getLastImageAttachment() {
		if (!hasAttachment()) {
			return null;
		}
		int size = attachments.size();
		for (int i = size - 1; i >= 0; i--) {
			Attachment att = (Attachment) attachments.get(i);
			if (Tool.isImageFile(att.localPath)) {
				return att.localPath;
			}
		}
		return null;
	}

	/**
	 * bZ[Wƈv邩ׂ܂B
	 * 
	 * @param search 
	 * @param m p^[(K\̏ꍇ)
	 * @return vꍇAvʒu(܂0)BvȂꍇ-1B
	 */
	public int match(String search, Matcher m) {

		if (m == null) {
			// P
			// M
			if (messageClass == RECEIVED) {
				String lower = userName.toLowerCase();
				int pos = lower.indexOf(search);
				if (pos >= 0) {
					return 0;
				}
			}
			// bZ[W
			String lower = message.toLowerCase();
			int pos = lower.indexOf(search);
			if (pos >= 0) {
				return pos;
			}
			// Ytt@C
			if (hasAttachment()) {
				int size = attachments.size();
				for (int i = 0; i < size; i++) {
					Attachment att = (Attachment) attachments.get(i);
					lower = att.name.toLowerCase();
					pos = lower.indexOf(search);
					if (pos >= 0) {
						return 0;
					}
				}
			}
			return -1;
		}
		// K\
		if (messageClass == RECEIVED) {
			m.reset(userName);
			if (m.find()) {
				int s = m.start();
				if (s >= 0) {
					return 0;
				}
			}
		}
		m.reset(message);
		if (m.find()) {
			int s = m.start();
			if (s >= 0) {
				return s;
			}
		}
		// Ytt@C
		if (hasAttachment()) {
			int size = attachments.size();
			for (int i = 0; i < size; i++) {
				Attachment att = (Attachment) attachments.get(i);
				m.reset(att.name);
				if (m.find()) {
					int pos = m.start();
					if (pos >= 0) {
						return 0;
					}
				}
			}
		}
		return -1;
	}

	/**
	 * @return J[XL[
	 */
	public String toColorSchemeString() {
		StringBuffer sb = new StringBuffer(48);
		if (colorScheme != null) {
			sb.append(colorScheme.toColorSchemeString());
		} else {
			sb.append("000000,FFFFFF,FFFF00"); //$NON-NLS-1$
		}
		sb.append(',');
		sb.append(alpha);
		sb.append(',');
		sb.append("Untitled"); //$NON-NLS-1$
		return sb.toString();
	}
}
