package petaclone;

import java.io.IOException;
import java.io.Writer;

import jp.takayuki.tools.Tool;

/**
 * J[XL[
 * 
 * @author Takayuki Shoji
 */
public class MessageColorScheme {

	/**
	 * tⳎ: tHgtFCX
	 */
	public String stickyFontFace;

	/**
	 * tⳎ: tHgTCY
	 */
	public int stickyFontSize;

	/**
	 * tⳎ: tHgX^C
	 */
	public int stickyFontStyle;

	/**
	 * tⳎ: F
	 */
	public int[] stickyForeground;

	/**
	 * tⳎ: wiF1
	 */
	public int[] stickyBackground1;

	/**
	 * tⳎ: wiF2
	 */
	public int[] stickyBackground2;

	/**
	 * ̃RXgN^
	 */
	public MessageColorScheme() {
		//
	}

	/**
	 * J[XL[ɂRXgN^
	 * @param schemeString J[XL[
	 * @throws IllegalArgumentException J[XL[񂪐Ȃꍇ
	 */
	public MessageColorScheme(String[] schemeString)
			throws IllegalArgumentException {
		if (schemeString.length < 5) {
			throw new IllegalArgumentException("Invalid scheme string:" //$NON-NLS-1$
					+ schemeString);
		}
		try {
			stickyForeground = Tool.parseInt24(schemeString[0]);
			stickyBackground1 = Tool.parseInt24(schemeString[1]);
			stickyBackground2 = Tool.parseInt24(schemeString[2]);
		} catch (NumberFormatException e) {
			throw new IllegalArgumentException("Invalid scheme string:" //$NON-NLS-1$
					+ schemeString + "\n" + Tool.getStackTraceString(e)); //$NON-NLS-1$
		}
	}

	/**
	 * CX^X𕡐܂B
	 * @return ꂽCX^X
	 */
	public MessageColorScheme duplicate() {
		MessageColorScheme result = new MessageColorScheme();
		result.stickyFontFace = stickyFontFace;
		result.stickyFontSize = stickyFontSize;
		result.stickyFontStyle = stickyFontStyle;

		result.stickyForeground = copyRGB(stickyForeground);
		result.stickyBackground1 = copyRGB(stickyBackground1);
		result.stickyBackground2 = copyRGB(stickyBackground2);
		return result;
	}

	/**
	 * RGB`FbNăRs[܂B
	 * 
	 * @param rgb RGB
	 * @return Rs[RGB܂null
	 */
	private static int[] copyRGB(int[] rgb) {
		if (rgb == null || rgb.length != 3) {
			return null;
		}
		int[] result = new int[3];
		System.arraycopy(rgb, 0, result, 0, 3);
		return result;
	}

	/**
	 * WriterXMLo͂܂B
	 * @param w o͐
	 * @throws IOException
	 */
	public void writeXml(Writer w) throws IOException {

		// tⳎ:tHg
		if (stickyFontFace != null) {
			Tool.writeElement(w, "stfontface", stickyFontFace); //$NON-NLS-1$
			// tHgTCY
			Tool.writeElement(w, "stfontsize", //$NON-NLS-1$
					Integer.toString(stickyFontSize));
			// tHgX^C
			Tool.writeElement(w, "stfontstyle", //$NON-NLS-1$
					Integer.toString(stickyFontStyle));
		}
		// tⳎ:F
		if (stickyForeground != null) {
			Tool.writeColor(w, "stforeground", stickyForeground); //$NON-NLS-1$
		}
		// tⳎ:wiF1
		if (stickyBackground1 != null) {
			Tool.writeColor(w, "stbackground1", stickyBackground1); //$NON-NLS-1$
		}
		// tⳎ:wiF2
		if (stickyBackground2 != null) {
			Tool.writeColor(w, "stbackground2", stickyBackground2); //$NON-NLS-1$
		}
	}

	/**
	 * @return J[XL[(F,wiF1,wiF2)
	 */
	public String toColorSchemeString() {
		StringBuffer result = new StringBuffer(20);
		result.append(Tool.formatInt24(stickyForeground, "000000")); //$NON-NLS-1$
		result.append(',');
		result.append(Tool.formatInt24(stickyBackground1, "FFFFFF")); //$NON-NLS-1$
		result.append(',');
		result.append(Tool.formatInt24(stickyBackground2, "FFFF00")); //$NON-NLS-1$
		return result.toString().toUpperCase();
	}
}
