package petaclone;

import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;

import jp.takayuki.logging.Logger;
import jp.takayuki.tools.MessageMap;

/**
 * IP Messenger`̃OL^܂B
 * @author Takayuki Shoji
 */
public class MessageLoggerImpl implements MessageLogger {

	/**
	 * logger
	 */
	private static final Logger logger = Logger
			.getLogger(MessageLoggerImpl.class);

	/**
	 * bZ[W\[X
	 */
	private static final MessageMap mm = MessageMap.getMessageMap();

	/**
	 * ݒ
	 */
	private AppPreferences pref;

	/**
	 * bZ[WO̕GR[fBOB
	 * null̏ꍇAVXẽftHgGR[fBOgpB
	 */
	private String encoding;

	/**
	 * RXgN^
	 * @param pref AvP[Vݒ
	 */
	public MessageLoggerImpl(AppPreferences pref) {
		this.pref = pref;
		if (pref.isUtf8MessageLog()) {
			encoding = "UTF-8"; //$NON-NLS-1$
		}
	}

	/**
	 * bZ[WOɋL^܂B
	 * @param msg L^郁bZ[W
	 */
	synchronized public void writeMessageLog(Message msg) {
		String path = this.pref.getMessageLogPath();
		if (path == null || path.length() == 0) {
			return;
		}

		FileOutputStream fos = null;
		OutputStreamWriter osw = null;
		BufferedWriter bw = null;
		try {
			fos = new FileOutputStream(path, true);
			if (encoding != null) {
				osw = new OutputStreamWriter(fos, encoding);
			} else {
				osw = new OutputStreamWriter(fos);
			}
			bw = new BufferedWriter(osw);

			msg.writeIPMsgLog(bw);
		} catch (FileNotFoundException e) {

			logger.error(mm.get("MessageLoggerImpl.FileNotFoundException"), e); //$NON-NLS-1$

		} catch (IOException e) {

			logger.error(mm.get("MessageLoggerImpl.IOException"), e); //$NON-NLS-1$

		} finally {
			try {
				if (bw != null) {
					bw.close();
				} else if (osw != null) {
					osw.close();
				} else if (fos != null) {
					fos.close();
				}
			} catch (IOException e) {
				logger.error(mm.get("MessageLoggerImpl.IOException"), e); //$NON-NLS-1$
			}
		}
	}

}
