package petaclone;

import jp.takayuki.logging.Logger;

/**
 * ThreadGroup
 * @author Takayuki Shoji
 */
public class MessengerThreadGroup extends ThreadGroup {

	/**
	 * logger
	 */
	private static final Logger logger = Logger
			.getLogger(MessengerThreadGroup.class);

	/**
	 * Cxg
	 */
	private EventBroker broker;

	/**
	 * RXgN^
	 * @param name XbhO[v̖O
	 * @param broker Cxg
	 */
	public MessengerThreadGroup(String name, EventBroker broker) {
		super(name);
		this.broker = broker;
	}

	/**
	 * ߑĂȂO܂B
	 */
	public void uncaughtException(Thread t, Throwable e) {
		super.uncaughtException(t, e);
		if (e instanceof ThreadDeath) {
			logger.debug("This thread will die. name=" + t.getName()); //$NON-NLS-1$
			return;
		}
		logger.error("Unchecked exception or error occurred.", e); //$NON-NLS-1$
		this.broker.notifyEvent(Events.UnexpectedMessengerError, e);
	}
}
