package petaclone;

import java.applet.Applet;
import java.applet.AudioClip;
import java.io.File;
import java.net.MalformedURLException;
import java.net.URI;
import java.net.URISyntaxException;

/**
 * TEhĐ܂B
 * @author Takayuki Shoji
 */
public class SoundPlayerImpl implements Runnable, SoundPlayer {
	/** ݒ */
	private AppPreferences pref;

	/** TEh:Ȃ */
	private static final int SOUND_NONE = 0;

	/** TEh:r[v */
	private static final int SOUND_BEEP = 1;

	/** TEh:t@C̍Đ */
	private static final int SOUND_FILE = 2;

	/** AudioClip̃[hɎgppX */
	private String loadedPath;

	/** AudioClip */
	private AudioClip clip;

	/** Đǂ */
	private boolean playing;

	/**
	 * RXgN^
	 * @param pref ݒ
	 */
	public SoundPlayerImpl(AppPreferences pref) {
		this.pref = pref;
	}

	/**
	 * ݒ̒l̒萔ɕϊ܂B
	 * @param value ݒl
	 * @return SOUND_*
	 */
	private int translateValue(String value) {
		if (value.equals("0")) { //$NON-NLS-1$
			return SOUND_NONE;
		} else if (value.equals("beep")) { //$NON-NLS-1$
			return SOUND_BEEP;
		} else if (value.equals("sound")) { //$NON-NLS-1$
			return SOUND_FILE;
		}
		return -1;
	}

	/**
	 * TEhĐ܂BĐ̏ꍇƍĐKvȂꍇ͉܂B
	 */
	public void play() {
		// ݒ̃`FbN
		int currentPref = translateValue(pref.getPlaySound());

		switch (currentPref) {
		case -1:
			clip = null;
			return;
		case SOUND_NONE:
			clip = null;
			return;
		case SOUND_BEEP:
			clip = null;
			System.out.print('\7');//beep
			return;
		case SOUND_FILE:
			break;
		default:
			clip = null;
			return;
		}

		synchronized (this) {
			// Đ
			if (this.playing) {
				return;
			}
			this.playing = true;
		}

		// 
		if (clip == null || !pref.getSoundUrl().equals(this.loadedPath)) {
			init();
		}

		// łȂꍇ
		if (clip == null) {
			synchronized (this) {
				this.playing = false;
			}
			return;
		}

		Thread th = new Thread(this, "SoundPlayer"); //$NON-NLS-1$
		th.start();
	}

	/**
	 * 
	 */
	private void init() {
		this.loadedPath = pref.getSoundUrl();

		if (loadedPath == null || loadedPath.length() == 0) {
			clip = null;
			return;
		}
		// URLɕϊ
		URI uri;
		try {
			uri = new URI(loadedPath);
		} catch (URISyntaxException e) {
			File file = new File(loadedPath);
			uri = file.toURI();
		}
		// AudioClip̐
		try {
			clip = Applet.newAudioClip(uri.toURL());
		} catch (MalformedURLException e) {
			clip = null;
		} catch (IllegalArgumentException e) {
			clip = null;
		}
	}

	/**
	 * ĐpXbh
	 * @see java.lang.Runnable#run()
	 */
	public void run() {
		clip.play();
		synchronized (this) {
			this.playing = false;
		}
	}
}
