package petaclone;

import java.util.Iterator;
import java.util.TreeSet;

import jp.takayuki.tools.InetAddressUtils;
import jp.takayuki.tools.Tool;

/**
 * o[Bo[gpłvgRXgB
 * @author Takayuki Shoji
 */
public class UniqueMember implements TableViewable, Cloneable {

	/** s݂̏ */
	private boolean isAbsence;

	/** bZW[̃[U[ */
	private String userName;

	/** OSւ̃OC */
	private String osUserName;

	/** Rs[^EzXg */
	private String computerName;

	/** IPAhX */
	private String ipAddress = ""; //$NON-NLS-1$

	/** O[v */
	private String group;

	/**
	 * clone()OhashCodeB
	 */
	private int clonedHashCode;

	/**
	 * bZW[̋NID(String)̃XgB
	 * t@CMT|[gĂ̂܂݂܂B
	 */
	private TreeSet launchIDs = new TreeSet();

	/**
	 * t@C̎MT|[gĂ郁bZW[̋NID(String)̃XgB
	 */
	private TreeSet fileReceivableLaunchIDs = new TreeSet();

	/** ԁFItC */
	public static final int OFFLINE = 0;

	/** ԁFs */
	public static final int ABSENCE = 1;

	/** ԁFs݁At@CM\ */
	public static final int ABSENCE_FILE = 2;

	/** ԁFIC */
	public static final int ONLINE = 3;

	/** ԁFICAt@CM\ */
	public static final int ONLINE_FILE = 4;

	/**
	 * RXgN^B
	 * MemberUniqueMember𐶐܂B
	 * @param member `MemberB
	 * null̂Ƃ͕tB[h܂B
	 */
	public UniqueMember(Member member) {
		if (member == null) {
			return;
		}
		this.isAbsence = member.isAbsence;
		this.userName = member.userName;
		this.osUserName = member.osUserName;
		this.computerName = member.computerName;
		this.group = member.group;
		this.ipAddress = member.getIpAddress();

		assert member.launchId != null;
		this.addMessenger(member);
	}

	/**
	 * NIDǉ܂B<br>
	 * MemberɎAgroup,userName,osUserNamȅꍇAݒ肵܂B
	 * @param member ǉ郁o[
	 */
	public void addMessenger(Member member) {
		this.launchIDs.add(member.launchId);

		// t@CM
		if (member.canReceiveFile) {
			this.fileReceivableLaunchIDs.add(member.launchId);
		}
		// 󗓂̃tB[h
		if (member.group != null
				&& (this.group == null || this.group.length() == 0)) {
			this.group = member.group;
		}
		if (this.userName == null || this.userName.length() == 0) {
			this.userName = member.userName;
		}
		if (this.osUserName == null || this.osUserName.length() == 0) {
			this.osUserName = member.osUserName;
		}

		// IPAhX
		if (this.ipAddress == null || this.ipAddress.length() == 0
				|| !this.ipAddress.equals(member.getIpAddress())) {
			this.ipAddress = member.getIpAddress();
		}

		// s݃[h
		this.isAbsence = member.isAbsence;
	}

	/**
	 * NID폜܂B
	 * @param member 폜郁o[
	 * @return 폜̋NID̐
	 */
	public int removeMessenger(Member member) {
		this.isAbsence = member.isAbsence;

		if (member.canReceiveFile) {
			this.fileReceivableLaunchIDs.remove(member.launchId);
		}
		this.launchIDs.remove(member.launchId);
		return this.launchIDs.size();
	}

	/**
	 * NID̐Ԃ܂B
	 * @return NID̐
	 */
	public int getMessengerCount() {
		return this.launchIDs.size();
	}

	/**
	 * <p>t@CMT|[gĂNID̐Ԃ܂B</p>
	 * @return int
	 */
	public int getFileReceivableMessengerCount() {
		return fileReceivableLaunchIDs.size();
	}

	/**
	 * vpeB[ۑp擾܂B
	 * @return ۑp
	 */
	public String toEncodedString() {
		StringBuffer sb = new StringBuffer();

		sb.append(encode(this.userName)).append(':');
		sb.append(encode(this.osUserName)).append(':');
		sb.append(encode(this.computerName)).append(':');
		sb.append(encode(this.group));

		return sb.toString();
	}

	/**
	 * %xxxxx%xxxxx...ɕϊ܂B
	 * @param str ϊΏۂ̕
	 * @return GR[hꂽ
	 */
	private static String encode(String str) {
		StringBuffer sb = new StringBuffer();

		for (int i = 0; i < str.length(); i++) {
			int value = str.charAt(i);
			sb.append('%').append(value);
		}
		return sb.toString();
	}

	/**
	 * ԂԂ܂B
	 * @return int OFFLINE,ABSENCE_FILE,ONLINE_FILE,ABSENCE,ONLINE
	 */
	public int getStatus() {
		assert this.getMessengerCount() >= this
				.getFileReceivableMessengerCount();

		if (this.getMessengerCount() == 0) {
			return OFFLINE;
		}
		if (this.getFileReceivableMessengerCount() > 0) {
			if (isAbsence) {
				return ABSENCE_FILE;
			}
			return ONLINE_FILE;
		}
		if (isAbsence) {
			return ABSENCE;
		}
		return ONLINE;
	}

	/**
	 * [U[̎ʎqԂ܂B
	 * @return String ݂̓zXĝ
	 */
	public String getIdentifier() {
		if (ipAddress == null || ipAddress.length() == 0) {
			return computerName.toUpperCase();
		}
		return ipAddress;
	}

	/**
	 * `̃[U[ʎqԂ܂B
	 * @return OCzXg
	 */
	public String getIdentifierLong() {
		StringBuffer sb = new StringBuffer();
		//sb.append(osUserName).append("@").append(computerName);
		sb.append(osUserName).append('@').append(ipAddress);
		return sb.toString().toUpperCase();
	}

	/**
	 * IPAhX擾܂B
	 * @return IPAhX
	 */
	public String getIpAddress() {
		return this.ipAddress;
	}

	/**
	 * Returns the computerName.
	 * @return String
	 */
	public String getComputerName() {
		return computerName;
	}

	/**
	 * Returns the group.
	 * @return String
	 */
	public String getGroup() {
		return group;
	}

	/**
	 * Returns the osUserName.
	 * @return String
	 */
	public String getOsUserName() {
		return osUserName;
	}

	/**
	 * Returns the userName.
	 * @return String
	 */
	public String getUserName() {
		return userName;
	}

	/**
	 * Sets the computerName.
	 * @param computerName The computerName to set
	 */
	public void setComputerName(String computerName) {
		this.computerName = computerName;
	}

	/**
	 * IPAhXݒ肵܂B
	 * @param ipAddress IPAhX
	 */
	public void setIpAddress(String ipAddress) {
		this.ipAddress = ipAddress;
	}

	/**
	 * Sets the group.
	 * @param group The group to set
	 */
	public void setGroup(String group) {
		this.group = group;
	}

	/**
	 * Sets the osUserName.
	 * @param osUserName The osUserName to set
	 */
	public void setOsUserName(String osUserName) {
		this.osUserName = osUserName;
	}

	/**
	 * Sets the userName.
	 * @param userName The userName to set
	 */
	public void setUserName(String userName) {
		this.userName = userName;
	}

	/**
	 * UniqueComparator̂߂̔r\bh
	 * @param column ԍ
	 * @param um rΏ
	 * @return 0: A: un菬A: um傫
	 */
	public int compareBy(int column, UniqueMember um) {
		int r;
		switch (column) {
		case 0:
			// [U[
			r = Tool.compareToIgnoreCase(this.userName, um.userName);
			if (r != 0)
				return r;
			r = Tool.compareToIgnoreCase(this.computerName, um.computerName);
			if (r != 0)
				return r;
			return Tool.compareToIgnoreCase(this.group, um.group);

			// Rs[^
		case 1:
			r = Tool.compareToIgnoreCase(this.computerName, um.computerName);
			if (r != 0)
				return r;
			r = Tool.compareToIgnoreCase(this.userName, um.userName);
			if (r != 0)
				return r;
			return Tool.compareToIgnoreCase(this.group, um.group);

			// O[v
		case 2:
			r = Tool.compareToIgnoreCase(this.group, um.group);
			if (r != 0)
				return r;
			r = Tool.compareToIgnoreCase(this.computerName, um.computerName);
			if (r != 0)
				return r;
			return Tool.compareToIgnoreCase(this.userName, um.userName);

			// IPAhX
		case 3:
			r = InetAddressUtils.compareIpAddress(this.ipAddress, um.ipAddress);
			if (r != 0)
				return r;
			r = Tool.compareToIgnoreCase(this.computerName, um.computerName);
			if (r != 0)
				return r;
			return Tool.compareToIgnoreCase(this.userName, um.userName);

		default:
			return 0;
		}
	}

	/**
	 * IuWFNg̃V[Rs[s܂B
	 * @return UniqueMember
	 * @see java.lang.Object#clone()
	 */
	public Object clone() {
		UniqueMember um;
		try {
			um = (UniqueMember) super.clone();
		} catch (CloneNotSupportedException e) {
			// Ǝv
			return null;
		}
		um.isAbsence = this.isAbsence;
		um.userName = this.userName;
		um.osUserName = this.osUserName;
		um.computerName = this.computerName;
		um.ipAddress = this.ipAddress;
		um.group = this.group;
		um.launchIDs = this.launchIDs;
		um.fileReceivableLaunchIDs = this.fileReceivableLaunchIDs;

		um.clonedHashCode = this.hashCode();
		return um;
	}

	/**
	 * 
	 */
	public String toString() {
		StringBuffer sb = new StringBuffer("UniqueMember{"); //$NON-NLS-1$

		sb.append("isAbsence=").append(isAbsence); //$NON-NLS-1$
		sb.append(", userName=").append(userName); //$NON-NLS-1$
		sb.append(", osUserName=").append(osUserName); //$NON-NLS-1$
		sb.append(", computerName=").append(computerName); //$NON-NLS-1$
		sb.append(", ipAddress=").append(ipAddress); //$NON-NLS-1$
		sb.append(", group=").append(group); //$NON-NLS-1$
		sb.append(", clonedHashCode=").append(clonedHashCode); //$NON-NLS-1$
		sb.append(", launchIDs={"); //$NON-NLS-1$
		Iterator itr = launchIDs.iterator();
		while (itr.hasNext()) {
			String id = (String) itr.next();
			sb.append(id);
			if (itr.hasNext()) {
				sb.append(',');
			}
		}
		sb.append('}');
		sb.append(", fileReceivableLaunchIDs={"); //$NON-NLS-1$
		itr = fileReceivableLaunchIDs.iterator();
		while (itr.hasNext()) {
			String id = (String) itr.next();
			sb.append(id);
			if (itr.hasNext()) {
				sb.append(',');
			}
		}
		sb.append("}}"); //$NON-NLS-1$

		return sb.toString();
	}

	/**
	 * ʎqŏƍ܂B
	 * @see java.lang.Object#equals(Object)
	 */
	public boolean equals(Object obj) {
		if (obj == null) {
			return false;
		}
		if (!(obj instanceof UniqueMember)) {
			return false;
		}
		// clone()łƂ݂Ȃ
		if (this.hashCode() == obj.hashCode()) {
			return true;
		}

		return this.getIdentifier()
				.equals(((UniqueMember) obj).getIdentifier());
	}

	/**
	 * nbVR[hԂ܂B
	 */
	public int hashCode() {
		/*
		 * IPAhXgetIdentifier()̒lς邽߁A
		 * clone()ꂽUniqueMember͓hashCodeԂ܂B
		 */
		if (clonedHashCode != 0) {
			return clonedHashCode;
		}
		return getIdentifier().hashCode();
	}

	/**
	 * e[uŕ\镶̔zԂ܂B
	 * z̒4B
	 * @see petaclone.TableViewable#getRowStrings()
	 */
	public String[] getRowStrings() {
		return new String[] { this.userName, this.computerName, this.group,
				this.ipAddress };
	}

	/**
	 * Mɂӂ킵bZW[߂܂B
	 * firstId  defaultId  ̗̑p\ȃbZW[
	 * @param attached Ytt@CȂtrue
	 * @param firstId ŏɎbZW[̋NIDBnullB
	 * @param defaultId ftHgbZW[̋NIDBnullsB
	 * @return NID
	 */
	public String resolveMessenger(boolean attached, String firstId,
			String defaultId) {

		if (defaultId == null) {
			throw new IllegalArgumentException("defaultId == null."); //$NON-NLS-1$
		}

		// firstId
		if (firstId != null && launchIDs.contains(firstId)) {
			if (attached) {
				if (fileReceivableLaunchIDs.contains(firstId)) {
					return firstId;
				}
			} else {
				return firstId;
			}
		}

		// defaultId
		if (launchIDs.contains(defaultId)) {
			if (attached) {
				if (fileReceivableLaunchIDs.contains(defaultId)) {
					return defaultId;
				}
			} else {
				return defaultId;
			}
		}

		// p\ȃbZW[
		if (attached && !fileReceivableLaunchIDs.isEmpty()) {
			// t@CMłƂ
			return (String) fileReceivableLaunchIDs.first();
		} else if (!launchIDs.isEmpty()) {
			// ƂɂNĂ
			return (String) launchIDs.first();
		}

		// NĂȂƎvƂ
		return defaultId;
	}
}
