package petaclone;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import jp.takayuki.logging.Logger;
import jp.takayuki.tools.Tool;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

/**
 * bZ[W̕ۑB
 * @author Takayuki Shoji
 */
public class XmlMessageStorage implements MessageStorage {

	/**
	 * logger
	 */
	private static final Logger logger = Logger
			.getLogger(XmlMessageStorage.class);

	/**
	 * \EBhEB
	 * l: Message
	 */
	private List desktop;

	/**
	 * ۑMf[^B
	 * l: Message
	 */
	protected List received;

	/**
	 * Mf[^ύXꂽǂ
	 */
	private boolean receivedChanged;

	/**
	 * ۑMf[^B
	 * l: Message
	 */
	protected List sent;

	/**
	 * Mf[^ύXꂽǂ
	 */
	private boolean sentChanged;

	/**
	 * ۗ̎Mf[^B
	 * l: Message
	 */
	private List pending;

	/**
	 * t@C̃f[^ׂēǂݍłtrueB
	 */
	private boolean cached;

	/** bZ[W: fXNgbv */
	private String DESKTOP;

	/** bZ[W: M */
	private String RECEIVED;

	/** bZ[W: M */
	private String SENT;

	/** bZ[W: ۗ */
	private String PENDING;

	/**
	 * RXgN^
	 * @param path ۊǔ̃pX
	 */
	public XmlMessageStorage(File path) {
		File f;
		f = new File(path, "desktop.xml"); //$NON-NLS-1$
		DESKTOP = f.getAbsolutePath();
		f = new File(path, "received.xml"); //$NON-NLS-1$
		RECEIVED = f.getAbsolutePath();
		f = new File(path, "sent.xml"); //$NON-NLS-1$
		SENT = f.getAbsolutePath();
		f = new File(path, "pending.xml"); //$NON-NLS-1$
		PENDING = f.getAbsolutePath();

		desktop = new ArrayList();
		received = new ArrayList();
		sent = new ArrayList();
		pending = new ArrayList();
		cached = false;
	}

	/**
	 * <p>t@CǂłȂꍇ̓t@Cǂݍ݁A
	 * ̃f[^ƍ킹܂B</p>
	 * <p>desktop.xml͂ł͏܂B</p>
	 * <ul>
	 * 	<li>IɕۑOɃLbVĂȂΌĂяo</li>
	 * 	<li>SWTMessageStorage#show()ŏɌĂяoƂ</li>
	 * </ul>
	 * @return ǂݍݏsꍇtrue
	 * @throws MessageStorageIOException MessageStorageœ͗Oꍇ
	 */
	protected boolean read() throws MessageStorageIOException {
		// łɓǂݍł牽Ȃ
		if (cached) {
			return false;
		}

		List tempReceived = xmlIn(this.received, RECEIVED);
		List tempSent = xmlIn(this.sent, SENT);

		// ǂݍ݂m
		this.received = tempReceived;
		this.sent = tempSent;

		cached = true;
		return true;
	}

	/**
	 * <p>desktop.xmlǂݍ݂܂B</p>
	 * <ul>
	 * 	<li>SWTMessageStorageꂽƂ</li>
	 * </ul>
	 * 
	 * @throws MessageStorageIOException MessageStorageœ͗Oꍇ
	 */
	protected void readDesktop() throws MessageStorageIOException {
		this.desktop = xmlIn(this.desktop, DESKTOP);
		synchronized (this) {
			this.pending = xmlIn(this.pending, PENDING);
		}
	}

	/**
	 * <p>t@Cɕۑ܂B
	 * AvP[VIɂ͕\̃EBhE
	 * MessageƂĕۑĂĂяo܂B</p>
	 * <ul>
	 * 	<li>Vbg_EɌĂяo</li>
	 * </ul>
	 * @throws MessageStorageIOException MessageStorageœo͗Oꍇ
	 */
	protected void write() throws MessageStorageIOException {
		logger.debug("write start."); //$NON-NLS-1$

		// \̃bZ[W
		writeToFile(this.desktop, DESKTOP);

		List tempReceived = this.received;
		List tempSent = this.sent;

		// MbZ[W
		if (this.receivedChanged) {
			if (!cached) {
				tempReceived = xmlIn(this.received, RECEIVED);
			}
			writeToFile(tempReceived, RECEIVED);
			this.receivedChanged = false;
		}

		// MbZ[W
		if (this.sentChanged) {
			if (!cached) {
				tempSent = xmlIn(this.sent, SENT);
			}
			writeToFile(tempSent, SENT);
			this.sentChanged = false;
		}

		// ۗ(\҂)̃bZ[W
		synchronized (this) {
			writeToFile(this.pending, PENDING);
		}

		// ǂݍ݂m
		this.received = tempReceived;
		this.sent = tempSent;
		cached = true;

		logger.debug("write end."); //$NON-NLS-1$
	}

	/**
	 * t@Cɏ㏑ۑ܂B
	 * @param data ރbZ[WXg(l: Message)
	 * @param path pX
	 */
	private void writeToFile(List data, String path) {
		logger.debug("writeToFile() called. path=" + path); //$NON-NLS-1$
		xmlOut(data, path);
	}

	///**
	// * 郁\bhBۑɌĂяoH
	// */
	//private void free() {
	//	this.desktop.clear();
	//	this.received.clear();
	//	this.sent.clear();
	//	this.cached = false;
	//}

	/**
	 * <p>Messageۑ(ɃLbV)܂B
	 * message.isSavedtrueɐݒ肵܂B</p>
	 * <ul>
	 * 	<li>Vbg_EɃfXNgbṽbZ[WꊇŒǉ(Nɍ폜Ă)</li>
	 * 	<li>j[-[t@C]-[ۑ]IƂ</li>
	 * 	<li>MɎIɕۑƂ(bZ[WEBhE, M_CAO)</li>
	 * 	<li>MɎIɕۑƂ(ServerListener)</li>
	 * </ul>
	 * 
	 * @param message ǉ郁bZ[W
	 */
	public void add(Message message) {
		if (message.messageClass == Message.PENDING) {
			synchronized (this) {
				this.pending.add(message);
			}
		} else if (message.messageClass == Message.RECEIVED) {
			// MbZ[W
			message.isSaved = true;
			this.received.add(message);
			this.receivedChanged = true;
			//System.out.println("ǉreceived.size():" + this.received.size());
		} else {
			// VKMAԐMpbZ[W
			message.isSaved = true;
			this.sent.add(message);
			this.sentChanged = true;
			//System.out.println("ǉsent.size():" + this.sent.size());
		}
	}

	/**
	 * @see MessageStorage#addDesktop(Message)
	 */
	public void addDesktop(Message message) {
		this.desktop.add(message);
	}

	/**
	 * 폜B
	 * @param message 폜郁bZ[W
	 */
	public void delete(Message message) {
		if (message.messageClass == Message.PENDING) {
			synchronized (this) {
				this.pending.remove(message);
			}
			return;
		} else if (message.messageClass == Message.RECEIVED) {
			//System.out.println("폜Oreceived.size():" + this.received.size());
			this.received.remove(message);
			this.receivedChanged = true;
			return;
		}
		// MEԐM
		//System.out.println("폜Osent.size():" + this.sent.size());
		this.sent.remove(message);
		this.sentChanged = true;
	}

	//////////////////////////////
	// XMLo
	//////////////////////////////
	/**
	 * MesssagẽXgXML͂܂B
	 * t@C݂ȂƂcurrent̂܂ܖ߂܂B
	 * @param current ݂̃bZ[WXg(l: Message)
	 * @param path pX
	 * @return List (l: Message)
	 * @throws MessageStorageIOException NumberFormatException, 
	 * 	ParserConfigurationException, SAXException, IOException
	 * 	ƂȂĔ܂B
	 */
	private List xmlIn(List current, String path) {
		logger.debug("xmlIn(List, String) start. file=" + path); //$NON-NLS-1$
		long start = System.currentTimeMillis();
		try {
			// t@C݂̑mF
			File file = new File(path);
			if (!file.exists()) {
				return current;
			}

			SAXParserFactory spf = SAXParserFactory.newInstance();

			SAXParser parser;
			XMLIn xmlIn = null;
			try {
				parser = spf.newSAXParser();
				xmlIn = new XMLIn();
				parser.parse(file, xmlIn);
				List data = xmlIn.getResult();
				data.addAll(current);
				return data;
				//} catch (NumberFormatException e) {
				//} catch (ParserConfigurationException e) {
				//} catch (SAXException e) {
				//} catch (IOException e) {

			} catch (Exception e) {
				throw new MessageStorageIOException(e);
			}
		} finally {
			logger.debug("xmlIn(List, String) end. file=" //$NON-NLS-1$
					+ path + ", time=" //$NON-NLS-1$
					+ (System.currentTimeMillis() - start));
		}
	}

	/**
	 * MesssagẽXgXMLŏo͂܂B
	 * @param data bZ[W̃Xg(l: Message)
	 * @param path pX
	 * @throws MessageStorageIOException UnsupportedEncodingException, 
	 * 	IOExceptionƂȂ蔭܂B
	 */
	private void xmlOut(List data, String path) {
		FileOutputStream fo = null;
		OutputStreamWriter os = null;
		BufferedWriter writer = null;
		try {
			fo = new FileOutputStream(path);
			os = new OutputStreamWriter(fo, "UTF-8"); //$NON-NLS-1$
			writer = new BufferedWriter(os);

			writer.write("<?xml version=\"1.0\" encoding=\"UTF-8\" ?>"); //$NON-NLS-1$
			writer.newLine();
			writer.write("<messagestorage>"); //$NON-NLS-1$

			Iterator itr = data.iterator();
			while (itr.hasNext()) {
				Message msg = (Message) itr.next();
				msg.writeXml(writer);
			}
			writer.write("</messagestorage>"); //$NON-NLS-1$

		} catch (Exception e) {
			e.printStackTrace();
			throw new MessageStorageIOException(e);

		} finally {
			try {
				if (writer != null) {
					writer.close();
				} else if (os != null) {
					os.close();
				} else if (fo != null) {
					fo.close();
				}
			} catch (IOException e1) {
				e1.printStackTrace();
				throw new MessageStorageIOException(e1);
			}
		}
	}

	/**
	 * XML͂snhB
	 * getResult()Ōʂo܂B
	 * 
	 * 1.4ɕWŔĂSAXp[Tg܂B
	 * W̃p[TXercesƂ͏삪قȂ(qNamelocalNametƂ)̂
	 * Xercesł͓삵܂B
	 * JAXB͔zzTCY傫̂ŌB
	 */
	private static class XMLIn extends DefaultHandler {

		/**
		 * sR[h
		 */
		private static final String EOL = System.getProperty("line.separator"); //$NON-NLS-1$

		/**
		 * 
		 */
		private List result;

		/**
		 * ̃bZ[W
		 */
		private Message curMessage;

		/**
		 * Attachment
		 */
		private Attachment curAttachment;

		/**
		 * Destination
		 */
		private Destination curDestination;

		/**
		 * replyFromĂ邩
		 */
		private boolean isInReplyFrom;

		/**
		 * ݂extitemnamel
		 */
		private String curKey;

		/**
		 * ݂̗vf
		 */
		private int current = NONE;

		/** current̒萔:  */
		private static final int NONE = -1;

		/** current̒萔:  */
		private static final int ID = 0;

		///** current̒萔:  */
		//private static final int MESSAGE_TYPE = 10;

		/** current̒萔:  */
		private static final int MESSAGE_CLASS = 20;

		/** current̒萔:  */
		private static final int ENCRYPT_METHOD = 28;

		/** current̒萔:  */
		private static final int IS_MULTICAST = 29;

		/** current̒萔:  */
		private static final int IS_SAVED = 30;

		/** current̒萔:  */
		private static final int IS_OPENED = 40;

		/** current̒萔:  */
		private static final int IS_PASSWORD_REQUIRED = 50;

		/** current̒萔:  */
		private static final int DESKTOP = 60;

		/** current̒萔:  */
		private static final int TIME = 70;

		/** current̒萔:  */
		private static final int IP_ADDRESS = 80;

		/** current̒萔:  */
		private static final int COMPUTER_NAME = 90;

		/** current̒萔:  */
		private static final int PORT = 91;

		/** current̒萔:  */
		private static final int OS_USER_NAME = 100;

		/** current̒萔:  */
		private static final int USER_NAME = 110;

		/** current̒萔:  */
		private static final int GROUP = 120;

		/** current̒萔:  */
		private static final int MESSAGE_BODY = 130;

		/** current̒萔:  */
		private static final int SELECTION_START = 131;

		/** current̒萔:  */
		private static final int SELECTION_END = 132;

		/** current̒萔:  */
		private static final int TOP_INDEX = 133;

		/** current̒萔:  */
		private static final int EXT = 140;

		/** current̒萔:  */
		private static final int EXT_ITEM = 150;

		/** current̒萔:  */
		private static final int PROTOCOL = 160;

		/** current̒萔:  */
		private static final int LAUNCH_ID = 161;

		/** current̒萔:  */
		private static final int WINDOW_LEFT = 170;

		/** current̒萔:  */
		private static final int WINDOW_TOP = 180;

		/** current̒萔:  */
		private static final int FOREGROUND_COLOR = 181;

		/** current̒萔:  */
		private static final int WIDTH = 190;

		/** current̒萔:  */
		private static final int HEIGHT = 200;

		/** current̒萔:  */
		private static final int WINDOW_STYLE = 210;

		/** current̒萔:  */
		private static final int REPLY_FROM = 220;

		/** current̒萔: */
		private static final int TRAY_RATIO = 230;

		/** current̒萔: */
		private static final int MAGNIFICATION = 231;

		/** current̒萔: */
		private static final int ALPHA = 232;

		// tⳎ
		/** current̒萔: */
		private static final int ST_FONTFACE = 300;

		/** current̒萔: */
		private static final int ST_FONTSIZE = 301;

		/** current̒萔: */
		private static final int ST_FONTSTYLE = 302;

		/** current̒萔: */
		private static final int ST_FOREGROUND = 303;

		/** current̒萔: */
		private static final int ST_BACKGROUND1 = 304;

		/** current̒萔: */
		private static final int ST_BACKGROUND2 = 305;

		// Attachment
		/** current̒萔:  */
		private static final int ATTACHMENT_NAME = 1000;

		/** current̒萔:  */
		private static final int ATTACHMENT_TYPE = 1001;

		/** current̒萔:  */
		private static final int ATTACHMENT_LOCALPATH = 1002;

		/** current̒萔:  */
		private static final int ATTACHMENT_POSITION = 1003;

		// Destination
		/** current̒萔:  */
		private static final int DESTINATION_TO = 1050;

		/** current̒萔:  */
		private static final int DESTINATION_LAUNCH_ID = 1051;

		/** current̒萔:  */
		private static final int DESTINATION_RESULT = 1052;

		/** current̒萔:  */
		private static final int DESTINATION_LOGINNAME = 1053;

		/** current̒萔:  */
		private static final int DESTINATION_COMPUTERNAME = 1054;

		/** current̒萔:  */
		private static final int DESTINATION_USERNAME = 1055;

		/** current̒萔: EBhE[h */
		private static final int WINDOW_MODE = 1056;

		/**
		 * ǂݍݒ̕
		 */
		private String buffer = ""; //$NON-NLS-1$

		/**
		 * RXgN^
		 */
		XMLIn() {
			this.result = new ArrayList();
		}

		/**
		 * @see org.xml.sax.ContentHandler#characters(char[], int, int)
		 */
		public void characters(char[] ch, int start, int length)
				throws SAXException {

			if (current == NONE) {
				return;
			}
			bufferCharacters(new String(ch, start, length));
		}

		/**
		 * ׂēǂݏI܂Ńobt@O܂B
		 * @param string 
		 */
		private void bufferCharacters(String string) {
			if (this.buffer == null || this.buffer.length() == 0) {
				this.buffer = string;
			} else {
				this.buffer += string;
			}
		}

		/**
		 * ܂B
		 */
		private void handleString() {

			Message target;
			if (isInReplyFrom) {
				target = curMessage.replyFrom;
			} else {
				target = curMessage;
			}

			switch (current) {
			case ID:
				target.id = Integer.parseInt(this.buffer.trim());
				break;
			case MESSAGE_CLASS:
				target.messageClass = Integer.parseInt(this.buffer.trim());
				break;
			case WINDOW_MODE:
				target.windowMode = Integer.parseInt(this.buffer.trim());
				break;
			case ENCRYPT_METHOD:
				target.encryptMethod = this.buffer.trim();
				break;
			case IS_MULTICAST:
				if (isTrue()) {
					target.isMulticast = true;
				}
				break;
			case IS_SAVED:
				if (isTrue()) {
					target.isSaved = true;
				}
				break;
			case IS_OPENED:
				if (isTrue()) {
					target.isOpened = true;
				}
				break;
			case IS_PASSWORD_REQUIRED:
				if (isTrue()) {
					target.isPasswordRequired = true;
				}
				break;
			case DESKTOP:
				if (isTrue()) {
					target.desktop = true;
				}
				break;
			case TIME:
				target.time = this.buffer.trim();
				target.setTimeDirectly(target.time);
				break;
			case IP_ADDRESS:
				target.ipAddress = this.buffer.trim();
				break;
			case COMPUTER_NAME:
				target.computerName = this.buffer.trim();
				break;
			case PORT:
				target.port = Integer.parseInt(this.buffer.trim());
				break;
			case OS_USER_NAME:
				target.osUserName = this.buffer.trim();
				break;
			case USER_NAME:
				target.userName = this.buffer.trim();
				break;
			case GROUP:
				//Â
				break;
			case MESSAGE_BODY:
				// trim()Ȃ
				StringBuffer sb = new StringBuffer();
				sb.append(this.buffer);
				Tool.replaceAll(sb, "\r\n", "\n"); //$NON-NLS-1$ //$NON-NLS-2$
				Tool.replaceAll(sb, "\r", "\n"); //$NON-NLS-1$ //$NON-NLS-2$
				Tool.replaceAll(sb, "\n", EOL); //$NON-NLS-1$
				target.message = sb.toString();
				break;
			case SELECTION_START:
				target.selectionStart = Integer.parseInt(this.buffer);
				break;
			case SELECTION_END:
				target.selectionEnd = Integer.parseInt(this.buffer);
				break;
			case TOP_INDEX:
				target.topIndex = Integer.parseInt(this.buffer);
				break;
			case EXT_ITEM:
				if (curKey == null) {
					break;
				}
				// trim()Ȃ
				target.setExt(curKey, this.buffer);
				curKey = null;
				break;
			case PROTOCOL:
				target.protocol = this.buffer.trim();
				break;
			case LAUNCH_ID:
				target.launchId = this.buffer.trim();
				break;
			case WINDOW_LEFT:
				target.windowLeft = Integer.parseInt(this.buffer.trim());
				break;
			case WINDOW_TOP:
				target.windowTop = Integer.parseInt(this.buffer.trim());
				break;
			case WIDTH:
				target.width = Integer.parseInt(this.buffer.trim());
				break;
			case HEIGHT:
				target.height = Integer.parseInt(this.buffer.trim());
				break;
			case WINDOW_STYLE:
				target.windowStyle = Integer.parseInt(this.buffer.trim());
				break;
			case FOREGROUND_COLOR:
				parseColor(target, this.buffer.trim());
				break;
			case TRAY_RATIO:
				parseTrayRatio(target, this.buffer.trim());
				break;
			case MAGNIFICATION:
				if (isTrue()) {
					target.magnification = true;
				}
				break;
			case ALPHA:
				target.alpha = Integer.parseInt(this.buffer.trim());
				break;
			case ST_FONTFACE:
				if (target.colorScheme == null) {
					target.colorScheme = new MessageColorScheme();
				}
				target.colorScheme.stickyFontFace = this.buffer.trim();
				break;
			case ST_FONTSIZE:
				if (target.colorScheme == null) {
					target.colorScheme = new MessageColorScheme();
				}
				target.colorScheme.stickyFontSize = Integer
						.parseInt(this.buffer.trim());
				break;
			case ST_FONTSTYLE:
				if (target.colorScheme == null) {
					target.colorScheme = new MessageColorScheme();
				}
				target.colorScheme.stickyFontStyle = Integer
						.parseInt(this.buffer.trim());
				break;
			case ST_FOREGROUND:
				if (target.colorScheme == null) {
					target.colorScheme = new MessageColorScheme();
				}
				target.colorScheme.stickyForeground = parseIntArray(this.buffer
						.trim(), 3);
				break;
			case ST_BACKGROUND1:
				if (target.colorScheme == null) {
					target.colorScheme = new MessageColorScheme();
				}
				target.colorScheme.stickyBackground1 = parseIntArray(
						this.buffer.trim(), 3);
				break;
			case ST_BACKGROUND2:
				if (target.colorScheme == null) {
					target.colorScheme = new MessageColorScheme();
				}
				target.colorScheme.stickyBackground2 = parseIntArray(
						this.buffer.trim(), 3);
				break;
			case ATTACHMENT_NAME:
				curAttachment.name = this.buffer;
				break;
			case ATTACHMENT_TYPE:
				curAttachment.type = Integer.parseInt(this.buffer.trim());
				break;
			case ATTACHMENT_LOCALPATH:
				curAttachment.localPath = this.buffer;
				break;
			case ATTACHMENT_POSITION:
				curAttachment.position = Integer.parseInt(this.buffer.trim());
				break;
			case DESTINATION_TO:
				// Â`(Rs[^)
			case DESTINATION_COMPUTERNAME:
				curDestination.setComputerName(this.buffer.trim());
				break;
			case DESTINATION_LAUNCH_ID:
				curDestination.setLaunchId(this.buffer.trim());
				break;
			case DESTINATION_LOGINNAME:
				curDestination.setLoginName(this.buffer.trim());
				break;
			case DESTINATION_USERNAME:
				curDestination.setUserName(this.buffer.trim());
				break;
			case DESTINATION_RESULT:
				if (isTrue()) {
					curDestination.setResult(true);
				}
				break;
			default:
				break;
			}
		}

		/**
		 * buffer̕true݂ȂꍇtrueԂ܂B
		 * @return trueƂ݂Ȃ邩ǂ
		 */
		private boolean isTrue() {
			return this.buffer.length() != 0 && this.buffer.charAt(0) != '0';
		}

		/**
		 * Fr,g,b
		 * @param target Fݒ肳郁bZ[W
		 * @param str 2̃J}ŋ؂ꂽ
		 */
		private void parseColor(Message target, String str) {
			target.color = parseIntArray(str, 3);
		}

		/**
		 * trayRatio͂܂Btext,tray
		 * @param target gC䗦ݒ肳郁bZ[W
		 * @param str 1̃J}ŋ؂ꂽ
		 */
		private void parseTrayRatio(Message target, String str) {
			target.trayRatio = parseIntArray(str, 2);
		}

		/**
		 * J}؂̐int̔zɂĕԂ܂B
		 * @param str Ώۂ̕
		 * @param length z̒
		 * @return lengthɖȂꍇAɕϊłȂꍇnullԂ܂B
		 */
		private int[] parseIntArray(String str, int length) {
			String[] elements = str.split(",", length); //$NON-NLS-1$
			if (elements.length != length) {
				return null;
			}
			int[] result = new int[length];
			for (int i = 0; i < length; i++) {
				try {
					result[i] = Integer.parseInt(elements[i]);
				} catch (NumberFormatException e) {
					return null;
				}
			}
			return result;
		}

		/**
		 * @see org.xml.sax.ContentHandler#endElement(String, String, String)
		 */
		public void endElement(String namespaceURI, String localName,
				String qName) throws SAXException {

			Message target;
			if (isInReplyFrom) {
				target = curMessage.replyFrom;
			} else {
				target = curMessage;
			}

			// ǂݍݍς݂̏̕
			handleString();
			this.buffer = ""; //$NON-NLS-1$

			if (qName.equalsIgnoreCase("message")) { //$NON-NLS-1$
				//System.out.println("XML-in:" + curMessage);
				// MbZ[W͕ۑJς݂ɂ
				if (target.messageClass == Message.RECEIVED
						|| target.messageClass == Message.PENDING) {
					target.isOpened = true;
				}
				// bZ[WXgɉ
				result.add(curMessage);
			} else if (qName.equalsIgnoreCase("replyfrom")) { //$NON-NLS-1$
				// MbZ[W͕ۑJς݂ɂ
				if (target.messageClass == Message.RECEIVED
						|| target.messageClass == Message.PENDING) {
					target.isOpened = true;
				}
				isInReplyFrom = false;
			} else if (qName.equalsIgnoreCase("attacheditem")) { //$NON-NLS-1$
				if (target.attachments == null) {
					target.attachments = new ArrayList();
				}
				curAttachment.getFileInfo();
				curAttachment.status = Attachment.STATUS_FINISHED;
				target.attachments.add(curAttachment);
			} else if (qName.equalsIgnoreCase("destination")) { //$NON-NLS-1$
				target.addDestination(curDestination);
			}
			current = NONE;
		}

		/**
		 * @see org.xml.sax.ContentHandler#startElement(String, String, String, Attributes)
		 */
		public void startElement(String namespaceURI, String localName,
				String qName, Attributes atts) throws SAXException {

			if (qName.equalsIgnoreCase("id")) { //$NON-NLS-1$
				current = ID;
			} else if (qName.equalsIgnoreCase("messagetype")) { //$NON-NLS-1$
				// Message.MESSAGEɌ܂Ă
				current = NONE;
			} else if (qName.equalsIgnoreCase("messageclass")) { //$NON-NLS-1$
				current = MESSAGE_CLASS;
			} else if (qName.equalsIgnoreCase("windowmode")) { //$NON-NLS-1$
				current = WINDOW_MODE;
			} else if (qName.equalsIgnoreCase("encryptmethod")) { //$NON-NLS-1$
				current = ENCRYPT_METHOD;
			} else if (qName.equalsIgnoreCase("issaved")) { //$NON-NLS-1$
				current = IS_SAVED;
			} else if (qName.equalsIgnoreCase("ismulticast")) { //$NON-NLS-1$
				current = IS_MULTICAST;
			} else if (qName.equalsIgnoreCase("ispasswordrequired")) { //$NON-NLS-1$
				current = IS_PASSWORD_REQUIRED;
			} else if (qName.equalsIgnoreCase("isopened")) { //$NON-NLS-1$
				current = IS_OPENED;
			} else if (qName.equalsIgnoreCase("desktop")) { //$NON-NLS-1$
				current = DESKTOP;
			} else if (qName.equalsIgnoreCase("time")) { //$NON-NLS-1$
				current = TIME;
			} else if (qName.equalsIgnoreCase("ipaddress")) { //$NON-NLS-1$
				current = IP_ADDRESS;
			} else if (qName.equalsIgnoreCase("computername")) { //$NON-NLS-1$
				current = COMPUTER_NAME;
			} else if (qName.equalsIgnoreCase("port")) { //$NON-NLS-1$
				current = PORT;
			} else if (qName.equalsIgnoreCase("osusername")) { //$NON-NLS-1$
				current = OS_USER_NAME;
			} else if (qName.equalsIgnoreCase("username")) { //$NON-NLS-1$
				current = USER_NAME;
			} else if (qName.equalsIgnoreCase("group")) { //$NON-NLS-1$
				current = GROUP;
			} else if (qName.equalsIgnoreCase("messagebody")) { //$NON-NLS-1$
				current = MESSAGE_BODY;
			} else if (qName.equalsIgnoreCase("selectionstart")) { //$NON-NLS-1$
				current = SELECTION_START;
			} else if (qName.equalsIgnoreCase("selectionend")) { //$NON-NLS-1$
				current = SELECTION_END;
			} else if (qName.equalsIgnoreCase("topindex")) { //$NON-NLS-1$
				current = TOP_INDEX;
			} else if (qName.equalsIgnoreCase("ext")) { //$NON-NLS-1$
				current = EXT;
			} else if (qName.equalsIgnoreCase("extitem")) { //$NON-NLS-1$
				current = EXT_ITEM;
				curKey = atts.getValue("name"); //$NON-NLS-1$
			} else if (qName.equalsIgnoreCase("protocol")) { //$NON-NLS-1$
				current = PROTOCOL;
			} else if (qName.equalsIgnoreCase("launchid")) { //$NON-NLS-1$
				current = LAUNCH_ID;
			} else if (qName.equalsIgnoreCase("windowleft")) { //$NON-NLS-1$
				current = WINDOW_LEFT;
			} else if (qName.equalsIgnoreCase("windowtop")) { //$NON-NLS-1$
				current = WINDOW_TOP;
			} else if (qName.equalsIgnoreCase("width")) { //$NON-NLS-1$
				current = WIDTH;
			} else if (qName.equalsIgnoreCase("height")) { //$NON-NLS-1$
				current = HEIGHT;
			} else if (qName.equalsIgnoreCase("windowstyle")) { //$NON-NLS-1$
				current = WINDOW_STYLE;
			} else if (qName.equalsIgnoreCase("foregroundcolor")) { //$NON-NLS-1$
				current = FOREGROUND_COLOR;
			} else if (qName.equalsIgnoreCase("trayratio")) { //$NON-NLS-1$
				current = TRAY_RATIO;
			} else if (qName.equalsIgnoreCase("replyfrom")) { //$NON-NLS-1$
				current = REPLY_FROM;
				isInReplyFrom = true;
				curMessage.replyFrom = new Message();
			} else if (qName.equalsIgnoreCase("message")) { //$NON-NLS-1$
				isInReplyFrom = false;
				current = NONE;
				curMessage = new Message();
			} else if (qName.equalsIgnoreCase("messagestorage")) { //$NON-NLS-1$
				current = NONE;
				isInReplyFrom = false;
			} else if (qName.equalsIgnoreCase("attacheditem")) { //$NON-NLS-1$
				current = NONE;
				curAttachment = new Attachment();
			} else if (qName.equalsIgnoreCase("attachmentname")) { //$NON-NLS-1$
				current = ATTACHMENT_NAME;
			} else if (qName.equalsIgnoreCase("attachmenttype")) { //$NON-NLS-1$
				current = ATTACHMENT_TYPE;
			} else if (qName.equalsIgnoreCase("attachmentpath")) { //$NON-NLS-1$
				current = ATTACHMENT_LOCALPATH;
			} else if (qName.equalsIgnoreCase("attachmentposition")) { //$NON-NLS-1$
				current = ATTACHMENT_POSITION;
			} else if (qName.equalsIgnoreCase("destination")) { //$NON-NLS-1$
				curDestination = new Destination();
			} else if (qName.equalsIgnoreCase("to")) { //$NON-NLS-1$
				// Â`(Rs[^)
				current = DESTINATION_TO;
			} else if (qName.equalsIgnoreCase("destlaunchid")) { //$NON-NLS-1$
				current = DESTINATION_LAUNCH_ID;
			} else if (qName.equalsIgnoreCase("result")) { //$NON-NLS-1$
				current = DESTINATION_RESULT;
			} else if (qName.equalsIgnoreCase("destloginname")) { //$NON-NLS-1$
				current = DESTINATION_LOGINNAME;
			} else if (qName.equalsIgnoreCase("destcomputername")) { //$NON-NLS-1$
				current = DESTINATION_COMPUTERNAME;
			} else if (qName.equalsIgnoreCase("destusername")) { //$NON-NLS-1$
				current = DESTINATION_USERNAME;
			} else if (qName.equalsIgnoreCase("magnification")) { //$NON-NLS-1$
				current = MAGNIFICATION;
			} else if (qName.equalsIgnoreCase("alpha")) { //$NON-NLS-1$
				current = ALPHA;
			} else if (qName.equalsIgnoreCase("stfontface")) { //$NON-NLS-1$
				current = ST_FONTFACE;
			} else if (qName.equalsIgnoreCase("stfontsize")) { //$NON-NLS-1$
				current = ST_FONTSIZE;
			} else if (qName.equalsIgnoreCase("stfontstyle")) { //$NON-NLS-1$
				current = ST_FONTSTYLE;
			} else if (qName.equalsIgnoreCase("stforeground")) { //$NON-NLS-1$
				current = ST_FOREGROUND;
			} else if (qName.equalsIgnoreCase("stbackground1")) { //$NON-NLS-1$
				current = ST_BACKGROUND1;
			} else if (qName.equalsIgnoreCase("stbackground2")) { //$NON-NLS-1$
				current = ST_BACKGROUND2;
			} else {
				current = NONE;
			}
		}

		/**
		 * Returns the result.
		 * @return List l: Message
		 */
		public List getResult() {
			return result;
		}
	}

	/**
	 * Xi[ǉ܂B
	 */
	public void addListener(MessageStorageListener listener) {
		// TODO MessageStoragẽ\bh
	}

	/**
	 * Xi[폜܂B
	 */
	public void removeListener(MessageStorageListener listener) {
		// TODO MessageStoragẽ\bh
	}

	/**
	 * ۗ̎MbZ[WׂĎo܂B
	 * ̏ꍇnullԂ܂B
	 */
	public synchronized List getPending() {
		if (this.pending.isEmpty()) {
			return null;
		}
		List result = this.pending;
		this.pending = new ArrayList();
		return result;
	}

	/**
	 * ۗ̃bZ[W擾܂B
	 * @return bZ[W
	 */
	public synchronized int getPendingCount() {
		return this.pending.size();
	}

	/**
	 * \bZ[WׂĎo܂B
	 * @return MessageList
	 */
	protected synchronized List getDesktop() {
		List result = this.desktop;
		this.desktop = new ArrayList();
		return result;
	}
}
