package petaclone.petaroux;

import java.net.InetSocketAddress;

import jp.takayuki.tools.Tool;
import petaclone.Member;
import petaclone.Message;

/**
 * y^낤XUDP,TCPʃpPbg
 * 
 * @author Takayuki Shoji
 */
public class PetaxPacket {

	/**
	 * gmversion̒萔
	 */
	public static final String GMVERSION = "GIZMOIPMSG2"; //$NON-NLS-1$

	/**
	 * pPbg̎:o^(UDP)
	 */
	public static final String TYPE_SENDBROAD = "SENDBROAD"; //$NON-NLS-1$

	/**
	 * pPbg̎:o^ւ̕ԓ(UDP)
	 */
	public static final String TYPE_RECVBROAD = "RECVBROAD"; //$NON-NLS-1$

	/**
	 * pPbg̎:I(UDP)
	 */
	public static final String TYPE_GIZMOEND = "GIZMOEND"; //$NON-NLS-1$

	/**
	 * pPbg̎:bZ[W(TCP)
	 */
	public static final String TYPE_SENDMSG = "SENDMSG"; //$NON-NLS-1$

	/**
	 * pPbg̎:bZ[W̓B(TCP)
	 */
	public static final String TYPE_RETURN = "RETURN"; //$NON-NLS-1$

	/**
	 * GM(GIZMO}l[W?)o[W
	 * <p>
	 * GMVERSION萔
	 */
	public String gmversion;

	/**
	 * bZ[WV[PX
	 * <p>
	 * idSENDMSĜƂ̂1B0B
	 */
	public int msgseq;

	/**
	 * pPbg̎
	 * <p>
	 * TYPE_*萔
	 */
	public String id;

	/**
	 * GIZMO ID
	 */
	public String gizmoid;

	/**
	 * OSOC[U
	 */
	public String username;

	/**
	 * zXg
	 */
	public String hostname;

	/**
	 * [U̕\
	 */
	public String displayname;

	/**
	 * IPAhX
	 * <p>
	 * bZ[WMmF"0.0.0.0"(IPv4)܂"0::"(IPv6)B
	 */
	public String ipaddress;

	/**
	 * bZ[W
	 * <p>
	 * TCP̂
	 */
	public Message msg;

	/*
	 * attachfile
	 * optiondata
	 */

	/**
	 * MIPAhX
	 * <p>
	 * nullȊȌꍇAMɗp܂B
	 */
	public InetSocketAddress address;

	/**
	 * gizmoidǂ`FbN܂B
	 * 3216iB
	 * @param str 
	 * @return gizmoid̂Ƃtrue
	 */
	static boolean isGizmoid(String str) {
		if (str == null || str.length() != 32) {
			return false;
		}
		for (int i = 0; i < 32; i++) {
			char c = str.charAt(i);
			if (('0' > c && c > '9') && ('a' > c && c > 'f')) {
				return false;
			}
		}
		return true;
	}

	/**
	 * gizmoid𐶐܂B
	 * @return gizmoid
	 */
	public static String generateGizmoid() {
		StringBuffer sb = new StringBuffer();

		for (int i = 0; i < 16; i++) {
			int v = (int) Math.round(Math.random() * 256D);
			Tool.intToHexString(sb, v);
		}

		return sb.toString();
	}

	/**
	 * CX^X̏ԂXMLɕϊ܂B
	 * @return XML
	 */
	public String toXml() {
		StringBuffer sb = new StringBuffer();
		sb.append("<?xml version=\"1.0\" ?>"); //$NON-NLS-1$
		sb.append("<IPMSGXmlData>"); //$NON-NLS-1$
		append(sb, "gmversion", GMVERSION); //$NON-NLS-1$
		append(sb, "msgseq", Integer.toString(msgseq)); //$NON-NLS-1$
		append(sb, "id", id); //$NON-NLS-1$
		append(sb, "gizmoid", gizmoid); //$NON-NLS-1$
		append(sb, "username", username); //$NON-NLS-1$
		append(sb, "hostname", hostname); //$NON-NLS-1$
		append(sb, "displayname", displayname); //$NON-NLS-1$
		append(sb, "ipaddress", ipaddress); //$NON-NLS-1$
		sb.append("<msg>"); //$NON-NLS-1$
		if (msg != null) {
			StringBuffer sb2 = new StringBuffer();
			sb2.append("<message"); //$NON-NLS-1$

			// uid
			sb2.append(" uid=\""); //$NON-NLS-1$
			Tool.escape(sb2, msg.getExt("uid", "")); //$NON-NLS-1$ //$NON-NLS-2$
			sb2.append('"');

			// face
			sb2.append(" face=\""); //$NON-NLS-1$
			Tool.escape(sb2, msg.getExt("face", "normal")); //$NON-NLS-1$ //$NON-NLS-2$
			sb2.append('"');

			// skinurl
			sb2.append(" skinurl=\""); //$NON-NLS-1$
			sb2.append("http://www.peta.gr.jp/x/whatschr.html?cid=DEFAULT"); //$NON-NLS-1$
			sb2.append('"');

			// skin
			// TODO y^L̃JX^}CY
			sb2.append(" skin=\"").append("DEFAULT").append('"'); //$NON-NLS-1$ //$NON-NLS-2$

			// displayname
			sb2.append(" displayname=\""); //$NON-NLS-1$
			Tool.escape(sb2, displayname);
			sb2.append('"');

			// gizmoid
			sb2.append(" gizmoid=\"");//$NON-NLS-1$
			Tool.escape(sb2, gizmoid);
			sb2.append('"');

			sb2.append('>');

			// color
			sb2.append("<txt color=\""); //$NON-NLS-1$
			if (msg.color != null) {
				Tool.intToHexString(sb2, msg.color[0]);
				Tool.intToHexString(sb2, msg.color[1]);
				Tool.intToHexString(sb2, msg.color[2]);
			} else {
				sb2.append("000000"); //$NON-NLS-1$
			}
			sb2.append("\">"); //$NON-NLS-1$

			// {

			StringBuffer body = new StringBuffer();
			if (msg.message != null)
				body.append(msg.message);
			Tool.replaceAll(sb, "\r\n", "\n"); //$NON-NLS-1$ //$NON-NLS-2$
			Tool.replaceAll(sb, "\r", "\n"); //$NON-NLS-1$ //$NON-NLS-2$
			Tool.replaceAll(sb, "\n", "\r\n"); //$NON-NLS-1$ //$NON-NLS-2$

			Tool.escape(sb2, body.toString());
			sb2.append("</txt>"); //$NON-NLS-1$
			sb2.append("</message>"); //$NON-NLS-1$
			Tool.escape(sb, sb2.toString());
		}
		sb.append("</msg>"); //$NON-NLS-1$
		sb.append("<attachfile></attachfile><optiondata></optiondata>"); //$NON-NLS-1$

		sb.append("</IPMSGXmlData>"); //$NON-NLS-1$
		return sb.toString();
	}

	/**
	 * XMLvfǉ܂B
	 * @param sb obt@
	 * @param name vf
	 * @param value l
	 */
	private void append(StringBuffer sb, String name, String value) {
		sb.append('<').append(name).append('>');
		sb.append(value);
		sb.append("</").append(name).append('>'); //$NON-NLS-1$
	}

	/**
	 * Memberɕϊ܂B
	 * @param launchId NID
	 * @return Member
	 */
	public Member toMember(String launchId) {
		Member m = new Member();
		m.computerName = hostname;
		m.userName = displayname;
		m.osUserName = username;
		m.setLocation(address);
		m.group = null;
		m.launchId = launchId;
		return m;
	}

	/**
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		String str = "PetaxPacket@" + hashCode(); //$NON-NLS-1$
		str += "{"; //$NON-NLS-1$
		str += "gmversion=" + gmversion; //$NON-NLS-1$
		str += ", msgseq=" + msgseq; //$NON-NLS-1$
		str += ", id=" + id; //$NON-NLS-1$
		str += ", gizmoid=" + gizmoid; //$NON-NLS-1$
		str += ", username=" + username; //$NON-NLS-1$
		str += ", hostname=" + hostname; //$NON-NLS-1$
		str += ", displayname=" + displayname; //$NON-NLS-1$
		str += ", ipaddress=" + ipaddress; //$NON-NLS-1$
		str += ", msg=" + msg; //$NON-NLS-1$
		str += "}"; //$NON-NLS-1$
		return str;
	}

	/**
	 * o[ǂA܂͕ύX̗L𔻒肵܂B
	 * <p>
	 * 
	 * 
	 * @param other rΏ
	 * @return ꍇtrue
	 */
	public boolean isSameMember(PetaxPacket other) {
		if (!this.displayname.equals(other.displayname)) {
			return false;
		}
		if (!this.ipaddress.equals(other.ipaddress)) {
			return false;
		}

		if (!this.gizmoid.equals(other.gizmoid)) {
			return false;
		}
		if (!this.username.equals(other.username)) {
			return false;
		}
		if (!this.hostname.equals(other.hostname)) {
			return false;
		}
		return true;
	}

	/**
	 * @return [U[ʎqԂ܂B
	 */
	public String getIdentifier() {
		return this.address.getAddress().getHostAddress();
	}
}
