package petaclone.swt;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;

import petaclone.EventBroker;
import petaclone.Events;

/**
 * AvP[VŜŗLȃV[gJbg
 * @author Takayuki Shoji
 */
public class SWTAppGlobalShortcut implements Listener {

	/**
	 * EventBroker
	 */
	private EventBroker broker;

	/**
	 * RXgN^
	 * @param broker EventBroker
	 */
	public SWTAppGlobalShortcut(EventBroker broker) {
		this.broker = broker;
	}

	/**
	 * Cxg܂B
	 */
	public void handleEvent(Event event) {

		if (event.type != SWT.KeyDown) {
			return;
		}

		if (event.stateMask == SWT.MOD1) {
			processMod1Event(event);
		} else if (event.stateMask == (SWT.MOD1 | SWT.MOD2)) {
			processShiftMod1Event(event);
		}
	}

	/**
	 * Shift+CtrlL[̃Cxg
	 * 
	 * @param event
	 */
	private void processShiftMod1Event(Event event) {
		switch (event.keyCode) {
		case 'd':
			broker.notifyEvent(Events.ShowDesktopSearch, null);
			break;
		case 'n':
			broker.notifyEvent(Events.OpenNewStickiesSet, null);
			break;
		default:
			return;
		}
	}

	/**
	 * CtrlL[̃CxgB
	 * 
	 * @param event
	 */
	private void processMod1Event(Event event) {
		switch (event.keyCode) {
		case 'b':
			broker.notifyEvent(Events.MinimizeAllWindows, null);
			break;
		case 'j':
			broker.notifyEvent(Events.FocusMainWindow, null);
			break;
		case 'm':
			broker.notifyEvent(Events.DisplayWindow, null);
			break;
		case 'n':
			broker.notifyEvent(Events.OpenBlankMessageWindow, null);
			break;
		default:
			return;
		}
	}
}
