package petaclone.swt;

import jp.takayuki.swt.util.SWTUtils;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Monitor;
import org.eclipse.swt.widgets.Shell;

/**
 * L[ɂEBhEړB
 * <p>
 * Shell, ܂Control̃TuNXɓKpł܂B
 * <p>
 * SWT.Traverse
 * 
 * @author Takayuki Shoji
 */
public class SWTArrowKeyWindowMoveAction implements Listener {

	public void handleEvent(Event event) {
		if (event.type != SWT.Traverse) {
			return;
		}

		//System.out.println(getClass().getSimpleName() + ":src=" + event.widget);

		if (event.stateMask != 0 && event.stateMask != SWT.MOD1
				&& event.stateMask != SWT.MOD2) {
			return;
		}
		// L[ł̈ړ
		if (SWTUtils.isArrowKeyCode(event.keyCode)) {
			Shell shell = SWTUtils.getShellFromWidget(event.widget);
			moveWindow(event.keyCode, event.stateMask, shell);
		}
		event.doit = true;
	}

	/**
	 * EBhEړ܂B
	 * @param keyCode L[R[h(SWT.ARROW_*)
	 * @param statusMask CL[
	 * @param shell Shell
	 */
	private void moveWindow(int keyCode, int statusMask, Shell shell) {

		if (statusMask == SWT.MOD1) {
			moveWindowAsFarAsPossible(shell, keyCode);

		} else if (statusMask == SWT.MOD2) {
			// 1pxړ
			moveWindowSmall(shell, keyCode, 1);

		} else if (statusMask == 0) {
			// ړ
			moveWindowSmall(shell, keyCode, 16);
		}
	}

	/**
	 * EBhE𑼂̃EBhEɂԂ܂łł邾ړ܂B
	 * @param current Shell
	 * @param keyCode L[R[h(SWT.ARROW_*)
	 */
	private void moveWindowAsFarAsPossible(Shell current, int keyCode) {
		Monitor[] monitors = current.getDisplay().getMonitors();

		/*
		 * fBXvC̃NCAg̈̒[ɐڂĂ邩ǂ
		 * ׂB
		 */
		boolean touch;
		Rectangle cRect = current.getBounds();
		Monitor curMonitor = SWTUtils.getMonitorByCoordinate(monitors, cRect.x,
				cRect.y, current.getDisplay());
		Rectangle client = curMonitor.getClientArea();
		switch (keyCode) {
		case SWT.ARROW_UP:
			touch = SWTUtils.isSharedBorderUp(client, cRect);
			break;
		case SWT.ARROW_DOWN:
			touch = SWTUtils.isSharedBorderBottom(client, cRect);
			break;
		case SWT.ARROW_LEFT:
			touch = SWTUtils.isSharedBorderLeft(client, cRect);
			break;
		case SWT.ARROW_RIGHT:
			touch = SWTUtils.isSharedBorderRight(client, cRect);
			break;
		default:
			return;
		}

		if (touch) {
			/*
			 * fBXvC̒[ɐڂĂƂAאڂƎvfBXvC
			 * WɈړA̍WɊYMonitor擾B
			 * Monitor擾łꍇ̓NCAg̈Ɏ܂悤ɈړB
			 */
			Rectangle curBounds = curMonitor.getBounds();
			switch (keyCode) {
			case SWT.ARROW_UP:
				cRect.y = curBounds.y - 1;
				break;
			case SWT.ARROW_DOWN:
				cRect.y = curBounds.y + curBounds.height;
				break;
			case SWT.ARROW_LEFT:
				cRect.x = curBounds.x - 1;
				break;
			case SWT.ARROW_RIGHT:
				cRect.x = curBounds.x + curBounds.width;
				break;
			}
			int index = SWTUtils.getMonitorIndexByCoordinate(monitors, cRect.x,
					cRect.y);
			if (index != -1) {
				Monitor dMonitor = monitors[index];
				fenceDisplayClientRectangle(cRect, dMonitor.getClientArea());
				current.setLocation(cRect.x, cRect.y);
			}
			return;
		}

		// Xgbv̍WW
		Shell[] shells = SWTUtils.getVisibleShells(current, true, true);
		int[] coordinates = new int[monitors.length * 2 + shells.length * 2];

		// Monitor
		for (int i = 0; i < monitors.length; i++) {
			Rectangle sRect = monitors[i].getClientArea();
			collectCoordinate(keyCode, coordinates, i, sRect);
		}

		// Shell
		for (int i = 0; i < shells.length; i++) {
			Rectangle sRect = shells[i].getBounds();
			collectCoordinate(keyCode, coordinates, monitors.length + i, sRect);
		}

		// lɌ݂̍Wݒ
		int initial;
		switch (keyCode) {
		case SWT.ARROW_UP:
			initial = cRect.y;
			break;
		case SWT.ARROW_DOWN:
			initial = cRect.y + cRect.height;
			break;
		case SWT.ARROW_LEFT:
			initial = cRect.x;
			break;
		case SWT.ARROW_RIGHT:
			initial = cRect.x + cRect.width;
			break;
		default:
			return;
		}

		// ߂lI
		int coordinate = -1;
		for (int i = 0; i < coordinates.length; i++) {
			switch (keyCode) {
			case SWT.ARROW_UP:
			case SWT.ARROW_LEFT:
				// initial菬ł邾傫l
				if (initial > coordinates[i]) {
					coordinate = Math.max(coordinate, coordinates[i]);
				}
				break;
			case SWT.ARROW_DOWN:
			case SWT.ARROW_RIGHT:
				// initial傫ł邾l
				if (initial < coordinates[i]) {
					if (coordinate == -1) {
						coordinate = coordinates[i];
					} else {
						coordinate = Math.min(coordinate, coordinates[i]);
					}
				}
				break;
			}
		}

		// ړ̃NCAg̈擾
		Rectangle dRect = SWTUtils.getMonitorClientByCoordinate(monitors,
				cRect.x, cRect.y, current.getDisplay());
		if (coordinate == -1) {
			switch (keyCode) {
			case SWT.ARROW_UP:
				coordinate = dRect.y;
				break;
			case SWT.ARROW_DOWN:
				coordinate = dRect.y + dRect.height;
				break;
			case SWT.ARROW_LEFT:
				coordinate = dRect.x;
				break;
			case SWT.ARROW_RIGHT:
				coordinate = dRect.x + dRect.width;
				break;
			default:
				return;
			}
		}

		// ړ
		switch (keyCode) {
		case SWT.ARROW_UP:
			cRect.y = coordinate;
			break;
		case SWT.ARROW_DOWN:
			cRect.y = coordinate - cRect.height;
			break;
		case SWT.ARROW_LEFT:
			cRect.x = coordinate;
			break;
		case SWT.ARROW_RIGHT:
			cRect.x = coordinate - cRect.width;
			break;
		default:
			return;
		}
		fenceDisplayClientRectangle(cRect, dRect);
		current.setLocation(cRect.x, cRect.y);
	}

	/**
	 * WW܂B
	 * 
	 * @param keyCode L[R[h(SWT.ARROW_*)
	 * @param coordinates Wݒ肷z
	 * @param i CfbNX
	 * @param sRect W̎擾
	 */
	private void collectCoordinate(int keyCode, int[] coordinates, int i,
			Rectangle sRect) {
		switch (keyCode) {
		case SWT.ARROW_UP:
		case SWT.ARROW_DOWN:
			coordinates[2 * i] = sRect.y;
			coordinates[2 * i + 1] = sRect.y + sRect.height;
			break;
		case SWT.ARROW_LEFT:
		case SWT.ARROW_RIGHT:
			coordinates[2 * i] = sRect.x;
			coordinates[2 * i + 1] = sRect.x + sRect.width;
			break;
		default:
			throw new IllegalArgumentException("Invalid keyCode:" + keyCode); //$NON-NLS-1$
		}
	}

	/**
	 * EBhEړ܂B
	 * @param sh Shell
	 * @param keyCode L[R[h(SWT.ARROW_*)
	 * @param move ړ
	 */
	private void moveWindowSmall(Shell sh, int keyCode, int move) {
		Rectangle cRect = sh.getBounds();

		// ݂̃NCAg̈擾
		Monitor[] monitors = sh.getDisplay().getMonitors();
		Monitor curMonitor = SWTUtils.getMonitorByCoordinate(monitors, cRect.x,
				cRect.y, sh.getDisplay());
		Rectangle curDisplay = curMonitor.getBounds();
		Rectangle curClient = curMonitor.getClientArea();

		int x;
		int y;
		boolean touch = false;
		/*
		 * [ƐڂĂꍇ͊ẽEBhETCYړ
		 * ړ̃NCAg̈̊OƏdȂƂfenceDisplayClientRectangleŕ␳
		 */
		switch (keyCode) {
		case SWT.ARROW_UP:
			x = 0;
			if (SWTUtils.isSharedBorderUp(curClient, cRect)) {
				// EBhE̍ƔNCAg݂̈̌
				y = -cRect.height - (curDisplay.y - curClient.y);
				touch = true;
			} else {
				y = -move;
			}
			break;

		case SWT.ARROW_DOWN:
			x = 0;
			if (SWTUtils.isSharedBorderBottom(curClient, cRect)) {
				// EBhE̍ƔNCAg݂̈̌𑫂
				y = cRect.height
						+ (curDisplay.y + curDisplay.height - curClient.y - curClient.height);
				touch = true;
			} else {
				y = move;
			}
			break;

		case SWT.ARROW_LEFT:
			if (SWTUtils.isSharedBorderLeft(curClient, cRect)) {
				// EBhE̍ƔNCAg݂̈̌
				x = -cRect.width - (curDisplay.x - curClient.x);
				touch = true;
			} else {
				x = -move;
			}
			y = 0;

			break;
		case SWT.ARROW_RIGHT:
			if (SWTUtils.isSharedBorderRight(curClient, cRect)) {
				// EBhE̍ƔNCAg݂̈̌𑫂
				x = cRect.width
						+ (curDisplay.x + curDisplay.width - curClient.x - curClient.width);
				touch = true;
			} else {
				x = move;
			}
			y = 0;

			break;
		default:
			return;
		}
		cRect.x += x;
		cRect.y += y;

		// ړ̃NCAg̈擾
		Rectangle destClient;
		if (touch) {
			int nextMonitorIndex = SWTUtils.getMonitorIndexByCoordinate(
					monitors, cRect.x, cRect.y);
			if (nextMonitorIndex == -1) {
				// ݂̗̈ɗ߂
				destClient = curClient;
			} else {
				destClient = monitors[nextMonitorIndex].getClientArea();
			}
		} else {
			// ݂̗̈ɗ߂
			destClient = curClient;
		}

		fenceDisplayClientRectangle(cRect, destClient);
		sh.setLocation(cRect.x, cRect.y);
	}

	/**
	 * fBXvC̃NCAg̈Ɏ܂悤Ɉړ̗̈␳܂B
	 * @param cRect ړ̗̈
	 * @param dRect fBXvC̃NCAg̈
	 */
	private void fenceDisplayClientRectangle(Rectangle cRect, Rectangle dRect) {
		cRect.x = Math.max(cRect.x, dRect.x);
		cRect.x = Math.min(cRect.x, dRect.width + dRect.x - cRect.width);

		cRect.y = Math.max(cRect.y, dRect.y);
		cRect.y = Math.min(cRect.y, dRect.height + dRect.y - cRect.height);
	}

}
