package petaclone.swt;

import jp.takayuki.swt.util.SWTUtils;

import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Monitor;

/**
 * }EX|C^̈ʒuɃEBhËʒu肵܂B
 * 
 * @author Takayuki Shoji
 */
public class SWTMousePositionWindowLocator implements SWTWindowLocator {

	public Rectangle getLocation(int windowWidth, int windowHeight,
			int padding, int spacing) {
		Display display = Display.getDefault();
		Point pos = display.getCursorLocation();
		Monitor monitor = SWTUtils
				.getMonitorByCoordinate(pos.x, pos.y, display);
		Rectangle client = monitor.getClientArea();

		if (windowHeight > client.height - (padding * 2)) {
			windowHeight = client.height - (padding * 2);
		}
		if (windowWidth > client.width - (padding * 2)) {
			windowWidth = client.width - (padding * 2);
		}

		Rectangle result = new Rectangle(pos.x - (windowWidth / 2), pos.y - 8,
				windowWidth, windowHeight);

		if (result.x < client.x + padding) {
			result.x = client.x + padding;
		} else if (result.x + windowWidth > client.x + client.width - padding) {
			result.x = client.x + client.width - windowWidth - padding;
		}

		if (result.y < client.y + padding) {
			result.y = client.y + padding;
		} else if (result.y + windowHeight > client.y + client.height - padding) {
			result.y = Math.max(client.y + client.height - windowHeight
					- padding, client.y + padding);
		}

		return result;
	}

}
