package petaclone.swt;

import jp.takayuki.swt.util.SWTUtils;
import jp.takayuki.tools.MessageMap;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import petaclone.Members;
import petaclone.UniqueMember;

/**
 * u悭vo^_CAO
 * @author Takayuki Shoji
 */
public class SWTRegisterDialog {
	/**
	 * bZ[W\[X
	 */
	private static final MessageMap mm = MessageMap.getMessageMap();

	/** o[Ǘ */
	private Members members;

	/** _CAOShell */
	private Shell shell;

	/**
	 * ҏWΏۂ̃o[
	 */
	private UniqueMember member;

	/**
	 * VK
	 */
	private boolean isNewMember;

	// eLXg{bNX
	/** eLXg{bNX: [U */
	private Text userNameText;

	/** eLXg{bNX: OC[U */
	private Text osUserNameText;

	/** eLXg{bNX: Rs[^ */
	private Text computerNameText;

	/** eLXg{bNX: O[v */
	private Text groupText;

	/**
	 * RXgN^
	 * @param main CEBhE
	 * @param parent eEBWFbg
	 * @param members o[Ǘ
	 * @param member ҏWΏۂ̃o[
	 */
	public SWTRegisterDialog(SWTMainWindow main, Shell parent, Members members,
			UniqueMember member) {
		this.members = members;
		if (member == null) {
			this.isNewMember = true;
			this.member = new UniqueMember(null);
		} else {
			this.member = member;
		}
		init(parent);
		shell.open();
		while (!shell.isDisposed()) {
			if (!shell.getDisplay().readAndDispatch()) {
				shell.getDisplay().sleep();
			}
		}
	}

	/**
	 * 1s̃CAEg쐬܂B
	 * @param labelKey x̃L[
	 * @param tooltipKey c[`bṽL[
	 * @return eLXg{bNX
	 */
	private Text createRow(String labelKey, String tooltipKey) {
		Label label = new Label(shell, SWT.NULL);
		label.setText(mm.get(labelKey));
		label.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_END));
		Text text = new Text(shell, SWT.SINGLE | SWT.BORDER);
		text.setToolTipText(mm.get(tooltipKey));
		text.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_FILL));
		return text;
	}

	/**
	 * EBWFbg𐶐܂B
	 * @param parent eEBWFbg
	 */
	private void init(Shell parent) {

		shell = new Shell(parent, SWT.DIALOG_TRIM | SWT.APPLICATION_MODAL);
		GridLayout gl = new GridLayout();
		gl.numColumns = 2;
		gl.makeColumnsEqualWidth = true;
		shell.setLayout(gl);
		shell.setText(mm.get("SWTRegisterDialog.title")); //$NON-NLS-1$

		//
		// eLXg{bNX
		//
		userNameText = createRow("SWTRegisterDialog.userName", //$NON-NLS-1$
				"SWTRegisterDialog.userName.tooltip"); //$NON-NLS-1$
		osUserNameText = createRow("SWTRegisterDialog.loginName", //$NON-NLS-1$
				"SWTRegisterDialog.loginName.tooltip"); //$NON-NLS-1$
		computerNameText = createRow("SWTRegisterDialog.computerName", //$NON-NLS-1$
				"SWTRegisterDialog.computerName.tooltip"); //$NON-NLS-1$
		groupText = createRow("SWTRegisterDialog.groupName", //$NON-NLS-1$
				"SWTRegisterDialog.groupName.tooltip"); //$NON-NLS-1$

		if (!isNewMember) {

			userNameText.setText(member.getUserName());
			// ɕҏW\

			osUserNameText.setText(member.getOsUserName());
			osUserNameText.setEditable(false);

			computerNameText.setText(member.getComputerName());
			computerNameText.setEditable(false);

			if (member.getGroup() != null) {
				// KDEp̃`FbN
				groupText.setText(member.getGroup());
			}
			// ɕҏW\

		}

		//
		// {^
		//
		GridData data = new GridData();
		data.horizontalAlignment = SWT.CENTER;
		data.horizontalSpan = 2;

		Composite composite = new Composite(shell, SWT.NULL);
		composite.setLayoutData(data);

		RowLayout buttonLayout = new RowLayout();
		buttonLayout.pack = false;
		composite.setLayout(buttonLayout);

		Button okButton = new Button(composite, SWT.PUSH);
		okButton.setText(mm.get("SWTRegisterDialog.ok")); //$NON-NLS-1$
		okButton.addSelectionListener(new OkButtonSelected());

		Button cancelButton = new Button(composite, SWT.PUSH);
		cancelButton.setText(mm.get("SWTRegisterDialog.cancel")); //$NON-NLS-1$
		cancelButton.addSelectionListener(new CancelButtonSelected());

		shell.setDefaultButton(okButton);
		shell.pack();
	}

	/**
	 * ͂`FbNA_CAO\܂B
	 * @return false 肪
	 */
	boolean checkInput() {
		String str;
		str = userNameText.getText();
		if (str.length() == 0) {
			SWTUtils.showWarning(shell, mm
					.get("SWTRegisterDialog.inputUserName")); //$NON-NLS-1$
			userNameText.setFocus();
			return false;
		}
		str = computerNameText.getText();
		if (str.length() == 0) {
			SWTUtils.showWarning(shell, mm
					.get("SWTRegisterDialog.inputComputerName")); //$NON-NLS-1$
			computerNameText.setFocus();
			return false;
		}

		return true;
	}

	/**
	 * OK̏
	 */
	class OkButtonSelected extends SelectionAdapter {
		public void widgetSelected(SelectionEvent arg0) {
			if (!checkInput()) {
				return;
			}

			// eLXgEBWFbgf[^o
			member.setUserName(userNameText.getText());
			member.setOsUserName(osUserNameText.getText());
			member.setComputerName(computerNameText.getText().toUpperCase());
			member.setGroup(groupText.getText());

			// o^
			members.register(member);
			members.saveRegisteredMembers();
			shell.close();
		}
	}

	/**
	 * LZ̏
	 */
	class CancelButtonSelected extends SelectionAdapter {
		public void widgetSelected(SelectionEvent arg0) {
			shell.close();
		}
	}
}
