package petaclone.swt;

import jp.takayuki.swt.util.SWTUtils;
import jp.takayuki.tools.Tool;

import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;

import petaclone.AppPreferences;
import petaclone.EventBroker;
import petaclone.Events;
import petaclone.Member;
import petaclone.Members;
import petaclone.Message;
import petaclone.MessengerFacade;
import petaclone.ServerListener;

/**
 * <p>T[oXi[B
 * ̃bZ[WbZW[󂯎A
 * K؂ȃIuWFNgɒʒm܂B</p>
 * <ul>
 * 	<li>o[̑ݒʒm</li>
 * 	<li>bZ[W̓ʒm</li>
 * 	<li>G[bZ[W</li>
 * </ul>
 * 
 * @author Takayuki Shoji
 */
public class SWTServerListener implements ServerListener {

	/** 񓯊sp */
	private Display display;

	/** G[_CAOp */
	private Shell shell;

	///** AvP[Vݒ */
	//private AppPreferences pref;

	/** o[Ǘ */
	private Members members;

	/**
	 * Cxg̒ʒm
	 */
	private EventBroker eventBroker;

	/**
	 * Cxg`Bꍇtrue
	 */
	private boolean transmit = true;

	/**
	 * RXgN^
	 * @param main CEBhE
	 * @param pref ݒ
	 * @param facade MessengerFacade
	 * @param eventBroker Cxg
	 */
	SWTServerListener(SWTMainWindow main, AppPreferences pref,
			MessengerFacade facade, EventBroker eventBroker) {

		this.shell = main.getShell();
		this.display = this.shell.getDisplay();
		//this.pref = pref;
		this.members = main.members;
		this.eventBroker = eventBroker;
	}

	/**
	 * Cxg̓`Bsǂݒ肵܂B
	 * ltrueB
	 * @param transmit Cxg`BꍇtrueB`BȂꍇfalseB
	 */
	public void setEventTransmission(boolean transmit) {
		this.transmit = transmit;
	}

	/**
	 * @see petaclone.ServerListener#addMember(Member)
	 */
	public void addMember(Member member) {
		if (transmit)
			members.add(member);
	}

	/**
	 * @see petaclone.ServerListener#deleteMember(Member)
	 */
	public void deleteMember(Member member) {
		if (transmit)
			members.delete(member);
	}

	/**
	 * s݃[h̕ύXʒm<br>
	 * IP Messenger
	 * @see petaclone.ServerListener#updateMember(Member)
	 */
	public void updateMember(Member member) {
		if (transmit)
			members.add(member);
	}

	/**
	 * @see petaclone.ServerListener#onError(String, Throwable)
	 */
	public void onError(String message, Throwable t) {
		// TODO BrokerΉEʒmp^[̓Kp
		if (transmit)
			display.asyncExec(new OnError(message, t));
	}

	/**
	 * G[_CAO\Xbh
	 */
	private class OnError implements Runnable {
		/**
		 * G[bZ[W
		 */
		private String message;

		/**
		 * Throwable
		 */
		private Throwable throwable;

		/**
		 * RXgN^
		 * @param message G[bZ[W
		 * @param t ThrowableIuWFNg
		 */
		OnError(String message, Throwable t) {
			this.message = message;
			this.throwable = t;
		}

		public void run() {
			Shell activeShell = display.getActiveShell();
			shell.setActive();
			if (activeShell == null) {
				activeShell = shell;
			}

			String msg = message;
			if (throwable != null) {
				msg += "\n"; //$NON-NLS-1$
				msg += Tool.getStackTraceString(throwable);
			}
			SWTUtils.showError(activeShell, msg);
		}
	}

	/**
	 * @see petaclone.ServerListener#onMessage(Message)
	 */
	public void onMessage(Message message) {
		// bZ[WMCxgʒm
		if (transmit)
			eventBroker.notifyEvent(Events.NewMessageReceived, message);
	}

	/**
	 * Jʒm
	 * @see petaclone.ServerListener#onOpenNotice(Message)
	 */
	public void onOpenNotice(Message message) {
		if (transmit)
			eventBroker.notifyEvent(Events.OpenNoticeReceived, message);
	}
}
