package petaclone.swt;

import java.util.Random;

import jp.takayuki.swt.util.SWTUtils;

import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.widgets.Display;

/**
 * fBXvCςݏdȂ悤Ɉʒu肵܂B
 * 
 * @author Takayuki Shoji
 */
public class SWTStackWindowLocator implements SWTWindowLocator {

	/**
	 * 
	 */
	private Random random = new Random();

	/**
	 * dȂȂʒu擾܂B
	 * 
	 * @param windowWidth VzuEBhẺ
	 * @param windowHeight VzuEBhE̍
	 * @param padding fBXvC̒[̗]
	 * @param spacing EBhEƃEBhE̊Ԋu
	 * @return ʒuB擾łȂꍇnullB
	 */
	public Rectangle getLocation(int windowWidth, int windowHeight, int padding,
			int spacing) {

		Rectangle displaySize = SWTUtils.getPointedMonitorClient(Display
				.getDefault());

		if (windowHeight > displaySize.height - (padding * 2)) {
			windowHeight = displaySize.height - (padding * 2);
		}
		if (windowWidth > displaySize.width - (padding * 2)) {
			windowWidth = displaySize.width - (padding * 2);
		}

		Rectangle[] rects = SWTUtils.getVisibleShellRects();

		// 0+4fBXvC̉ƂāAKz̗擾
		double r;
		do {
			r = random.nextGaussian();
		} while (Math.abs(r) > 2.0d);
		r += 2.0d;

		// ݂̃fBXvCɊZ
		final int initialX = (int) ((displaySize.width - windowWidth - padding)
				* r / 4)
				+ displaySize.x;
		// fBXvC̉[
		final int initialY = displaySize.height + displaySize.y - windowHeight
				- padding;

		Rectangle windowRect = new Rectangle(initialX, initialY, windowWidth,
				windowHeight);

		Point p = searchBlankToTop(padding, displaySize, rects, initialX,
				windowRect);
		if (p != null) {
			return new Rectangle(p.x, p.y, windowWidth, windowHeight);
		}

		// 
		windowRect.x = displaySize.x + (displaySize.width - windowWidth) / 2;
		windowRect.y = initialY;

		// 疄߂Ă
		{
			// xWvZ
			// An = An-1 * -1 + 1
			int[] targets = new int[displaySize.width / windowWidth];
			for (int i = 0; i < targets.length / 2; i++) {
				targets[i * 2] = i;
				targets[i * 2 + 1] = (i + 1) * -1;
			}
			if (targets.length % 2 != 0) {
				targets[targets.length - 1] = -1 * targets.length / 2;
			}

			// 
			int currentY = initialY;
			do {
				for (int i = 0; i < targets.length; i++) {
					windowRect.x = targets[i] * windowWidth + displaySize.width
							/ 2 + displaySize.x;

					if (SWTUtils.withinDisplay(displaySize, windowWidth,
							windowHeight, padding, windowRect.x, windowRect.y)) {
						Rectangle rect = SWTUtils.getIntersectRect(windowRect,
								rects);
						if (rect == null) {
							return windowRect;
						}
						if (SWTUtils.containsRect(rect, windowRect)) {
							continue;
						}

						// ړʂȂɈړ
						// EɈړƂ
						int rdiff = (rect.x + rect.width) - windowRect.x;
						// ɈړƂ
						int ldiff = (rect.x - windowRect.width) - windowRect.x;
						// ɈړƂ
						int udiff = (rect.y - windowRect.height) - windowRect.y;
						// ɈړƂ
						//int ddiff = (rect.y + rect.height) - windowRect.y;

						int minIndex = minIndex(new int[] { Math.abs(rdiff),
								Math.abs(ldiff), Math.abs(udiff) });
						switch (minIndex) {
						case 0:
							// EɈړƂ
							windowRect.x += rdiff;
							break;
						case 1:
							// ɈړƂ
							windowRect.x += ldiff;
							break;
						case 2:
							// ɈړƂ
							windowRect.y += udiff;
							break;
						}
						if (SWTUtils.withinDisplay(displaySize, windowWidth,
								windowHeight, padding, windowRect.x,
								windowRect.y)) {
							Rectangle oRect = SWTUtils.getIntersectRect(
									windowRect, rects);
							if (oRect == null) {
								return windowRect;
							}
						}
					}
					windowRect.y = currentY;
				}
				currentY -= 16;
				windowRect.y = currentY;

			} while (displaySize.y < currentY);
		}
		return null;
	}

	/**
	 * Ɍċ󔒂T܂B
	 * 
	 * @param padding ]
	 * @param displaySize fBXvCTCY
	 * @param rects ̋`̈
	 * @param initialX XW
	 * @param windowRect zuEBhE̋`̈
	 * @return zu\ȏꍇ͍̍WAzułȂꍇnullB
	 */
	private Point searchBlankToTop(int padding, Rectangle displaySize,
			Rectangle[] rects, final int initialX, Rectangle windowRect) {
		do {
			Rectangle origRect = SWTUtils.getIntersectRect(windowRect, rects);
			if (origRect == null) {
				return new Point(windowRect.x, windowRect.y);
			}
			// ɏdȂĂ镪炷
			if (origRect.x > windowRect.x) {
				windowRect.x = origRect.x - windowRect.width;
			} else {
				windowRect.x = origRect.x + origRect.width;
			}
			if (SWTUtils.withinDisplay(displaySize, windowRect.width,
					windowRect.height, padding, windowRect.x, windowRect.y)) {
				Rectangle hRect = SWTUtils.getIntersectRect(windowRect, rects);
				if (hRect == null) {
					return new Point(windowRect.x, windowRect.y);
				}
			}
			// xW߂
			windowRect.x = initialX;
			// 
			windowRect.y = origRect.y - windowRect.height;
		} while (SWTUtils.withinDisplay(displaySize, windowRect.width,
				windowRect.height, padding, windowRect.x, windowRect.y));
		return null;
	}

	/**
	 * ŏl̃CfbNX擾܂B
	 * 
	 * @param nums l̔z
	 * @return CfbNXBꍇ0܂͍ŏ̒lB
	 */
	private static int minIndex(int[] nums) {
		int minIndex = 0;
		for (int i = 0; i < nums.length; i++) {
			if (nums[minIndex] > nums[i]) {
				minIndex = i;
			}
		}
		return minIndex;
	}

}
