package petaclone.swt;

import java.io.InputStream;

import jp.takayuki.logging.Logger;
import jp.takayuki.swt.util.SWTUtils;
import jp.takayuki.swt.widgets.AnimatedTrayItem;
import jp.takayuki.tools.MessageMap;
import jp.takayuki.tools.Os;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.ToolTip;
import org.eclipse.swt.widgets.Tray;
import org.eclipse.swt.widgets.TrayItem;

import petaclone.EventBroker;
import petaclone.Events;

/**
 * ^XNgC̊Ǘ
 * @author Takayuki Shoji
 */
public class SWTTaskTray {

	/**
	 * bZ[W\[X
	 */
	private static final MessageMap mm = MessageMap.getMessageMap();

	/**
	 * logger
	 */
	private static final Logger logger = Logger.getLogger(SWTTaskTray.class);

	/**
	 * |bvAbvj[ƃo[̂߂Shell
	 */
	private Shell shell;

	/**
	 * ^XNgC
	 */
	private Tray tray;

	/**
	 * Aj[VΉTrayItem
	 */
	private AnimatedTrayItem item;

	/**
	 * ʒmo[
	 */
	private ToolTip toolTip;

	/**
	 * Cxg
	 */
	private EventBroker eventBroker;

	/**
	 * |bvAbvj[
	 */
	private Menu menu;

	/**
	 * ݂̏
	 */
	private int status = 0;

	/**
	 * ʏ̃ACRݒ肳Ă
	 */
	private static final int NORMAL = 1;

	/**
	 * ʒm̃ACRݒ肳Ă
	 */
	private static final int NOTIFY = 2;

	/**
	 * RXgN^
	 * @param eventBroker Cxg
	 * @param display Display
	 * @param shell CEBhEShell(Traỹ|bvAbvj[p)
	 * @param popup ^XNgC̃ReLXgj[
	 * @param notify ʒmACȐꍇtrueAʏACȐꍇfalse
	 */
	public SWTTaskTray(EventBroker eventBroker, Display display, Shell shell,
			Menu popup, boolean notify) {
		this.eventBroker = eventBroker;
		this.shell = shell;
		this.menu = popup;
		this.tray = display.getSystemTray();
		if (tray == null) {
			// VXeTrayT|[gĂȂ
			logger.info("Tray is not supported."); //$NON-NLS-1$
			return;
		}
		this.item = new AnimatedTrayItem(tray, SWT.NONE);

		if (notify) {
			setNotifyImage();
		} else {
			setNormalImage();
		}

		// Xi[̐ݒ
		TrayItem trayItem = this.item.getItem();
		trayItem.setToolTipText(mm.get("BaseMain.appName")); //$NON-NLS-1$

		// ENbN
		trayItem.addListener(SWT.MenuDetect, new Listener() {
			public void handleEvent(Event event) {
				menu.setVisible(true);
			}
		});

		// NbN
		trayItem.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event event) {
				// TODO ƗEBhE[ĥƂAbZ[W\݂̂ɂ
				SWTTaskTray.this.eventBroker.notifyEvent(Events.DisplayWindow,
						Boolean.FALSE);
			}
		});

		// _uNbN
		trayItem.addListener(SWT.DefaultSelection, new Listener() {
			public void handleEvent(Event event) {
				SWTTaskTray.this.eventBroker.notifyEvent(
						Events.OpenBlankMessageWindow, null);
			}
		});
	}

	/**
	 * ʏ̏Ԃɂ܂B
	 */
	public void setNormalImage() {
		if (this.status == NORMAL) {
			return;
		}
		setImage("/icons/tray_normal.png"); //$NON-NLS-1$
		this.status = NORMAL;
	}

	/**
	 * ʒm̏Ԃɂ܂B
	 */
	public void setNotifyImage() {
		if (this.status == NOTIFY) {
			return;
		}
		setImage("/icons/tray_notify.gif"); //$NON-NLS-1$
		this.status = NOTIFY;
	}

	/**
	 * ACRݒ肵܂B
	 * @param icon
	 */
	private void setImage(String icon) {
		if (tray == null) {
			return;
		}
		InputStream is = SWTTaskTray.class.getResourceAsStream(icon);
		if (is == null) {
			logger.warn(icon + " not found."); //$NON-NLS-1$
			return;
		}
		item.setImage(is);
	}

	/**
	 * EBWFbgj܂B
	 */
	public void dispose() {
		if (tray != null)
			tray.dispose();
	}

	/**
	 * TrayItem擾܂B
	 * @return TrayItem
	 */
	public TrayItem getTrayItem() {
		if (item == null) {
			return null;
		}
		return item.getItem();
	}

	/**
	 * o[Ĕj܂B
	 * ̃\bhclearBalloon()płB
	 * 
	 * @return łɔjĂƂfalseB
	 */
	private boolean disposeBalloon() {
		if (toolTip == null || toolTip.isDisposed()) {
			return false;
		}
		toolTip.setVisible(false);
		toolTip.dispose();
		toolTip = null;
		return true;
	}

	/**
	 * o[܂B
	 */
	public void clearBalloon() {

		/*
		 * carbonłToolTipNbNŏ
		 * balloon.setVisible(false)sNPEɂȂB
		 * ŎsNPEɂȂȂB
		 * 
		 * bZ[W\Cxg
		 * ToolTip̃NbNƃV[gJbgL[
		 * LĂAV[gJbgL[̏ꍇɂ
		 * AvP[VŏKv邽߁B
		 */
		if (Os.isMacOSX()) {
			if (toolTip == null)
				return;
			Display.getDefault().asyncExec(new Runnable() {
				public void run() {
					disposeBalloon();
				}
			});
			return;
		}

		/*
		 * ʂɃo[鏈B
		 */
		if (!disposeBalloon()) {
			// łɔjĂB
			return;
		}

		if (!Os.isWindows()) {
			return;
		}

		/*
		 * win32łToolTip#setVisible(false)ĂȂ(3.4M5)B
		 * ̂߁ATrayItemEĕ\ăo[B
		 * ȂAEĕ\Ńo[͎̂ˑB
		 */

		if (System.getProperty("os.name").equalsIgnoreCase("Windows 98")) { //$NON-NLS-1$ //$NON-NLS-2$
			/*
			 * Windows 98(T|[gΏۊO)imagedisposeĂ
			 * IllegalArgumentExceptionɂȂ邱ƂB
			 */
			return;
		}

		final TrayItem item = getTrayItem();
		if (item != null && !item.isDisposed()) {
			item.setVisible(false);

			// Windows XP ŋHɏ܂܂ɂȂ̂Ń^C~Ox点Ă݂
			Display.getDefault().asyncExec(new Runnable() {

				public void run() {
					if (!item.isDisposed()) {
						item.setVisible(true);
					}
				}
			});
		}
	}

	/**
	 * o[\܂B
	 * łɕ\Ăo[͔j܂B
	 * @param title ^Cg
	 * @param message bZ[W
	 * @param displayWindow truêƂASelectionListenerǉDisplayWindowCxg𔭐B
	 */
	public void showBalloon(String title, String message, boolean displayWindow) {

		if (toolTip != null && !toolTip.isDisposed()) {
			toolTip.dispose();
		}

		toolTip = new ToolTip(shell, SWT.BALLOON | SWT.ICON_INFORMATION);
		toolTip.setText(title);
		toolTip.setMessage(message);
		if (displayWindow) {
			toolTip.addSelectionListener(new BalloonSelected(eventBroker));
		}

		TrayItem trayItem = getTrayItem();
		if (trayItem == null) {
			Rectangle rect = SWTUtils.getPointedMonitorClient(Display
					.getDefault());
			toolTip.setLocation(rect.x + 20, rect.y + 20);
			toolTip.setAutoHide(false);
		} else {
			trayItem.setToolTip(toolTip);
		}

		toolTip.setVisible(true);
	}

	/**
	 * o[NbNꂽƂ̏
	 */
	private static class BalloonSelected extends SelectionAdapter {
		/**
		 * EventBroker
		 */
		private EventBroker broker;

		/**
		 * RXgN^
		 * @param broker
		 */
		public BalloonSelected(EventBroker broker) {
			this.broker = broker;
		}

		/**
		 * o[NbNꂽƂ
		 */
		public void widgetSelected(SelectionEvent e) {
			broker.notifyEvent(Events.DisplayWindow, Boolean.TRUE);
		}
	}
}
