package petaclone.swt;

import java.text.DecimalFormat;

import jp.takayuki.tools.MessageMap;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Scale;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

/**
 * xݒ肷_CAO
 * 
 * @author Takayuki Shoji
 */
public class SWTTransparencySettingDialog implements SelectionListener {

	/**
	 * bZ[W\[X
	 */
	private static final MessageMap mm = MessageMap.getMessageMap();

	/**
	 * eEBhEExݒ肷Ώ
	 */
	private final Shell parent;

	/**
	 * _CAOShell
	 */
	private Shell shell;

	/**
	 * XP[
	 */
	private Scale scale;

	/**
	 * lŕ\
	 */
	private Text text;

	/**
	 * ̓x
	 */
	private final int initialAlpha;

	/**
	 * x̕\tH[}b^
	 */
	private DecimalFormat format = new DecimalFormat("#0.0%"); //$NON-NLS-1$

	/**
	 * x̐ݒΏ
	 */
	private final TransparencySetter setter;

	/**
	 * RXgN^
	 * 
	 * @param parent eEBhE
	 * @param setter x̐ݒΏ
	 * @param initialAlpha x̏l(0(transparent)-255(opaque))
	 */
	public SWTTransparencySettingDialog(Shell parent,
			TransparencySetter setter, int initialAlpha) {
		this.parent = parent;
		this.setter = setter;
		this.initialAlpha = initialAlpha;
		createWidgets();
	}

	/**
	 * EBWFbg𐶐܂B
	 */
	private void createWidgets() {
		shell = new Shell(parent, SWT.TITLE | SWT.CLOSE | SWT.APPLICATION_MODAL);
		shell.setText(mm.get("SWTTransparencySettingDialog.title")); //$NON-NLS-1$
		shell.setImage(parent.getImage());
		GridLayout layout = new GridLayout(2, false);
		shell.setLayout(layout);

		scale = new Scale(shell, SWT.HORIZONTAL);
		scale.setMinimum(0);
		scale.setMaximum(204);
		scale.setSelection(255 - initialAlpha);
		scale.setSize(300, 50);
		scale.setPageIncrement(16);
		scale.addSelectionListener(this);

		GridData scaleData = new GridData();
		scaleData.widthHint = 300;
		scaleData.horizontalAlignment = SWT.CENTER;
		scale.setLayoutData(scaleData);

		text = new Text(shell, SWT.RIGHT);
		text.setEditable(false);
		updateAlpha(255 - initialAlpha);

		GridData textData = new GridData();
		textData.widthHint = 50;
		textData.horizontalAlignment = SWT.CENTER;
		text.setLayoutData(textData);

		shell.pack();
		shell.open();

		scale.setFocus();
	}

	/**
	 * x̕\XV܂B
	 * 
	 * @param alpha x
	 */
	private void updateAlpha(int alpha) {
		float f = ((float) alpha / 255);
		String str = format.format(f);
		text.setText(str);
	}

	public void widgetDefaultSelected(SelectionEvent e) {
		//
	}

	public void widgetSelected(SelectionEvent e) {
		int val = scale.getSelection();
		updateAlpha(val);
		setter.setAlpha(255 - val);
	}
}
