package petaclone.swt;

import jp.takayuki.swt.util.SWTUtils;
import jp.takayuki.tools.MessageMap;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.FocusAdapter;
import org.eclipse.swt.events.FocusEvent;
import org.eclipse.swt.events.KeyAdapter;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.TraverseEvent;
import org.eclipse.swt.events.TraverseListener;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.graphics.Region;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Monitor;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;

/**
 * EBhE؂ւ܂B
 * @author Takayuki Shoji
 */
public class SWTWindowSwitcher implements Listener {

	/**
	 * bZ[W\[X
	 */
	private static final MessageMap mm = MessageMap.getMessageMap();

	/**
	 * Shell
	 */
	private Shell shell;

	/**
	 * EBhEXg
	 */
	private Table list;

	/**
	 * EBhEǗ
	 */
	private SWTMessageWindowManager desktopMessages;

	/**
	 * tH[JXEBhEwg̃EBhE
	 */
	private Shell borderShell;

	/**
	 * XtH[JXĂShell
	 */
	private Shell focusedShell;

	/**
	 * CtrlL[^C~OŃEBhEꍇfalse
	 */
	private boolean ignoreKeyUp;

	/**
	 * RXgN^
	 * @param desktopMessages EBhEǗ
	 */
	public SWTWindowSwitcher(SWTMessageWindowManager desktopMessages) {
		this.desktopMessages = desktopMessages;
	}

	/**
	 * Cxg
	 */
	public void handleEvent(Event event) {
		//System.out.println("Event:" + event.keyCode + "," + event.stateMask);
		switch (event.type) {
		case SWT.KeyDown:
			if ((event.stateMask & SWT.MOD1) == 0) {
				return;
			}
			handleKeyDownKeyCode(event);

			break;
		case SWT.KeyUp:
			if (event.keyCode != SWT.MOD1) {
				return;
			}
			if (!ignoreKeyUp)
				closeAndFocus(getSelectedShell());
			break;
		case SWT.Selection:
			// j[̏ꍇ
			handleKeyDownKeyCode(event);
			break;
		default:
			return;
		}
	}

	/**
	 * L[CxgL[R[hɉď܂B
	 * 
	 * @param event Cxg
	 */
	private void handleKeyDownKeyCode(Event event) {
		boolean reverse = false;
		switch (event.keyCode) {
		case SWT.F6:
			if (SWTUtils.isDialogShellOpened()) {
				return;
			}
			reverse = (event.stateMask & SWT.MOD2) != 0;
			rotateWindow(reverse);
			break;

		case SWT.PAGE_UP:
			reverse = true;

		case SWT.PAGE_DOWN:
			if (SWTUtils.isDialogShellOpened()) {
				return;
			}
			switchWindow(reverse);
			break;

		default:
			return;
		}
	}

	/**
	 * ܂͑ÕEBhEɃtH[JX܂B
	 * 
	 * @param reverse t̏ꍇtrueB
	 */
	private void switchWindow(boolean reverse) {

		if (shell != null) {
			// lotateWindowsswitchWindowsȂB
			return;
		}

		Display display = Display.getDefault();
		this.focusedShell = display.getActiveShell();

		Shell[] shells = SWTUtils.getVisibleShells(shell, true, false);
		int current = 0;
		for (int i = 0; i < shells.length; i++) {
			if (this.focusedShell == shells[i]) {
				current = i;
			}
		}
		if (reverse) {
			current = current - 1 + shells.length;
		} else {
			current++;
		}
		current = current % shells.length;

		focus(shells[current]);
	}

	/**
	 * EBhẼXg񂵂܂B
	 * @param reverse tɏ񂷂Ƃtrue
	 */
	private void rotateWindow(boolean reverse) {
		if (shell == null) {
			createWidget();
			showBorderShell(list.getSelectionIndex());
			return;
		}
		// Xg̗̎vf
		int index = list.getSelectionIndex();
		int count = list.getItemCount();
		if (reverse) {
			if (index <= 0) {
				index = count - 1;
			} else {
				index--;
			}
		} else {
			index++;
			index %= count;
		}
		list.setSelection(index);
		list.showSelection();
		showBorderShell(index);
	}

	/**
	 * EBhËʒu܂B
	 * FIXME borderShell̏ʉ
	 * @param index I𒆂̃CfbNX
	 */
	private void showBorderShell(int index) {
		if (list.getItemCount() <= index) {
			return;
		}
		borderShell.setVisible(false);

		TableItem item = list.getItem(index);
		Shell sh = (Shell) item.getData();
		Rectangle shRect = sh.getBounds();

		// g̑
		final int w = 5;

		Rectangle outer = new Rectangle(0, 0, shRect.width + w + w,
				shRect.height + w + w);
		Rectangle inner = new Rectangle(w, w, shRect.width, shRect.height);

		Region reg = new Region();
		reg.add(outer);
		reg.subtract(inner);

		borderShell.setRegion(reg);
		borderShell.setSize(outer.width, outer.height);
		borderShell.setLocation(shRect.x - w, shRect.y - w);
		borderShell.setVisible(true);
	}

	/**
	 * EBhE\܂B
	 */
	private void createWidget() {
		ignoreKeyUp = false;

		Display display = Display.getDefault();
		shell = new Shell(display, SWT.NO_TRIM | SWT.ON_TOP);
		shell.setLayout(new FillLayout());

		list = new Table(shell, SWT.SINGLE | SWT.FULL_SELECTION);
		list.setLinesVisible(true);
		list.setHeaderVisible(true);

		TableColumn column = new TableColumn(list, SWT.LEFT);
		column.setText(mm.get("SWTWindowSwitcher.windows")); //$NON-NLS-1$
		column.setResizable(false);

		this.focusedShell = display.getActiveShell();
		addItems();

		list.addFocusListener(new FocusAdapter() {
			public void focusLost(FocusEvent e) {
				closeAndFocus(focusedShell);
			}
		});

		list.addMouseListener(new MouseAdapter() {
			public void mouseDown(MouseEvent e) {
				// mouseDown͑̃Cxg܂Œx
				ignoreKeyUp = true;
			}
		});
		// L[AEnter
		list.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				ignoreKeyUp = true;
				showBorderShell(list.getSelectionIndex());
			}

			public void widgetDefaultSelected(SelectionEvent e) {
				closeAndFocus(getSelectedShell());
			}
		});
		list.addKeyListener(new KeyAdapter() {
			public void keyPressed(KeyEvent e) {
				if (e.keyCode == SWT.ESC) {
					closeAndFocus(focusedShell);
				}
			}
		});
		list.addTraverseListener(new TraverseListener() {
			/**
			 * ׂĂTraverseCxg}
			 */
			public void keyTraversed(TraverseEvent e) {
				e.doit = false;
			}
		});
		list.addListener(SWT.KeyDown, this);
		list.addListener(SWT.KeyUp, this);

		column.pack();
		list.pack();
		int width = list.getClientArea().width;
		column.setWidth(width);
		shell.pack();

		Monitor[] monitors = display.getMonitors();
		Monitor monitor = SWTUtils.getPointedMonitor(display, monitors);

		limitHeight(shell, monitor.getClientArea());
		SWTUtils.moveToCenter(shell, monitor);

		list.showSelection();

		shell.open();
		shell.setActive();

		// g
		borderShell = new Shell(display, SWT.NO_TRIM | SWT.ON_TOP);
		borderShell.setBackground(display.getSystemColor(SWT.COLOR_RED));
		borderShell.setVisible(false);
	}

	/**
	 * EBhẼXgACeƂĒǉ܂B
	 */
	private void addItems() {
		Shell[] shells = SWTUtils.getVisibleShells(shell, true, false);
		for (int i = 0; i < shells.length; i++) {

			String text;
			// bZ[W擾
			SWTMessageWindow mw = desktopMessages.get(shells[i]);
			if (mw != null) {
				mw.synchMessage();
				text = mw.getWindowDescription();
			} else {
				text = shells[i].getText();
				if (text == null || text.length() == 0) {
					text = mm.get("SWTWindowSwitcher.notitle"); //$NON-NLS-1$
				}
			}

			TableItem item = new TableItem(list, SWT.NONE);
			item.setText(0, text);
			item.setImage(0, getShellImage(shells[i]));
			item.setData(shells[i]);

			if (shells[i] == focusedShell) {
				list.setSelection(i);
			}
		}
	}

	/**
	 * EBhẼACR擾܂B
	 * 16sNZ̃ACRD悵Ď擾܂B
	 * @param sh 擾ΏۂShell
	 * @return 擾łȂꍇnullB
	 */
	private Image getShellImage(Shell sh) {
		Image img;
		Image[] imgs = sh.getImages();
		if (imgs != null && imgs.length > 0) {
			img = imgs[0];
			for (int j = 0; j < imgs.length; j++) {
				Rectangle rect = imgs[j].getBounds();
				if (rect.width == 16) {
					img = imgs[j];
					break;
				}
			}
		} else {
			img = sh.getImage();
		}
		return img;
	}

	/**
	 * EBhE̍fBXvC̃NCAg̈̍ɐ܂B
	 * @param sh EBhE
	 * @param dRect ΏۃfBXvC̃NCAg̈
	 */
	private void limitHeight(Shell sh, Rectangle dRect) {
		Rectangle sRect = sh.getBounds();

		if (sRect.height > dRect.height) {
			sRect.height = dRect.height;
		}

		int itemHeight = list.getItemHeight();
		int headerHeight = list.getHeaderHeight();

		int visibleItemCount = (sRect.height - headerHeight) / itemHeight;
		sRect.height = headerHeight + visibleItemCount * itemHeight;

		sh.setBounds(sRect);
	}

	/**
	 * e[uőIꂽڂɑΉShell擾܂B
	 * @return ShellBnull̏ꍇ
	 */
	private Shell getSelectedShell() {
		if (list == null) {
			return null;
		}
		final int selection = list.getSelectionIndex();
		TableItem item = list.getItem(selection);
		Shell sh = (Shell) item.getData();
		if (sh.isDisposed()) {
			return null;
		}
		return sh;
	}

	/**
	 * ؂ւEBhE܂B
	 * @param sh tH[JXShell
	 */
	private void closeAndFocus(Shell sh) {
		focusedShell = null;
		if (this.shell == null) {
			return;
		}

		/*
		 * mouseDownx̂ŁA
		 * ̃Cxg̏҂ăEBhEB
		 */
		Display.getDefault().asyncExec(new Runnable() {
			public void run() {
				if (shell != null) {
					shell.close();
					shell = null;
					list = null;
				}

				if (borderShell != null) {
					borderShell.close();
					borderShell = null;
				}
			}
		});

		/*
		 * EBhEXgJ܂܃}EXŒ
		 * tH[JXEBhENbNꍇ
		 * ̃tH[JXDȂ悤ɂŃtH[JXB
		 * (asyncExecɓȂ)
		 */
		focus(sh);
	}

	/**
	 * w肵EBhEɃtH[JX܂B
	 * 
	 * @param sh Ώۂ̃EBhE
	 */
	private void focus(Shell sh) {
		/*
		 * gtkłasyncExecɂĂ݂ĂʂB
		 */
		if (sh != null && !sh.isDisposed()) {
			sh.setActive();
		}
	}
}
